HighlightFrame = class(Turbine.UI.Window)
function HighlightFrame:Constructor(parent)
    Turbine.UI.Window.Constructor(self)
    self:SetPosition(x, y)
    --self:SetSize(self.width, self.height)
    --self:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self:SetVisible(false)
    self:SetMouseVisible(false)
    --self:SetBackground(IconAlerts) --0x41000912 ice --0x411AE441 blood --0x41142E03  0x4114B070
    --self:SetStretchMode(1)
    self:SetSize(42, 41)
    self:SetOpacity(1)
    self:SetParent(parent)

    self.backgroundViewBox = Turbine.UI.Window()
    self.backgroundViewBox:SetParent(self)
    self.backgroundViewBox:SetSize(42, 41)
    self.backgroundViewBox:SetSize(65, 65)
    --self.backgroundViewBox:SetPosition(100 - 10 + 7, 100 - 10 + 7)
    self.backgroundViewBox:SetPosition(- 10, - 10 )
    self.backgroundViewBox:SetVisible(true)
    self.backgroundViewBox:SetMouseVisible(false)

    self.backgroundBox = Turbine.UI.Control()
    self.backgroundBox:SetParent(self.backgroundViewBox)
    self.backgroundBox:SetSize(42, 41)
    --self.backgroundBox:SetSize(256 - 22, 256 - 22)
    self.backgroundBox:SetSize(256 - 22, 256 - 22)
    self.backgroundBox:SetPosition(-12 + 10, -81 + 10)
    self.backgroundBox:SetBlendMode(Turbine.UI.BlendMode.Normal)
    self.backgroundBox:SetBackground(IconAlertBackground)
    self.backgroundBox:SetMouseVisible(false)

    self.viewBox = Turbine.UI.Control()
    self.viewBox:SetParent(self)
    self.viewBox:SetSize(42, 41)
    --self.viewBox:SetSize(256 - 22, 256 - 22)
    --self.viewBox:SetPosition(100, 100)
    self.viewBox:SetPosition(1, 1)
    self.viewBox:SetMouseVisible(false)
    --self.viewBox:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1))

    self.movingTexture = Turbine.UI.Control()
    self.movingTexture:SetParent(self.viewBox)
    self.movingTexture:SetBackground(IconAlerts)
    self.movingTexture:SetBlendMode(Turbine.UI.BlendMode.Normal)
    self.movingTexture:SetSize(256 - 20, 256 - 22)
    self.movingTexture:SetPosition(-2, -2)
    self.movingTexture:SetVisible(true)
    self.movingTexture:SetMouseVisible(false)

    --self:SetStretchMode(1)
    self.viewBox:SetStretchMode(1)
    --self.viewBox:SetSize(32, 32)
    self.viewBox:SetSize(30, 30)
    --self.viewBox:SetSize(46, 46)
    self.backgroundViewBox:SetStretchMode(1)
    self.backgroundViewBox:SetSize(54, 54)
    --self.backgroundViewBox:SetSize(40, 40)



    self.lastUpdate = Turbine.Engine.GetGameTime()
    self.tick = 0
    self.Update = function()
        if Turbine.Engine.GetGameTime() - self.lastUpdate < 0.02 then return end
        self.lastUpdate = Turbine.Engine.GetGameTime()
        self.tick = (self.tick + 1) % 23
        self.movingTexture:SetPosition(-(self.tick % 5) * 48 - 2, -(math.floor(self.tick / 5)) * 48 -2)
    end
end

function HighlightFrame:Toggle(value)
    self:SetWantsUpdates(value)
    self:SetVisible(value)
end


HighlightFrame2 = class(Turbine.UI.Window)
function HighlightFrame2:Constructor(parent, scale)
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetSize(32, 32)
    self:SetOpacity(1)
    self:SetParent(parent)

    self.background = 0x41007F0E

    self.box = Turbine.UI.Control()
    self.box:SetParent(self)
    self.box:SetSize(32, 32)
    self.box:SetBlendMode(Turbine.UI.BlendMode.Normal)
    self.box:SetBackground(self.background)
    self.box:SetMouseVisible(false)
    self.box:SetVisible(true)

    self.scale = scale

    if not(self.scale) then self.scale = 1 end

    self:SetStretchMode(1)
    self:SetSize(32 * self.scale, 32 * self.scale)

    self.lastUpdate = Turbine.Engine.GetGameTime()

    self.Update = function()
        if Turbine.Engine.GetGameTime() - self.lastUpdate < 0.03 then return end

        self.box:SetBackground(self.background)

        self.background = self.background + 1

        if self.background > 0x41007F0E + 7 then self.background = 0x41007F0E end

        self.lastUpdate = Turbine.Engine.GetGameTime()
    end
end

function HighlightFrame2:Toggle(value)
    self:SetWantsUpdates(value)
    self:SetVisible(value)
end