-- Normal timer
Counter = class(Turbine.UI.Control)
function Counter:Constructor(parent, width, height, elements, duration, message, font, colour1, colour2, colour3, colour4, colour5, icon)

    self.Scale = Settings.SkillTimerScale

    local oldHeight = height
    height = height * self.Scale

    local heightDelta = oldHeight - height
    --ChatOutput(message)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width, height)
    self:SetPosition(0, elements * height)
    self:SetOpacity(1)
    self:SetVisible(true)
    self:SetMouseVisible(false)

    local offset = 0

    if icon ~= nil then
        offset = height
    end

    local opacityWindow = Turbine.UI.Window()
    opacityWindow:SetParent(self)
    opacityWindow:SetVisible(true)
    opacityWindow:SetPosition(0, 0)
    opacityWindow:SetSize(width, height)
    opacityWindow:SetOpacity(0.4)
    opacityWindow:SetMouseVisible(false)

    local outLine = Turbine.UI.Label()
    outLine:SetParent(opacityWindow)
    outLine:SetSize(width, height)
    outLine:SetMouseVisible(false)
    outLine:SetVisible(true)
    outLine:SetBackColor(Turbine.UI.Color(0,0,0))
    outLine:SetMouseVisible(false)
    
    local backLabel = Turbine.UI.Label()
    backLabel:SetParent(opacityWindow)
    backLabel:SetSize(width - 2 - offset, height - 2)
    backLabel:SetPosition(1 + offset,1)
    backLabel:SetMouseVisible(false)
    backLabel:SetVisible(true)
    backLabel:SetMouseVisible(false)

    local frontLabel = Turbine.UI.Label()
    frontLabel:SetParent(opacityWindow)
    frontLabel:SetPosition(1 + offset,1)
    frontLabel:SetSize(width - 2 - offset, height - 2)
    frontLabel:SetBackColor(colour5)
    frontLabel:SetMouseVisible(false)

    local opacityWindow2 = Turbine.UI.Window()
    opacityWindow2:SetParent(self)
    opacityWindow2:SetVisible(true)
    opacityWindow2:SetPosition(0, 0)
    opacityWindow2:SetSize(width, height)
    --self.opacityWindow:SetOpacity(0.5)
    opacityWindow2:SetMouseVisible(false)

    if icon ~= nil then
        local iconLabel = Turbine.UI.Label()
        iconLabel:SetParent(opacityWindow2)
        iconLabel:SetPosition(1,1)
        iconLabel:SetSize(32, 32)
        iconLabel:SetStretchMode(1)
        iconLabel:SetMouseVisible(false)
        iconLabel:SetVisible(true)
        iconLabel:SetBackground(icon)
        iconLabel:SetSize(height, height)
        iconLabel:SetMouseVisible(false)
    end

    local durationVisible = true
    if duration > 99999 then
        durationVisible = false
    end

    local textLabel = Turbine.UI.Label()
    textLabel:SetParent(opacityWindow2)
    textLabel:SetPosition(1 + offset + 5, 1)
    textLabel:SetSize(width - 65, height)
    textLabel:SetMouseVisible(false)
    textLabel:SetVisible(true)
    textLabel:SetMultiline(false)
    textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    textLabel:SetFont(font)
    textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    textLabel:SetMouseVisible(false)
    textLabel:SetText(message)
    textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    textLabel:SetOutlineColor(OutlineColor)
    textLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
    textLabel:SetMouseVisible(false)

    self.durationLabel = Turbine.UI.Label()
    self.durationLabel:SetParent(opacityWindow2)
    self.durationLabel:SetPosition(width - 25, 1)
    self.durationLabel:SetSize(25, height)
    self.durationLabel:SetFont(font)
    self.durationLabel:SetVisible(durationVisible)
    self.durationLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.durationLabel:SetMouseVisible(false)
    self.durationLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.durationLabel:SetOutlineColor(OutlineColor)
    self.durationLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.durationLabel:SetMultiline(false)
    self.durationLabel:SetText(duration)
    self.durationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.durationLabel:SetMouseVisible(false)

    local s = message
    self.number = duration
    local maxNumber = duration

    self.Destroy = function()
        self:SetVisible(false)
        offset = nil
        opacityWindow = nil
        outLine = nil
        backLabel = nil
        frontLabel = nil
        opacityWindow2 = nil
        iconLabel = nil
        durationVisible = nil
        textLabel = nil
        self.durationLabel = nil

        self:SetParent(nil)
        self = nil
    end

    self.UpdateColour = function()
        if self.number == 0 then
            backLabel:SetBackColor(colour1)
        elseif self.number <= 5 then
            backLabel:SetBackColor(colour2)
        elseif self.number <= 10 then
            --self.backLabel:SetBackColor(colour3)
        else
            backLabel:SetBackColor(colour4)
        end
        frontLabel:SetSize(self.number / duration * (width - 2 - offset), (height - 2))
    end

    self:UpdateColour()

    self.GetRemainingTime = function()
        return(self.number)
    end

    self.GetDuration = function()
        return(maxNumber)
    end
    --ChatOutput(message .. elements)
end

function Counter:UpdateText(delta)
    self.number = self.number - delta
    if self.number <= 5 then
        self.durationLabel:SetText(Round(self.number, 1))
    else 
        self.durationLabel:SetText(math.floor(self.number))
    end
    self:UpdateColour()
end

function Counter:ChangeDuration(newNumber)
    --ChatOutput(newNumber)
    self.number = newNumber
end

-- Timer based on effect display
Counter2 = class(Turbine.UI.Control)
function Counter2:Constructor(parent, width, height, elements, duration, message, font, colour1, colour2, colour3, colour4, colour5, icon, effect, options, buffWindow, reset)

    --ChatOutput(effect:GetName())
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width, height)
    self:SetPosition(0, elements * height)
    self:SetOpacity(1)
    self:SetVisible(true)
    self:SetMouseVisible(false)

    local offset = 0
    local effectName = nil

    if effect ~= nil then
        offset = height
        effectName = effect:GetName()
    end

    local opacityWindow = Turbine.UI.Window()
    opacityWindow:SetParent(self)
    opacityWindow:SetVisible(true)
    opacityWindow:SetPosition(0, 0)
    opacityWindow:SetMouseVisible(false)
    opacityWindow:SetSize(width, height)
    opacityWindow:SetOpacity(0.4)

    local outLine = Turbine.UI.Label()
    outLine:SetParent(opacityWindow)
    outLine:SetSize(width, height)
    outLine:SetMouseVisible(false)
    outLine:SetVisible(true)
    outLine:SetBackColor(Turbine.UI.Color(0,0,0))
    
    local backLabel = Turbine.UI.Label()
    backLabel:SetParent(opacityWindow)
    backLabel:SetSize(width - 2 - offset, height - 2)
    backLabel:SetPosition(1 + offset,1)
    backLabel:SetMouseVisible(false)
    backLabel:SetVisible(true)

    local frontLabel = Turbine.UI.Label()
    frontLabel:SetParent(opacityWindow)
    frontLabel:SetPosition(1 + offset,1)
    frontLabel:SetSize(width - 2 - offset, height - 2)
    frontLabel:SetBackColor(colour5)
    frontLabel:SetMouseVisible(false)

    local opacityWindow2 = Turbine.UI.Window()
    opacityWindow2:SetParent(self)
    opacityWindow2:SetVisible(true)
    opacityWindow2:SetPosition(0, 0)
    opacityWindow2:SetSize(width, height)
    opacityWindow2:SetMouseVisible(false)
    --self.opacityWindow:SetOpacity(0.5)

    if effect ~= nil then
        local iconLabel = Turbine.UI.Lotro.EffectDisplay()
        iconLabel:SetEffect(effect)
        iconLabel:SetParent(opacityWindow2)
        --iconLabel:SetPosition(1,1)
        iconLabel:SetSize(height, height)
        iconLabel:SetMouseVisible(false)
        iconLabel:SetVisible(true)
        --self.iconLabel:SetBackground(icon)
    end

    local durationVisible = true
    if duration > 99999 then
        durationVisible = false
        backLabel:SetBackColor(colour5)
    end

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(opacityWindow2)
    self.textLabel:SetPosition(1 + offset + 5, 1)
    self.textLabel:SetSize(width - 45, height)
    self.textLabel:SetVisible(true)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.textLabel:SetFont(font)
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetText(message)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetOutlineColor(OutlineColor)
    self.textLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.textLabel:SetMultiline(false)

    self.durationLabel = Turbine.UI.Label()
    self.durationLabel:SetParent(opacityWindow2)
    self.durationLabel:SetPosition(width - 28, 1)
    self.durationLabel:SetSize(25, 20)
    self.durationLabel:SetFont(font)
    self.durationLabel:SetVisible(durationVisible)
    self.durationLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.durationLabel:SetMouseVisible(false)
    self.durationLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.durationLabel:SetOutlineColor(OutlineColor)
    self.durationLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.durationLabel:SetMultiline(false)
    self.durationLabel:SetText(duration)
    self.durationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    --self.durationLabel:SetBackColor(OutlineColor)
    --self.self.durationLabel:
    

    local s = message
    self.number = duration
    if effect ~= nil then
        if reset == 1 then
            self.number = effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime())
        elseif reset == 2 then
            self.number = duration - (Turbine.Engine.GetGameTime() - effect:GetStartTime())
        end
    end
    local maxNumber = duration
    local colourEvent = 5
    self.oldnumber = duration
    if colour2 == nil then colourEvent = -1 end

    self.Destroy = function()
        self:SetVisible(false)
        offset = nil
        opacityWindow = nil
        outLine = nil
        backLabel = nil
        frontLabel = nil
        opacityWindow2 = nil
        iconLabel = nil
        durationVisible = nil
        self.textLabel = nil
        self.durationLabel = nil

        self:SetParent(nil)
        self = nil
    end

    self.UpdateColour = function()
        if self.number <= colourEvent then
            if self.number == 0 then
                backLabel:SetBackColor(colour1)
                colourEvent = -5
            elseif self.number <= 5 then
                backLabel:SetBackColor(colour2)
                colourEvent = 0
            elseif self.number <= 10 then
                --self.backLabel:SetBackColor(colour3)
            else
                backLabel:SetBackColor(colour4)
            end
        end
        frontLabel:SetSize(self.number / duration * (width - 2 - offset), (height - 2))
    end

    self:UpdateColour()

    self.GetRemainingTime = function()
        return(self.numbe)
    end

    self.GetDuration = function()
        return(maxNumber)
    end

    --ChatOutput(message .. elements)

    if options ~= nil then
        local clickWindow = Turbine.UI.Window()
        clickWindow:SetParent(self)
        clickWindow:SetVisible(true)
        clickWindow:SetPosition(0, 0)
        clickWindow:SetMouseVisible(true)
        clickWindow:SetSize(width - height, height)
        clickWindow:SetPosition(height, 0)

        local menu = Turbine.UI.ContextMenu()
        local menuItems = menu:GetItems()

        local item = Turbine.UI.MenuItem( "Add to Filter" )
        menuItems:Add(item)
        item.Click = function(sender, args)
            --ChatOutput(options)
            --ChatOutput(effectName)
            BuffWindows[options].List[effectName] = true
            buffWindow:Reset()
        end

        clickWindow.MouseClick = function()
            menu:ShowMenu()
        end
    end

    effect = nil
end

function Counter2:ChangeDuration(newNumber)
    --ChatOutput(newNumber)
    self.number = newNumber
    self.oldnumber = newNumber
end

function Counter2:UpdateText(delta)
    if self.number > 99999 then return end
    self.number = self.number - delta
    if self.oldnumber - self.number > 0.05 then
        if self.number <= 5 then
            self.durationLabel:SetText(Round(self.number, 1))
        else 
            self.durationLabel:SetText(math.floor(self.number))
        end
        self:UpdateColour()
        self.oldnumber = self.number
    end
end

function Counter2:ChangeName(newName)
    self.textLabel:SetText(newName)
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

-- Colour scheme [1] outline [2] background [3] bar colour [4] text colour [5] outline colour [6] warning colour

EffectTimer = class(Turbine.UI.Control)
function EffectTimer:Constructor(parent, width, height, effect, message, font, colourScheme, showDuration, optionsWindow, optionalDuration, optionalIcon, optionalTarget, hide)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetVisible(true)
    self:SetMouseVisible(false)
    self:SetSize(width, height)

    self.backgroundColour = colourScheme[2]
    self.warningColour = colourScheme[6]
    if not(self.backgroundTexture) then
        self.maxTimerWidth = width - height - 2
    end
    self.timerHeight = height
    self.showDuration = not(showDuration)
    self.hide = hide
    if self.hide == nil then self.hide = false end

    self.sparkOffset = 32 - 20 / 32 * 32 - 3
    self.height = height
    
    self.backgroundFrontTexture = colourScheme[7]
    self.backgroundBackTexture = colourScheme[8]
    self.backgroundFrontOpacity = colourScheme[9]
    self.backgroundBackOpacity = colourScheme[10]

    -- Background UI
    self.opacityWindow = Turbine.UI.Window()
    self.opacityWindow:SetParent(self)
    self.opacityWindow:SetVisible(true)
    self.opacityWindow:SetMouseVisible(false)
    self.opacityWindow:SetOpacity(self.backgroundBackOpacity)
    if self.backgroundBackTexture then
        self.backgroundBackTexture = bars[self.backgroundBackTexture]
        self.opacityWindow:SetSize(self.backgroundBackTexture[2], self.backgroundBackTexture[3])
        self.opacityWindow:SetBackground( self.backgroundBackTexture[1])
        self.opacityWindow:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply)
        self.opacityWindow:SetStretchMode(1)
        self.opacityWindow:SetSize(width, height)

    else
        self.opacityWindow:SetSize(width, height)
    end
    self.opacityWindow:SetBackColor(colourScheme[1])

    self.spark = Turbine.UI.Window()
    self.spark:SetParent(self)
    self.spark:SetVisible(true)
    self.spark:SetPosition(0, 0)
    self.spark:SetOpacity(0.4)
    self.spark:SetSize(32, 32)
    self.spark:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply)
    self.spark:SetBackground(BarSpark)
    self.spark:SetStretchMode(1)
    self.spark:SetSize(height, height)
    self.spark:SetMouseVisible(false)
    self.spark:SetPosition(width + (32 / height) * 16, 0)

    self.timerBar = Turbine.UI.Window()
    self.timerBar:SetParent(self)
    self.timerBar:SetVisible(true)
    self.timerBar:SetPosition(height,1)
    self.timerBar:SetOpacity(self.backgroundFrontOpacity)
    if self.backgroundFrontTexture then
        self.backgroundFrontTexture = bars[self.backgroundFrontTexture]
        self.timerBar:SetSize(self.backgroundFrontTexture[2], self.backgroundFrontTexture[3])
        self.timerBar:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply)
        self.timerBar:SetBackground(self.backgroundFrontTexture[1])
        self.timerBar:SetStretchMode(1)
        self.timerBar:SetSize(width, height - 2 - 2)
        --self.timerBar:SetBackColor(colourScheme[3])
    else
        self.timerBar:SetSize(width, height - 2 - 2)
    end
    self.timerBar:SetBackColor(colourScheme[3])
    self.timerBar:SetMouseVisible(false)


    -- Text UI
    self.textWindow = Turbine.UI.Window()
    self.textWindow:SetParent(self)
    self.textWindow:SetVisible(true)
    self.textWindow:SetPosition(0, 0)
    self.textWindow:SetSize(width - 2, height)
    self.textWindow:SetMouseVisible(false)

    if optionalIcon then
        self.effectIcon = Turbine.UI.Label()
        self.effectIcon:SetParent(self.textWindow)
        self.effectIcon:SetBackground(optionalIcon)
        self.effectIcon:SetSize(32, 32)
        self.effectIcon:SetStretchMode(1)
        self.effectIcon:SetSize(height, height)
        self.effectIcon:SetMouseVisible(false)
        self.effectIcon:SetVisible(true)
    elseif effect then
        self.effectIcon = Turbine.UI.Lotro.EffectDisplay()
        self.effectIcon:SetParent(self.textWindow)
        self.effectIcon:SetEffect(effect)
        self.effectIcon:SetSize(32, 32)
        self.effectIcon:SetStretchMode(1)
        self.effectIcon:SetSize(height, height)
        self.effectIcon:SetMouseVisible(false)
        self.effectIcon:SetVisible(true)
    end

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self.textWindow)
    self.textLabel:SetPosition(2 + height, 0)
    self.textLabel:SetSize(width - height - height - 10, height)
    self.textLabel:SetVisible(true)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetForeColor(colourScheme[4])
    self.textLabel:SetOutlineColor(colourScheme[5])
    self.textLabel:SetFont(font)
    self.textLabel:SetMultiline(false)
    self.textLabel:SetText(message)

    self.durationLabel = Turbine.UI.Label()
    self.durationLabel:SetParent(self.textWindow)
    self.durationLabel:SetPosition(width - height - 15, 0)
    self.durationLabel:SetSize(height + 10, height)
    self.durationLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.durationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    self.durationLabel:SetMouseVisible(false)
    self.durationLabel:SetForeColor(colourScheme[4])
    self.durationLabel:SetOutlineColor(colourScheme[5])
    --self.durationLabel:SetFont(font)    
    self.durationLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)    
    self.durationLabel:SetMultiline(false)
    
    if optionsWindow then
        self.clickWindow = Turbine.UI.Window()
        self.clickWindow:SetParent(self)
        self.clickWindow:SetVisible(true)
        self.clickWindow:SetPosition(0, 0)
        self.clickWindow:SetMouseVisible(true)
        self.clickWindow:SetSize(width - height, height)
        self.clickWindow:SetPosition(height, 0)

        self.menu = Turbine.UI.ContextMenu()
        self.menuItems = self.menu:GetItems()

        local item = Turbine.UI.MenuItem( "Add to Filter" )
        self.menuItems:Add(item)
        item.Click = function(sender, args)
            BuffWindows[optionsWindow].List[effect:GetName()] = true
            parent:GetParent():Reset()
        end

        self.clickWindow.MouseClick = function()
            self.menu:ShowMenu()
        end
    elseif optionalTarget then
        self.clickWindow = Turbine.UI.Lotro.EntityControl()
        self.clickWindow:SetParent(self)
        self.clickWindow:SetVisible(true)
        self.clickWindow:SetMouseVisible(true)
        self.clickWindow:SetSize(width - height, height)
        self.clickWindow:SetPosition(height, 0)
        self.clickWindow:SetEntity(optionalTarget)
    end

    if optionalDuration then
        self.maxDuration = optionalDuration
        self.number = optionalDuration
        self.permanent = false
        self:UpdateColour()
    else
        self.maxDuration = effect:GetDuration()

        if self.maxDuration > 99999 then 
            self.permanent = true 
            self.number = 0
            self.timerBar:SetSize(self.maxTimerWidth + 2, self.timerHeight - 2)
            self.spark:SetVisible(false)
        else
            self.number = effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime())
            self:UpdateColour()
        end
    end
end

function EffectTimer:Destroy()
    self.backgroundColour = nil
    self.warningColour = nil
    self.maxTimerWidth = nil
    self.showDuration = nil
    self.opacityWindow = nil
    self.background = nil
    self.timerBar = nil
    self.textWindow = nil
    self.effectIcon = nil
    self.textLabel = nil
    self.durationLabel = nil
    self.clickWindow = nil
    self.menu = nil
    self.menuItems = nil
    self.maxDuration = nil
    self.number = nil
    self.permanent = nil
    self.maxDuration = nil

    self:SetVisible(false)
    self:SetParent(nil)
end

function EffectTimer:Unload()
    self:Destroy()
end

function EffectTimer:GetRemainingTime()
    return(self.number)
end

function EffectTimer:GetDuration()
    return(self.maxDuration)
end

function EffectTimer:UpdateColour()
    if self.number < 7 then
        local timerLeft = (7 - self.number) / 7
        self.opacityWindow:SetBackColor(Turbine.UI.Color(
            self.backgroundColour.A,
            math.abs(self.warningColour.R - self.backgroundColour.R) * timerLeft, 
            math.abs(self.warningColour.G - self.backgroundColour.G) * timerLeft, 
            math.abs(self.warningColour.B - self.backgroundColour.B) * timerLeft))
    end

    self.timerBar:SetSize(self.number / self.maxDuration * self.maxTimerWidth, self.timerHeight - 2)
    self.spark:SetPosition(self.number / self.maxDuration * self.maxTimerWidth + (self.height / 32 * 16), 0)
    self.spark:SetOpacity(math.abs(math.sin(self.number) * 0.55) + 0.3)
end

function EffectTimer:SetTimer(duration, maxDuration)
    self.number = duration
    self.maxDuration = maxDuration
    self.durationLabel:SetVisible(true)
    self:SetVisible(true)
    self:UpdateColour()
    if duration > 7 then self.opacityWindow:SetBackColor(self.backgroundColour) end
end

function EffectTimer:ChangeDuration(newNumber)
    self.number = newNumber
    self.durationLabel:SetVisible(true)
    self:SetVisible(true)
    self:UpdateColour()
    if newNumber > 7 then self.opacityWindow:SetBackColor(self.backgroundColour) end
end

function EffectTimer:UpdateText(delta)
    if self.showDuration then return end
    if self.permanent then
        self.number = self.number + delta
        self.durationLabel:SetText(math.floor(self.number))
    else
        self.number = self.number - delta

        if self.number <= 5 then
            self.durationLabel:SetText(self:Round(self.number, 1))
        else
            self.durationLabel:SetText(math.floor(self.number))
        end
        self:UpdateColour()
        if self.number < 0 then
            self.durationLabel:SetVisible(false)
            if self.hide then self:SetVisible(false) end
            return true
        end
    end
end

function EffectTimer:HideText(value)
    self.durationLabel:SetVisible(value)
end

function EffectTimer:Round(num, rounding)
    local mult = 10^(rounding or 0)
    local number = math.floor(num * mult + 0.5) / mult
    if (number % 1) == 0 and rounding ~= 0 then
        return tostring(number .. ".0")
    else
        return number
    end
end

function EffectTimer:ChangeName(newName)
    self.textLabel:SetText(newName)
end

function EffectTimer:ChangeFrontOpacity(opacity)
    self.timerBar:SetOpacity(opacity)
end

function EffectTimer:ChangeBackOpacity(opacity)
    self.opacityWindow:SetOpacity(opacity)
end

function EffectTimer:ChangeFrontTexture(texture)
    if texture == nil then 
        self.timerBar:SetBackColorBlendMode(nil)
        self.timerBar:SetBackground(nil)
    else
            
        local width, height = self:GetSize()
        self.backgroundTexture = bars[texture]
        self.timerBar:SetStretchMode(nil)
        self.timerBar:SetSize(self.backgroundTexture[2], self.backgroundTexture[3])
        self.timerBar:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply)
        self.timerBar:SetBackground(self.backgroundTexture[1])
        self.timerBar:SetStretchMode(1)
        self.timerBar:SetSize(width, height - 2 - 2)
    end
end

function EffectTimer:ChangeBackTexture(texture)
    if texture == nil then 
        self.opacityWindow:SetBackColorBlendMode(nil)
        self.opacityWindow:SetBackground(nil)
    else
        local width, height = self:GetSize()
        self.backgroundTexture = bars[texture]
        self.opacityWindow:SetStretchMode(nil)
        self.opacityWindow:SetSize(self.backgroundTexture[2], self.backgroundTexture[3])
        self.opacityWindow:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply)
        self.opacityWindow:SetBackground(self.backgroundTexture[1])
        self.opacityWindow:SetStretchMode(1)
        self.opacityWindow:SetSize(width, height - 2)
    end
end

function EffectTimer:ChangeText(newName)
    self.textLabel:SetText(newName)
end