DataGrab = class(Turbine.UI.Control)
function DataGrab:Constructor()
    Turbine.UI.Control.Constructor(self)
    self:SetVisible(false)
    self:SetMouseVisible(false)

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.effectList = self.player:GetEffects()
    self.ClassAttr = self.player:GetClassAttributes()
    self.trainedSkills = self.player:GetTrainedSkills()
    self.class = self.player:GetClass()

    self.effectCallbacks = {}

    self.effectData = LoadTable(Turbine.DataScope.Account, "PrimeEffectData")
    self.skillData = LoadTable(Turbine.DataScope.Account, "PrimeSkillData")
    self.iconData = LoadTable(Turbine.DataScope.Account, "PrimeIconData")

    if self.effectData == nil then self.effectData = {} end
    if self.skillData == nil then self.skillData = {} end
    if self.skillData[self.class] == nil then self.skillData[self.class] = {} end
    if self.iconData == nil then self.iconData = {} end


    if Settings.CollectIconData then
        local index = 0
        for i = 1, self.trainedSkills:GetCount(), 1 do
            local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
            local skillInfo = item:GetSkillInfo()
            local name = item:GetSkillInfo():GetName()
            if not(self.skillData[name] ) and skillInfo then
                -- [name] = {Description, ImageID, Type}
                self.skillData[self.class][name] = {skillInfo:GetDescription(), skillInfo:GetIconImageID(), skillInfo:GetType()}
            end
            if not(self.iconData[skillInfo:GetIconImageID()]) then
                self.iconData[skillInfo:GetIconImageID()] = true
            end
        end

        self:SetCallbacks()
    end
end

function DataGrab:GetIcons()
    local result = {}

    for class, classSkills in pairs(self.skillData) do
        for key, value in pairs(classSkills) do
            result[key] = value[2]
        end
    end

    for skill, value in pairs(self.effectData) do
        result[skill] = value[4]
    end

    for icon, _ in pairs(self.iconData) do
        result[icon] = icon
    end

    return result
end

function DataGrab:GetEffects()
    return self.effectData
end

function DataGrab:SetCallbacks()

    self.effectCallbacks["EffectAdded"] = AddCallback(PlayerEffectsHandler, "EffectAdded", 
    function(effect)
        local effectName = effect:GetName()

        if not(self.effectData[effectName]) then
            self.effectData[effectName] = {effect:GetCategory(), effect:GetDescription(), effect:GetDuration(), effect:GetIcon(), effect:IsCurable(), effect:IsDebuff()}
        end
        if not(self.iconData[effect:GetIcon()]) then
            self.iconData[effect:GetIcon()] = true
        end
    end)

end

function DataGrab:RemoveCallbacks()
    --player callbacks
    for key, value in pairs(self.effectCallbacks) do
        RemoveCallback(PlayerEffectsHandler, key, value)
    end

    collectgarbage()

end

function DataGrab:Save()
    SaveTable(Turbine.DataScope.Account, "PrimeEffectData", self.effectData)
    SaveTable(Turbine.DataScope.Account, "PrimeSkillData", self.skillData)
    SaveTable(Turbine.DataScope.Account, "PrimeIconData", self.iconData)
    self:RemoveCallbacks()
end