EffectsWindow = class(Turbine.UI.Window)
function EffectsWindow:Constructor()
  Turbine.UI.Window.Constructor(self);
  local width = Settings.EWidth
  local height = Settings.EHeight
  local x = Settings.EX
  local y = Settings.EY
  self.cooldownTimer = 0
  self.maxFadeTimer = 5
  self.fadeTimer = self.maxFadeTimer
  self.maxTimer = 0
  self.alertEffectName = ""

  self.active = false
  self.fiveCDActive = false
  self.fiveCD = nil

  self:SetSize(width,height);
  self:SetPosition(x,y);
  self:SetZOrder(1);

  self:SetWantsKeyEvents(false)
  self:SetMouseVisible(false)
  self:SetVisible(true)
  --self:SetBackColor(GetRandomColour())
  --self:SetWantsUpdates(true)
  --self:SetOpacity(0.3)

  self.messageBox = Turbine.UI.Label()
  self.messageBox:SetParent(self)
  self.messageBox:SetSize(width - 250,height - 20)
  self.messageBox:SetPosition(125,20)
  self.messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.messageBox:SetFont(Settings.EFont)
  self.messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.messageBox:SetVisible(false)
  self.messageBox:SetMarkupEnabled(true)
  self.messageBox:SetOutlineColor(OutlineColor)
  self.messageBox:SetFontStyle( Turbine.UI.FontStyle.Outline )
  self.messageBox:SetMouseVisible(false)
  --self.messageBox:SetBackColor(GetRandomColour())

  self.imageWindow = Turbine.UI.Window()
  self.imageWindow:SetParent(self)
  self.imageWindow:SetVisible(true)
  self.imageWindow:SetSize(Settings.EIWidth, Settings.EIHeight)
  self.imageWindow:SetMouseVisible(false)
  --self.imageWindow:SetBackColor(GetRandomColour())
  self.imageWindow:SetPosition(12.5, 12.5)

  self.imageBox1 = Turbine.UI.Label()
  self.imageBox1:SetParent(self.imageWindow)
  self.imageBox1:SetSize(Settings.EIWidth, Settings.EIHeight)
  --self.imageBox1:SetPosition(12.5, 12.5)
  self.imageBox1:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
  self.imageBox1:SetForeColor(Turbine.UI.Color(1, 1, 1))
  self.imageBox1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.imageBox1:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.imageBox1:SetFont(Settings.EFont)
  self.imageBox1:SetMouseVisible(false)
  --self.imageBox1:SetBackColor(GetRandomColour())

  self.countdownWindow = Turbine.UI.Window()
  self.countdownWindow:SetParent(self)
  self.countdownWindow:SetVisible(true)
  self.countdownWindow:SetSize(Settings.EIWidth, Settings.EIHeight)
  self.countdownWindow:SetMouseVisible(false)

  self.countdownBox = Turbine.UI.Label()
  self.countdownBox:SetParent(self.countdownWindow)
  self.countdownBox:SetSize(Settings.EIWidth, Settings.EIHeight)
  self.countdownBox:SetPosition(12.5, 12.5)
  self.countdownBox:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
  self.countdownBox:SetForeColor(Turbine.UI.Color(1, 1, 1))
  self.countdownBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.countdownBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.countdownBox:SetFont(Settings.EFont)
  self.countdownBox:SetOpacity(1)
  self.countdownBox:SetMouseVisible(false)

  self.imageBox2 = Turbine.UI.Label()
  self.imageBox2:SetParent(self)
  self.imageBox2:SetSize(Settings.EIWidth, Settings.EIHeight)
  self.imageBox2:SetPosition(width - 125 + 12.5, 12.5)
  self.imageBox2:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
  self.imageBox2:SetForeColor(Turbine.UI.Color(1, 1, 1))
  self.imageBox2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.imageBox2:SetFont(Settings.EFont)
  self.imageBox2:SetMouseVisible(false)


  local moveBox = MoveBox(self, width, height, "Self alerts")
    
  self.ToggleMove = function()
      moveBox:ToggleMove()
  end

  self.ExecuteUpdate = function(delta)
    if (self.cooldownTimer <= 0) then
      self.messageBox:SetVisible(false)
      self.imageBox1:SetVisible(false)
      self.imageBox2:SetVisible(false)
      self.imageWindow:SetVisible(false)
      self.countdownWindow:SetVisible(false)
      self.alertEffectName = nil
      if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
      self.updateCallback = nil
    end
  
    if self.cooldownTimer < 1 then
      self:SetOpacity(self.cooldownTimer + 0.3)
  end
  
    if(self.cooldownTimer > 0) then
        self.cooldownTimer = self.cooldownTimer - delta
    end

    if self.fiveCD and self.cooldownTimer <= 5 and not(self.fiveCDActive) and countdownWindow then
      countdownWindow:Countdown(self.cooldownTimer)
      self.fiveCDActive = true
    end
  
    if self.countDownVisible then
      if self.cooldownTimer <= 2 then
        self.countdownBox:SetText(Round(self.cooldownTimer,1))
        self.countdownBox:SetForeColor(Turbine.UI.Color(0.75, 0, 0))
      else
        self.countdownBox:SetText(math.ceil(self.cooldownTimer))
      end
        --effectsWindow.imageBox2:SetText(self.cooldownTimer)
    end
  
    if(self.cooldownTimer <= self.maxTimer - self.fadeTimer) then
      if Settings.EL then
        self.imageBox1:SetBackground("")
      end
      if Settings.ER then
        self.imageBox2:SetBackground("")
      end
    else
      --effectsWindow.imageWindow:SetOpacity(0.1)
      --ChatOutput(1 - ((self.maxTimer - self.cooldownTimer) / 3))
      self.imageWindow:SetOpacity(1 - ((self.maxTimer - self.cooldownTimer) / self.fadeTimer))
    end
  end

  if not(Settings.ReloadData) then 
    self:Message(8, "<rgb=#0008CFF>".. Greetings[math.random(1, tablelength(Greetings))] .. "</rgb>",nil,false) 
  end
end

function EffectsWindow:Clear()
  self.messageBox:SetText("")
  self.cooldownTimer = 0
  self.imageBox1:SetBackground("")
  self.imageBox2:SetBackground("")
end  

function EffectsWindow:Unload()
  if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
  self.updateCallback = nil
end

function EffectsWindow:Message(duration, message, icon, cdVisible, effectName, fiveCD)
  if E.UniqueEffects[effectName] and effectName == self.alertEffectName then return end

  self:SetOpacity(1)

  if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end

  ChatOutput(message)
  self.cooldownTimer = duration
  self.maxTimer = duration
  self.alertEffectName = effectName
  self.messageBox:SetText(message)
  self.messageBox:SetVisible(true)
  self.imageWindow:SetOpacity(1)
  self.imageWindow:SetVisible(true)
  self.countdownWindow:SetVisible(true)

  self.fiveCD = fiveCD
  self.fiveCDActive = false
  self.lastSoundCD = 6

  self.fadeTimer = math.min(self.maxFadeTimer, duration)
  
  if icon ~= nil then
    if Settings.EL then
      self.imageBox1:SetBackground(icon)
      self.imageBox1:SetVisible(true)
    end
    if Settings.ER then
      self.imageBox2:SetBackground(icon)
      self.imageBox2:SetVisible(false)
    end
  else
    self.imageBox1:SetBackground("")
    self.imageBox1:SetVisible(true)
    self.imageBox2:SetBackground("")
    self.imageBox2:SetVisible(true)
  end

  if cdVisible then
    self.countDownVisible = true
    self.countdownBox:SetText(duration)
    self.countdownBox:SetForeColor(Turbine.UI.Color(1, 1, 1))
    --self.imageBox2:SetText(duration)
  else 
    self.countDownVisible = false
    self.countdownBox:SetText("")
    self.imageBox2:SetText("")
  end
end