InstanceHub = class(Turbine.UI.Control)
function InstanceHub:Constructor()
    Turbine.UI.Control.Constructor(self)

    self:CreateTables()

    self.mplus = MythicPlus()
    self.mplusViewer = MythicPlusViewer(self.nameTable, self.mplus:GetDungeonData())
    self.button = MythicButton(self.mplusViewer)

    if Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == 2 then
        Settings.EttenmoorsState = true
        self.switchAction[4]()
    end

    if Settings.EttenmoorsState and Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() < 2 then
        self.switchAction[5]()
    end

    --ChatOutput(Settings.InstanceVersion)
    
        self:ExecuteInstanceSwitch()
end

function InstanceHub:EnterNewInstance(line, id)
    Settings.InstanceState = true
    Settings.InstanceVersion = id
    if line then
        Settings.InstanceTier = string.sub(line, string.len(line), string.len(line))
    else
        Settings.InstanceTier = "?"
    end

    --ChatOutput(id)
    if Target and Settings.InstanceState then 
        ChatOutput("<rgb=#FF0000>Target window is enabled, this might impact performance on some raid bosses!</rgb>")
    end

    self:ExecuteInstanceSwitch()
end

function InstanceHub:ExecuteInstanceSwitch()
    if self.switchAction[Settings.InstanceVersion] then self.switchAction[Settings.InstanceVersion]() end
    
    if Settings.InstanceState then
        self.mplus:LoadDungeon(Settings.InstanceVersion, Settings.InstanceTier)

        PluginsManager:LoadRaidPlugins()

        if Auras then Auras:HandleRaidLoads(true) end
    end

    if Settings.SPInstance then
        --if skillTimers then skillTimers:SetVisible(Settings.InstanceState) end
        --if activeTimers then activeTimers:SetVisible(Settings.InstanceState) end
    end
end

function InstanceHub:ParsePlus(line)
    self.mplus:Parse(line)
end

function InstanceHub:CheckInstanceState(line)
    if string.find(line, "Quest") then

        local strippedLine = nil
        if string.find(line, "- ") then
            strippedLine = string.sub(line, 1, string.find(line, "- ") - 2)
        else
            strippedLine = line
        end

        if self.questLines[strippedLine] then self:EnterNewInstance(line, self.questLines[strippedLine]) end
    end

    if string.find(line, "Entered the") then
        if string.find(string.match(line, "Entered the (.*) channel."), "-") and Settings.InstanceVersion > 0 then
            if Settings.EEnabled and Settings.InstanceState then
                --effectsWindow:Message(8, "<rgb=#0008CFF>Leaving so soon?</rgb>",nil,false)
            end
            Settings.InstanceState = false
            Settings.InstanceVersion = 0
            self:ExecuteInstanceSwitch()
            PluginsManager:UnloadRaidPlugins()
            if Auras then Auras:HandleRaidLoads(false) end
            self.mplus:LoadDungeon(0, 0)
        end


        if not(string.find(line, "Ettenmoors" )) and Settings.EttenmoorsState and Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() < 2 then
            Settings.EttenmoorsState = false
            if KillTracker ~= nil then
                KillTracker:SetVisible(false)
            end
            PluginsManager:UnloadEttenmoorsPlugins()
            if Auras then Auras:HandlePvpLoads(false) end
            
        end

        if combatTimer then
            combatTimer:ChangeMode(false)
        end
    end

    if string.find(line, "Entered the Ettenmoors") and not(Settings.EttenmoorsState) then
        Settings.EttenmoorsState = true

        if Settings.InstanceState then 
            PluginsManager:UnloadRaidPlugins() 
            if Auras then Auras:HandleRaidLoads(false) end
        end
        Settings.InstanceState = false
        if Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == 1 then
            self.switchAction[5]()
        end

        PluginsManager:LoadEttenmoorsPlugins()
        if Auras then Auras:HandlePvpLoads(true) end
    end

    if string.find(line, "resets") then
        -- DG
        if string.find(line, "Dâr Narbugud resets in") then
            Settings.InstanceState = true
            if Settings.EEnabled and Settings.InstanceVersion ~= 2 then
                --effectsWindow:Message(8, "<rgb=#0008CFF>Welcome to Dâr Narbugud! </rgb>",nil,false)
            end
            self:EnterNewInstance(line, 2)
        end

        -- Rift
        if string.find(line, "The Rift of Nûrz Ghâshu resets in") then
            Settings.InstanceState = true
            if Settings.EEnabled and Settings.InstanceVersion ~= 3 then
                --effectsWindow:Message(8, "<rgb=#0008CFF>Welcome to The Rift of Nûrz Ghâshu! </rgb>",nil,false)
            end
            self:EnterNewInstance(line, 3)
        end

        -- Throne
        if string.find(line, "Throne of the Dread Terror resets in") then
            Settings.InstanceState = true
            if Settings.EEnabled and Settings.InstanceVersion ~= 8 then
                --effectsWindow:Message(8, "<rgb=#0008CFF>Welcome to Throne! </rgb>",nil,false)
            end
            self:EnterNewInstance(line, 8)
        end

        -- Filikul
        if string.find(line, "Filikul resets in") then
            Settings.InstanceState = true
            if Settings.EEnabled and Settings.InstanceVersion ~= 8 then
                --effectsWindow:Message(8, "<rgb=#0008CFF>Welcome to Filikul!</rgb>",nil,false)
            end
            self:EnterNewInstance(line, 30)
        end

        -- Watcher
        if string.find(line, "The Vile Maw resets in") then
            Settings.InstanceState = true
            if Settings.EEnabled and Settings.InstanceVersion ~= 8 then
                --effectsWindow:Message(8, "<rgb=#0008CFF>Welcome to The Vile Maw!</rgb>",nil,false)
            end
            self:EnterNewInstance(line, 31)
        end

    end
end

function InstanceHub:CreateTables()

    --[[
        Instances
        Warg Pens of Dol Guldur
        Sammath Gûl

        Dark Delvings 21
        Fil Gashan 22
        Skumfil 23
        Forges of Khazad-dûm 24
        The Grand Stair 25
        The Sixteenth Hall 26

        Arboretum
        Barrows
        Fortress

        The Depths of Kidzul-kâlah
        The Harrowing of Morgul
        Eithel Gwaur, the Filth-well 
        Gath Daeroval, the Shadow-roost
        Gorthad Nûr, the Deep-barrow 

        Bâr Nírnaeth, the Houses of Lamentation 
        Ghashan-kútot, the Halls of Black Lore 
        The Fallen Kings 
        
        Shakalush, the Stair Battle

        Raids
        Barad Guldur
        Remmorchant, the Net of Darkness
        Amdân Dammul, the Bloody Threshold 
        Filikul
        The Vile Maw
    ]]

    self.questLines = {

        -- MM
        ["New Quest: Remmorchant, the Net of Darkness "] = 1,
        ["New Quest: Amdân Dammul, the Bloody Threshold "] = 7,
        ["New Quest: The Depths of Kidzul-kâlah "] = 9,
        ["New Quest: Shakalush, the Stair Battle "] = 10,
        ["New Quest: The Harrowing of Morgul"] = 11,
        ["New Quest: Bâr Nírnaeth, the Houses of Lamentation "] = 12,
        ["New Quest: Eithel Gwaur, the Filth-well "] = 13,
        ["New Quest: Gath Daeroval, the Shadow-roost "] = 14,
        ["New Quest: Ghashan-kútot, the Halls of Black Lore "] = 15,
        ["New Quest: Gorthad Nûr, the Deep-barrow "] = 16,
        ["New Quest: The Fallen Kings "] = 17,

        ["New Quest: Agoroth, the Narrowdelve "] = 32,
        ["New Quest: Woe of the Willow "] = 33,

        ["New Quest: Askâd-mazal, the Chamber of Shadows "] = 36,

        -- Mirkwood
        ["New Quest: Barad Guldur: The Deep Assault"] = 18,
        ["New Quest: Dark Deeds in Sammath Gûl"] = 19,
        ["New Quest: Strange Meat"] = 20,

        -- Moria
        ["New Quest: Challenge: Gurvand (Daily)"] = 21,
        ["New Quest: Challenge: General Talug (Daily)"] = 22,
        ["New Quest: Challenge: Hwandrin (Daily)"] = 23,
        ["New Quest: Challenge: Kranklûk (Daily)"] = 24,
        ["New Quest: Challenge: Igash (Daily)"] = 25,
        ["New Quest: Challenge: The Lost One (Daily)"] = 26,

        -- Garth Aragwen
        ["New Quest: Challenge: Grimbark"] = 27,
        ["New Quest: Challenge: Ivar"] = 28,
        ["New Quest: Challenge: Dúnlang"] = 29,   

        -- Festival
        ["New Quest: Boss from the Vaults: Naruhel"] = 34,
        ["New Quest: Bee's Big Business"] = 35,

        -- ROots of fangorn
        ["New Quest: Instance: The Roots of Fangorn"] = 37,

        -- Fall of Khazad-Dum
        ["New Quest: The Fall of Khazad-dûm "] = 38,
        
        -- Filikul 30
        -- Vile maw 31

        -- Highest 38

    }

    self.nameTable = {
        [0] = "All",
        [1] = "Remmorchant",
        [2] = "Dâr Narbugud",
        [3] = "The Rift of Nûrz Ghâshu",
        [4] = "Monster Player",
        [5] = "The Free Peoples",
        [6] = "The Ettenmoors",
        [7] = "Amdân Dammul",
        [8] = "Throne of the Dread Terror",
        [9] = "The Depths of Kidzul-kâlah",
        [10] = "Shakalush, the Stair Battle",
        [11] = "The Harrowing of Morgul",
        [12] = "Bâr Nírnaeth, the Houses of Lamentation",
        [13] = "Eithel Gwaur, the Filth-well",
        [14] = "Gath Daeroval, the Shadow-roost",
        [15] = "Ghashan-kútot, the Halls of Black Lore",
        [16] = "Gorthad Nûr, the Deep-barrow",
        [17] = "The Fallen Kings",
        [18] = "Barad Guldur",
        [19] = "Sammath Gûl",
        [20] = "Warg Pens of Dol Guldur",
        [21] = "Dark Delvings",
        [22] = "Fil Gashan",
        [23] = "Skumfil",
        [24] = "Forges of Khazad-dûm",
        [25] = "The Grand Stair",
        [26] = "The Sixteenth Hall",
        [27] = "Arboretum",
        [28] = "Barrows",
        [29] = "Fortress",
        [30] = "Filikul",
        [31] = "The Vile Maw",
        [32] = "Agoroth, the Narrowdelve",
        [33] = "Woe of the Willow",
        [34] = "Boss from the Vaults: Naruhel",
        [35] = "Bee's Big Business",
        [36] = "Askâd-mazal, the Chamber of Shadows",
        [37] = "Roots of Fangorn",
        [38] = "The Fall of Khazad-dûm",
    }

    self.switchAction = {
        -- DefaultState
        [0] = 
        function()
    
        end,
        -- Remmorchant
        [1] = 
        function()

            --Player alerts
            Fight = FightHandler()
        end,
        -- Ettenmoors Creep
        [4] = 
        function()
            
            self.switchAction[6]()
        end,
        -- Ettenmoors Freep
        [5] =
        function()
            self.switchAction[6]()
        end,
        -- Ettenmoors both factions
        [6] =
        function()
            if KillTracker == nil then
                KillTracker = KillCounter()
            else
                KillTracker:SetVisible(true)
            end
        end,
        [7] =
        function()
            if Settings.EEnabled then
                --effectsWindow:Message(8, "<rgb=#0008CFF>Welcome to the Bloody Threshold! </rgb>",nil,false)
            end
            --TDamage["Thrash"] = {55, "Thrash"}
            --TDamage[""]
            Fight = FightHandler()
            -- Let's see how they handle bardhrukh, or as my boys call him... THE KILLBEAST! -- Start on boss 1 + X seconds
            --Gorgar the Ruthless says  Look at that! The dwarves killed the Killbeast! -- kill on boss 1
            -- Good warg. To battle! -- Start boss 2
            --The warg chieftain is victorious! I guess you get to live, mongrel! -- Wipe on boss 2
            -- Prince Durin shouts Well done, heroes! -- Kill on boss 2
        end,
        -- Throne
        [8] =
        function()
            Fight = FightHandler()
        end,
        [38] = function()


            Fight = FightHandler()
        end,
        [999] =
        function()

        end,
    }
end

function InstanceHub:Unload()
    Settings.MythicPlusX, Settings.MythicPlusY = self.mplus:GetPosition()
    Settings.MythicPlusButtonX, Settings.MythicPlusButtonY = self.button:GetPosition()
end

function InstanceHub:GetDungeonNameTable()
    return self.nameTable
end

RaidTable = {
    [1] = {
        -- Boss 1
        ["Bratha Tasakh, Lady of Many Venoms"] = {
            ["No, no! I cannot be the last! The Ungoledain will not fall this day!"] = 
            {
                1,
                {
                ["This will not do. Perhaps this may work...."] = {1, 2}
                },
                {
                    ["No! Erk... Felgúr.... You were right.... The Ungoledain die with me...."] = {1, "Bratha Tasakh", true}
                },
                "Bratha Tasakh",
                
            },
        },
        -- Boss 3
        ["Captain Zabothak"] = {

            ["For the Pale Herald!"] = 
            {
                3,
                {
                    ["It is over, Zabothak... and you have failed."] = {3, 2}
                },
                {
                    ["You are... too late...."] = {3, "Zabothak & Rukhor", true}
                },
                "Zabothak & Rukhor"
            }
        },
        -- Boss 4
        ["Legolas"] = {
            ["You must wield the Gilgalar, my friend. Hold off Ungwetári for as long as you can!"] = 
            {
                4,
                nil,
                {
                    ["Ungwetári means to flee! We cannot allow her to escape, my friends!"] = {4, "Shelob", true}
                },
                "Shelob"
            }
        }
    },
    [7] = {
        ["Gorgar the Ruthless"] = {
            -- Boss 1
            ["Let's see how they handle Bardhrukh, or as my boys call him... THE KILLBEAST!"] = 
            {
                1, 
                nil,
                {
                    ["What a pathetic showing by the dwarves! At least the beasts will eat well tonight! Hah!"] = {1, "The Killbeast", false},
                    ["Look at that! The dwarves killed the Killbeast!"] = {1, "The Killbeast", true}
                },
                "The Killbeast"
            },

            -- Boss 2
            ["Good warg. To battle!"] = {
                2,
                {
                    ["ENOUGH! I AM NO ONE'S MOUNT!"] = {2, 2}
                },
                {
                    ["The warg chieftain is victorious! I guess you get to live, mongrel!"] = {2, "Gorgar & Ránulur", false},
                    ["None can stand against Gorgar the Ruthless!"] = {2, "Gorgar & Ránulur", false},
                    ["Prince Durin shouts Well done, heroes!"] = {2, "Gorgar & Ránulur", true},
                    ["At last... my suffering... is over...."] = {2, "Gorgar & Ránulur", true},
                },
                "Gorgar & Ránulur"
            }
        },
    },
    [8] = {
        ["Rakothas"] = {
            -- Boss 1
            ["I am but a hammer before a field of nails!"] = {
                1,
                nil,
                {},
                "Rakothas"
            }
        }
    },
    [9] = {
        ["Gultháva, Maiden of the Gladden"] = {
            -- Boss 1
            ["You must prove you are strong enough to triumph over the shadows below."] = {
                1,
                nil,
                {
                    ["You are indeed strong. Please, help me remove the shadows that corrupt this place."] = {1, "Gultháva", true},
                },
                "Gultháva"
            }
        }
    },
    [38] = {
        ["Commander Formáth Firmhand"] = {
            ["This is it, dwarves! All we must do is survive! For Durin! For Náin!"] = {
                1,
                {
                    ["Retreat! He will slaughter us!"] = {1, 2},
                    ["Fall back!"] = {1, 3},
                    ["Blast! He keeps pushing us back!"] = {1, 4},
                    ["We are quickly running out of ground!"] = {1, 5},
                },
                {
                    ["We have no more time. Go, cross the bridge and live! I will hold him off!"] = {1, "Durin's Bane", true},
                },
                "Durin's Bane"
            }
        }
    },
    --[[
    [32] = {
        -- boss 1
        ["Aigrith the Ashen"] = {
            ["Outsiders! You will be destroyed at the hands of Aigrith the Ashen! The Witch-King has commanded it!"] = {
                1,
                nil,
                {
                    ["Useless Gauredain magic... not enough... I have failed you, my Master!"] = {1, "Aigrith the Ashen", true},
                    ["Argh! No! Gauradan... take my power, and keep your word to Angmar...."] = {1, "Aigrith the Ashen", true},
                    ["Ashes to ashes!"] = {1, "Aigrith the Ashen", false},
                },
                "Aigrith the Ashen"
            },


        },
        -- boss 2
        ["Rucrog Hoarpelt"] = {
            ["I have failed! Angmarim, I have one last boon to offer. Take it and gain victory!"] = {
                2,
                nil,
                {
                    ["I have failed! Angmarim, I have one last boon to offer. Take it and gain victory!"] = {2, "Rucrog Hoarpelt", true},
                    ["Erk.... Your foul magic was not enough, Angmarim. I go to meet my ancestors...."] = {2, "Rucrog Hoarpelt", true}
                },
                "Rucrog Hoarpelt"
            }
        },
        -- Boss 3
        ["Captain Glamagon"] = {
            [Turbine.Gameplay.LocalPlayer.GetInstance():GetName() .. ", Lothrandir, be ready for anything!"] = {
                3,
                nil,
                {
                    ["We have lost control! The ship is being torn apart!"] = {3, "Witch-King in Narrowdelve", true}
                },
                "Witch-King in Narrowdelve"
            }
        }

    },
    [33] = {
        -- Boss 1
        [""] = {
            ["Pesky vermin... these woods are ours!"] = {

            }
        }
    }
    --]]
}

FightHandler = class(Turbine.UI.Control)
function FightHandler:Constructor()

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.InstanceTier = Settings.InstanceTier
    self.InstanceID =  Settings.InstanceVersion

    self.InFight = false

    self.BossID = nil
    self.BossName = nil
    self.PhaseLines = nil
    self.EndLines = nil

    self.CurrentPhase = nil
    self.MaxPhases = nil

    self.StartTime = nil
    self.PhaseStartTime = nil

    self.FightLines = RaidTable[self.InstanceID]
end

function FightHandler:TextUpdate(line)
    local name = GetFirstName(line)
    local cleanedLine = GetTextLine(line)

    --Find if the fight is starting
    if (not(self.InFight) or (self.InFight and not(self.player:IsInCombat()))) and self.FightLines[name] and self.FightLines[name][cleanedLine] then
        -- [1] Boss ID [2] Phases lines [3] End Line
        local StartTemp = self.FightLines[name][cleanedLine]
        self.BossID, self.PhaseLines, self.EndLines = StartTemp
        self.BossID = StartTemp[1]
        self.PhaseLines = StartTemp[2]
        self.EndLines = StartTemp[3]
        self.BossName = StartTemp[4]
        self.MaxPhases = tablelength(self.PhaseLines)
        self.StartTime = Turbine.Engine.GetGameTime()
        self.PhaseStartTime = Turbine.Engine.GetGameTime()
        self.InFight = true
        self.CurrentPhase = 1
        if combatTimer then
            combatTimer:ChangeMode(true)
        end

        ChatOutput("<rgb=#f79000>Started encounter \"" .. self.BossName .. "\" on Tier " .. self.InstanceTier .." difficulty, good luck!")

        return
    end

    -- Return if the fight didn't start and not ongoing
    if not(self.InFight) then return end

    -- We are in a fight

    -- Check for phase ending
    if self.PhaseLines and self.PhaseLines[cleanedLine] then

        -- [1] Boss ID [2] Phase #
        local phaseTemp = self.PhaseLines[cleanedLine]

        if self.BossID == phaseTemp[1] and self.CurrentPhase < phaseTemp[2] then
            self.CurrentPhase = phaseTemp[2]
            local PhaseDuration = Turbine.Engine.GetGameTime() - self.PhaseStartTime
            ChatOutput("<rgb=#f79000>Completed phase " .. self.CurrentPhase - 1 .. " in " .. TimeDeltaToString(PhaseDuration))
            if Settings.EEnabled then
                effectsWindow:Message(8, "<rgb=#0008CFF>Phase ".. self.CurrentPhase .."</rgb>",nil,false)
            end
            self.PhaseStartTime = Turbine.Engine.GetGameTime()
            return
        end
    end

    -- Check for fight ending
    local detectWipe = ((string.find(line, "Your fellow,") and string.find(line, "has been defeated!")) or string.find(line, "You succumb to your wounds.")) and tablelength(self.EndLines) < 2

    if self.EndLines and self.EndLines[cleanedLine] or detectWipe then
        -- [1] Boss ID [2] Boss Name [3] Success
        local EndTemp = self.EndLines[cleanedLine] 

        if detectWipe or self.BossID == EndTemp[1] then 

            local tempData = ReturnBossData(self.InstanceID, self.BossName, self.InstanceTier)
            local FightDuration = Turbine.Engine.GetGameTime() - self.StartTime
            -- We win
            if EndTemp and EndTemp[3] then

                if tempData["FirstCompletion"] < 0 then
                    ChatOutput("<rgb=#f79000>Congratulations on your first successful clear on Tier " .. self.InstanceTier .. " difficulty! You have wiped ".. tempData["Wipes"] .. " times before this completion!")
                end

                if FightDuration < tempData["BestTime"] then
                    ChatOutput("<rgb=#f79000>Completed encounter " .. EndTemp[2] .. " in " .. TimeDeltaToString(FightDuration) .. ", new best time! You have completed this encounter ".. tempData["Completions"] + 1 .. " times on Tier " .. self.InstanceTier .. " difficulty!")
                else
                    ChatOutput("<rgb=#f79000>Completed encounter " .. EndTemp[2] .. " in " .. TimeDeltaToString(FightDuration) .. ", your best time is: ".. TimeDeltaToString(tempData["BestTime"]) .."! You have completed this encounter ".. tempData["Completions"] + 1 .. " times on Tier " .. self.InstanceTier .. " difficulty!")
                end
                SaveBossData(self.InstanceID, EndTemp[2], self.InstanceTier, FightDuration, true)
            end

            -- We Lost
            if detectWipe or not(EndTemp[3]) and FightDuration > 5 then
                ChatOutput("<rgb=#f79000>Wiped after " .. TimeDeltaToString(FightDuration) .. ", you have wiped " .. tempData["Wipes"] + 1 .. " times on Tier " .. self.InstanceTier .. " difficulty.")
                SaveBossData(self.InstanceID, self.BossName, self.InstanceTier, FightDuration, false)
            end
            
            if combatTimer then
                combatTimer:ChangeMode(false)
            end
            if skillCounters then skillCounters:Clear() end
            self.InFight = false
        end
    end
end

function FightHandler:FightStatus()
    return self.InFight
end

--[[
    
    Gultháva, Maiden of the Gladden shouts, ''You must prove you are strong enough to triumph over the shadows below.''
    Gultháva, Maiden of the Gladden shouts, ''You are indeed strong. Please, help me remove the shadows that corrupt this place.''
]]

MythicPlus = class(Turbine.UI.Window)
function MythicPlus:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.width = 300
    self.height = 190
    self:SetPosition(Settings.MythicPlusX, Settings.MythicPlusY)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(false)
    self:SetMouseVisible(true)

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.NameLabel = Turbine.UI.Label()
    self.NameLabel:SetParent(self)
    self.NameLabel:SetSize(300, 30)
    self.NameLabel:SetPosition(0, 0)
    self.NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold30)
    self.NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.NameLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.NameLabel:SetMouseVisible(false)
    --self.NameLabel:SetText("Cord's Panties")

    self.TimeLabel = Turbine.UI.Label()
    self.TimeLabel:SetParent(self)
    self.TimeLabel:SetSize(300, 20)
    self.TimeLabel:SetPosition(0, 30)
    self.TimeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.TimeLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold22)
    self.TimeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.TimeLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.TimeLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.TimeLabel:SetMouseVisible(false)
    --self.TimeLabel:SetText("[T2] 25:44 / 41:00")

    self.DeathLabel = Turbine.UI.Label()
    self.DeathLabel:SetParent(self)
    self.DeathLabel:SetSize(300, 20)
    self.DeathLabel:SetPosition(0, 50)
    self.DeathLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.DeathLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.DeathLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.DeathLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.DeathLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.DeathLabel:SetMouseVisible(false)
    --self.DeathLabel:SetText("Deaths: 0 - Time lost: 0:00")

    self.TrashLabel = Turbine.UI.Label()
    self.TrashLabel:SetParent(self)
    self.TrashLabel:SetSize(300, 20)
    self.TrashLabel:SetPosition(0, 70)
    self.TrashLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.TrashLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.TrashLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.TrashLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.TrashLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.TrashLabel:SetMouseVisible(false)
    --self.TrashLabel:SetText("Enemy Forces - 0.0%")

    -- Reset logic
    if Settings.MythicPlusSeason == -1 then
        Settings.MythicPlusSeason = 1
    end

    self.bossLabels = {}

    self.active = false

    self:LoadData()

    self.instanceVersion = 0
    self.instanceData = nil
    self.trashCount = 0
    self.maxTrashCount = 1
    self.timer = 0
    self.startTime = Turbine.Engine.GetGameTime()
    self.tier = 0
    self.maxTime = 0
    self.maxTimeString = ""
    self.maxTimeString = CombatTimeDeltaToString((41 * 60))
    self.bossCount = 0
    self.addedDeathTime = 0
    self.deathCount = 0

    --self:LoadDungeon(32, 2)

    self.Moving = false

    self.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
  
    self.MouseUp = function()
        self.Moving = false
    end
  
    self.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          self:SetPosition(newLeft,newTop)
        end
    end
    
    self.ToggleMove = function()
      if not(self.MoveBox:IsVisible()) then
        self.ParentVisibleMemory = parent:IsVisible()
      end
      self.MoveBox:SetVisible(not self.MoveBox:IsVisible())
    end
end

function MythicPlus:GetDungeonData(id)
    if id and self.DungeonInfo then return self.DungeonInfo[id] end
    return self.DungeonInfo
end

function MythicPlus:AddBossLabel(name)
    local BossLabel = Turbine.UI.Label()
    BossLabel:SetParent(self)
    BossLabel:SetSize(300, 20)
    BossLabel:SetPosition(0, 90 + self.bossCount * 20)
    BossLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    BossLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    BossLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    BossLabel:SetMultiline(false)
    BossLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    BossLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    BossLabel:SetMouseVisible(false)
    BossLabel:SetText("0/1 " .. name)

    self.bossLabels[name] = BossLabel

    self.bossCount = self.bossCount + 1
end

function MythicPlus:LoadDungeon(id, tier)

    self.active = false

    self:SetVisible(false)
    for key, value in pairs(self.bossLabels) do
        value:SetParent(nil)
        self.bossLabels[key] = nil
    end
    self.bossCount = 0

    self.instanceVersion = id
    self.tier = tier
    self.trashCount = 0
    self.timer = 0
    self.startTime = 0
    self.finished = false
    self.progress = nil
    self.instanceData = nil
    self.maxTime = 0
    self.maxTrashCount = 0
    self.maxTimeString = 0
    self.addedDeathTime = 0
    self.deathCount = 0
    self:SetWantsUpdates(false)
    self.trashComplete = false
    self.partyNames = {}
    collectgarbage()

    if not(tonumber(tier)) or tonumber(tier) < 2 then 
        return
    end

    if self.DungeonInfo[id] then
        self.active = true
        self.instanceData = self.DungeonInfo[id]
        self.maxTime = self.instanceData["Time"]
        self.maxTrashCount = self.instanceData["MaxTrash"]
        self.maxTimeString = CombatTimeDeltaToString(self.instanceData["Time"])
        self.NameLabel:SetText(self.instanceData["Name"])
        self.startTime = Turbine.Engine.GetGameTime()
        self.progress = {
            ["Trash"] = false
        }
        for key, value in spairs(self.instanceData["Bosses"], function(t,a,b) return t[b] > t[a] end) do
            self:AddBossLabel(key)
            self.progress[key] = false
        end
        self.DeathLabel:SetText("Deaths: 0 - Time lost: 0:00")
        self.TrashLabel:SetText("Enemy Forces - 0.0%")
        self:SetVisible(Settings.MythicPlusVisible)
        self.party = self.player:GetParty()

        if self.party then
            for i = 1, self.party:GetMemberCount(), 1 do
                self.partyNames[self.party:GetMember(i):GetName()] = true
            end
        end
    end


    self:SetWantsUpdates(true)

end

function MythicPlus:Update(sender, args)
    self.timer = Turbine.Engine.GetGameTime() - self.startTime
    self.TimeLabel:SetText("[T" .. self.tier ..  "] ".. FormatTimeString(self.timer + self.addedDeathTime) .. " / " .. self.maxTimeString)
end

function MythicPlus:Parse(line, chatType)
    if not(self.active) then return end

    if line then self:KillParse(line) end
end

function MythicPlus:KillParse(line)

    local kill = string.match(line, "defeated ".."(.+)".. "%.")

    local newCount = self.instanceData["Trash"][kill]
    if newCount then
        self:UpdateCount(newCount)
    end

    if self.partyNames[kill] then self:AddDeath() end

    if self.instanceData["Bosses"][kill] then
        self:UpdateBoss(kill)
    else
        local suicide = string.match(line, "(.+)" .. " died.")
        if self.instanceData["Bosses"][suicide] then
            self:UpdateBoss(suicide)
        end
    end

    if string.find(line, "has been defeated") or 
    string.find(line, " incapacitated you.") or 
    string.find(line, "You have been incapacitated by misadventure.") then
        self:AddDeath()
    end

end

function MythicPlus:UpdateBoss(name)
    self.bossLabels[name]:SetText("1/1 " .. name .. " " .. FormatTimeString(Turbine.Engine.GetGameTime() - self.startTime))
    self.progress[name] = true
    self:UpdateProgress()
end

function MythicPlus:UpdateCount(newCount)
    self.trashCount = self.trashCount + newCount

    if self.trashComplete then return end

    if self.trashCount >= self.maxTrashCount then 
        self.progress["Trash"] = true
        self.trashComplete = true
        self:UpdateProgress() 
        self.TrashLabel:SetText("Enemy Forces - 100%") 
    else
        self.TrashLabel:SetText("Enemy Forces - " .. Round(self.trashCount / self.maxTrashCount * 100) .. "%")    
    end

    --ChatOutput(self.trashCount)
    -- update UI
end

function MythicPlus:AddDeath()
    self.deathCount = self.deathCount + 1
    self.addedDeathTime = self.addedDeathTime + 5

    self.DeathLabel:SetText("Deaths: " .. self.deathCount .. " - Time lost: " .. CombatTimeDeltaToString(self.addedDeathTime))

end

function MythicPlus:UpdateProgress()
    for key, value in pairs(self.progress) do
        --ChatOutput(key)
        if value == false then return end
    end

    self:Finish()


    -- we won
end

function MythicPlus:Finish()
    if self.finished then return end

    self.finished = true

    self:SetWantsUpdates(false)

    local score = self:CalculateScore(self.tier, self.timer + self.addedDeathTime, self.maxTime)

    local party = {}

    if self.player:GetParty() then
        for i = 1, self.player:GetParty():GetMemberCount(), 1 do
            local member = self.player:GetParty():GetMember(i)
            party[i] = {["Name"] = member:GetName(), ["Class"] = member:GetClass(), ["Level"] = member:GetLevel()}
        end
    end

    SaveMythicPlusData(self.instanceVersion, self.player:GetName(), {["Date"] = Turbine.Engine.GetLocalTime(), ["Trash"] = self.trashCount, ["TrashM"] = self.maxTrashCount, ["Deaths"] = self.deathCount, ["DeathTime"] = self.addedDeathTime, ["CompletionTime"] = self.timer + self.addedDeathTime, ["MaxTime"] = self.maxTime, ["Name"] = self.instanceData["Name"], ["Tier"] = self.tier, ["Finished"] = self.finished, ["Progress"] = self.progress, ["GameTime"] = Turbine.Engine.GetGameTime(), ["Timer"] = self.timer, ["StartTime"] = self.startTime, ["Name"] = self.player:GetName(), ["Level"] = self.player:GetLevel(), ["Class"] = self.player:GetClass(), ["Role"] = Roles:GetRole(), ["Line"] = Roles:GetLine(), ["Score"] = score, ["Party"] = party, ["Season"] = Settings.MythicPlusSeason})
    AddMythicPlusScore(self.instanceVersion, self.player:GetName(), {["Score"] = score, ["Tier"] = self.tier, ["Time"] = self.timer + self.addedDeathTime, ["Max Time"] = self.maxTime, ["Season"] = Settings.MythicPlusSeason})

    ChatOutput("<rgb=" .. GoldHex .. ">Completed " .. self.instanceData["Name"] .. " in " .. FormatTimeString(self.timer + self.addedDeathTime) .. " on T" .. self.tier .. " difficulty for a score of " .. Round(score, 1) .. "!")
end

function MythicPlus:CalculateScore(tier, time, maxTime)
    return math.max((tier - 1) * 100 + self:ReturnScoreRange(tier, time, maxTime), 0)
end

function MythicPlus:ReturnScoreRange(tier, time, maxTime)
    --local scaling = time / maxTime

    --local bonus = math.floor(math.max(0, math.abs(math.max(0.7, scaling) - 1)) / 0.1)

    --local timeScore = 1 - (1 / (math.exp((1 - scaling - 0.5)))) * 1000

    --local timeScore = 300 - 300 * scaling + bonus * 20
    return (1 - (1 / (math.exp( (1 - (time / maxTime)) * (0.1 + 0.1 * (tier - 1)))))) * 1000

    --return timeScore
end

function MythicPlus:LoadData()
    -- Roost 15 
    self.DungeonInfo = {
        [10] = {
            ["Bosses"] = {
                ["Azbauz"] = 1,
                ["Maugrush"] = 2,
                ["Shatarkha"] = 3,
                ["Groz-and-Ulk"] = 4,
            },
            ["Trash"] = {
                ["the Gundabad Warg"] = 2, -- 3 
                ["the Gundabad Goblin Trasher"] = 1, -- 6
                ["the Gundabad Defiler"] = 2, -- 3
                ["the Gundabad Warrior"] = 1, -- 19
                ["the Gundabad Archer"] = 1, -- 3
                ["the Gundabad Captain"] = 5, -- 2
                ["the Frostbound Hobgoblin"] = 5, -- 2
                ["the Gundabad Troll"] = 4, -- 3
                ["the Gundabad Heaver"] = 3, -- 2

            },
            ["Time"] = 18 * 60,
            ["Name"] = "Shakalush",
            ["MaxTrash"] = 78,
            ["Season"] = 1,
        },
        [11] = {
            ["Bosses"] = {
                ["Shaktur"] = 1,
                ["Dargásh"] = 2,
            },
            ["Trash"] = {
                ["the Goblin-scout"] = 0, -- 6
                ["the Ugrukhôr Warrior"] = 2, -- 16 2
                ["the Ugrukhôr Archer"] = 1, -- 2 1
                ["the Ugrukhôr Sergeant"] = 5, -- 4
                ["the Ugrukhôr Defiler"] = 3, -- 2
                ["the Gothmog Warrior"] = 2, -- 7
                ["the Gothmog Sergeant"] = 5, -- 2
                ["the Gothmog Defiler"] = 3, -- 2
                ["the Gothmog Archer"] = 1, -- 1

            },
            ["Time"] = 8 * 60,
            ["Name"] = "Harrowing",
            ["MaxTrash"] = 86,
            ["Season"] = 0,
        },
        [12] = {
            ["Bosses"] = {
                ["Manôzagar"] = 1,
                ["Narkhor the Flensed"] = 2,
                ["Agath-kali, the Gaunt-woman"] = 3,
            },
            ["Trash"] = {
                ["the Bound Fell-spirit"] = 0, -- 2
                ["the Nîluzir"] = 10, -- 3
                ["the Shadow-sworn Tormentor"] = 15, 
                ["the Shadow-sworn Acolyte"] = 3,  -- 3

                ["the Flayed Servant"] = 1, -- 20
                ["the Flayed Fanatic"] = 1, -- 23
                ["the Flayed Warrior"] = 3, -- 12

                ["the Stained Morvul"] = 5, -- 5
                ["the Stained Morroval"] = 5, -- 5
                ["the Stained Great-bat"] = 3, -- 3

                ["the Gaunt-man"] = 10, -- 7
                ["the Dark Tendril"] = 0, -- 10  

            },
            ["Time"] = 35 * 60,
            ["Name"] = "Bâr Nírnaeth",
            ["MaxTrash"] = 260, --247
            ["Season"] = 0,
        }, 
        [13] = {
            ["Bosses"] = {
                ["Balchneth"] = 1,
                ["Gwaurodel"] = 2,
            },
            ["Trash"] = {
                ["the Bloated Morgul Leech"] = 3, --
                ["the Morgulduin Vapour"] = 1, -- 4
                ["the Morgul Fumarole"] = 10, -- 2
                ["the Morgul Leech"] = 3, -- 
                ["the Morgul Darkwater"] = 3, --
                ["the Rotting Darkwater"] = 3, --
                ["the Morgul Crawler"] = 3, --
                ["the Bloated Morgul Crawler"] = 3, --
                ["the Morgul Root"] = 5, --
                ["the Morgul Filth"] = 3, --
                ["the Shadow Fumarole"] = 10, --

            },
            ["Time"] = 25 * 60,
            ["Name"] = "Eithel Gwaur",
            ["MaxTrash"] = 60,
            ["Season"] = 0,
        },
        [14] = {
            ["Bosses"] = {
                ["Khúrthak the Rent"] = 1, 
                ["Khatlob, the Brood Mother"] = 2,
            },
            ["Trash"] = {
                ["the Orc Guard"] = 3, -- 9
                ["the Orc Sentry"] = 2, -- 6
                ["the Gorthrog Warrior"] = 5, -- 2
                ["the Fell Beast Hatchling"] = 1, -- 6
                ["the Shadow-roost Fell Beast"] = 0, -- 1
            },
            ["Time"] = 8 * 60,
            ["Name"] = "Gath Daeroval",
            ["MaxTrash"] = 45,
            ["Season"] = 0,
        },
        [15] = {
            ["Bosses"] = {
                ["Dolguzigir, the Dark Archivist"] = 1,
            },
            ["Trash"] = {
                ["the Bound Protector"] = 3, -- 8
                ["the Dark Cataloguer"] = 2, -- 3
                ["the Shade of the Past"] = 2, -- 8
                ["the Warden of the Archive"] = 20, -- 2
                ["the Shade of Dark Knowledge"] = 4, -- 3
                ["the Dark Curator"] = 1, -- 10
                ["the Bound Protector"] = 4, -- 2
                ["the Shade of the Past"] = 4, -- 2
            },
            ["Time"] = 15 * 60,
            ["Name"] = "Ghashan-kútot",
            ["MaxTrash"] = 140,
            ["Season"] = 0,
        },
        [16] = {
            ["Bosses"] = {
                ["Shalgoth"] = 1,
                ["Gurzhorn"] = 2,
            },
            ["Trash"] = {
                ["the Morgul Wight"] = 0, -- 3
                ["the Corpse Eater"] = 1, -- 17
                ["the Pile of Bones"] = 10, -- 10
                ["the Kergrim Ravager"] = 1, -- 9 -- 2
                ["the Kergrim Prowler"] = 2, -- 11
                ["the Kergrim Invoker"] = 2, -- 4
                ["the Morgul Barrow-wight"] = 2, -- 10
                ["the Morgul Ritualist"] = 3, -- 15
                ["the Shambling Barrow-wight"] = 5, -- 6

            },
            ["Time"] = 20 * 60,
            ["Name"] = "Gorthad Nûr",
            ["MaxTrash"] = 251,
            ["Season"] = 0,
        },
        [17] = {
            ["Bosses"] = {
                ["The Witch-king"] = 1,
            },
            ["Trash"] = {
                ["The Bane of Rhûn"] = 1, 
                ["The High Sorcerer of Harad"] = 1, 
                ["The Black Blade of Lebennin"] = 1,
                ["The Forsaken Reaver"] = 1,
                ["The Gloom of Nurn"] = 1, 
                ["The Cursed Rider"] = 1, 
                ["The Grim Southron"] = 1, 
                ["The Woe of Khand"] = 1, 

            },
            ["Time"] = 10 * 60,
            ["Name"] = "The Fallen Kings",
            ["MaxTrash"] = 8,
            ["Season"] = 0,
        },
        [32] = {
            ["Bosses"] = {
                ["Aigrith the Ashen"] = 1,
                ["Rúcrog Hoarpelt"] = 2,
                ["Storm of the Witch-king"] = 3,
            },
            ["Trash"] = {
                ["the Angmarim Sorceress"] = 2, -- 13 -- 3
                ["the Angmarim Sorcerer"] = 2, -- 14 -- 5
                ["the Angmarim Captain"] = 5, -- 11
                ["the Gauradan Hunter"] = 1, -- 9
                ["the Gauradan Elder"] = 3, -- 4
                ["the Gauradan Warrior"] = 2, -- 9

            },
            ["Time"] = 12 * 60,
            ["Name"] = "Agoroth",
            ["MaxTrash"] = 148,
            ["Season"] = 1,
        },
        [33] = {
            ["Bosses"] = {
                ["Gulmúk Dampmould"] = 1,
                ["The Morgul Blade"] = 2,
            },
            ["Trash"] = {
                ["the Wood-troll Warrior"] = 3, -- 8 -- 5
                ["the Wood-troll Lobber"] = 3, -- 8 -- 4
                ["the Wood-troll Corruptor"] = 3, -- 12 -- 4
                ["the Accursed Fell-spirit"] = 6, -- 2
                ["the Creeping Root"] = 1, -- 11
            },
            ["Time"] = 6 * 60,
            ["Name"] = "Woe",
            ["MaxTrash"] = 50,
            ["Season"] = 1,
        },
        [36] = {
            ["Bosses"] = {
                ["The Shadowed King"] = 1,
            },
            ["Trash"] = {
                ["the Oozing Darkling"] = 1, -- 11
                ["the Shadowed Dark-maw"] = 2, -- 4
                ["the Frenzied Dark-maw"] = 2, -- 9
                ["the Vigilant Dark-maw"] = 3, -- 3
                ["the Shadowed World-eater"] = 5, -- 1
            },
            ["Time"] = 10 * 60,
            ["Name"] = "Askâd-mazal",
            ["MaxTrash"] = 51,
            ["Season"] = 0,
        },
    }
end

MythicButton = class(Turbine.UI.Lotro.Window)
function MythicButton:Constructor(window)
    Turbine.UI.Window.Constructor(self)
    self.width = 24
    self.height = 24
    self:SetPosition(Settings.MythicPlusButtonX, Settings.MythicPlusButtonY)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(Settings.MythicPlusVisible)
    self:SetMouseVisible(true)
    self:SetBackground(Keystone)

    self.MouseClick = function()
        window:SetVisible(not(window:IsVisible()))
    end

    self.Moving = false

    self.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
  
    self.MouseUp = function()
        self.Moving = false
    end
  
    self.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          self:SetPosition(newLeft,newTop)
        end
    end
    
    self.ToggleMove = function()
      if not(self.MoveBox:IsVisible()) then
        self.ParentVisibleMemory = parent:IsVisible()
      end
      self.MoveBox:SetVisible(not self.MoveBox:IsVisible())
    end

end

MythicPlusViewer = class(Turbine.UI.Lotro.Window)
function MythicPlusViewer:Constructor(dungeonNames, dungeonData)
    Turbine.UI.Lotro.Window.Constructor(self)
    self.width = 500
    self.height = 500
    self:SetPosition(Turbine.UI.Display.GetWidth() / 2 - self.width / 2, Turbine.UI.Display.GetHeight() / 2 - self.height / 2)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(false)
    self:SetMouseVisible(true)
    self:SetText("TEQ Scores")

    self.dungeonData = dungeonData
    self.currentSeason = 1

    self.totalScoreTitleLabel = Turbine.UI.Label()
    self.totalScoreTitleLabel:SetParent(self)
    self.totalScoreTitleLabel:SetSize(200, 20)
    self.totalScoreTitleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.totalScoreTitleLabel:SetMultiline(false)
    self.totalScoreTitleLabel:SetPosition(10, 50)
    self.totalScoreTitleLabel:SetText("TEQ Score: ")

    self.TotalScoreLabel = Turbine.UI.Label()
    self.TotalScoreLabel:SetParent(self)
    self.TotalScoreLabel:SetSize(200, 20)
    self.TotalScoreLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TotalScoreLabel:SetMultiline(false)
    self.TotalScoreLabel:SetPosition(95, 50)
    self.TotalScoreLabel:SetText(0)

    self.SeasonLabel = Turbine.UI.Label()
    self.SeasonLabel:SetParent(self)
    self.SeasonLabel:SetSize(200, 20)
    self.SeasonLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.SeasonLabel:SetMultiline(false)
    self.SeasonLabel:SetPosition(395, 50)
    self.SeasonLabel:SetText("Season: " .. self.currentSeason)

    self.nameLabel = Turbine.UI.Label()
    self.nameLabel:SetParent(self)
    self.nameLabel:SetSize(200, 20)
    self.nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.nameLabel:SetMultiline(false)
    self.nameLabel:SetPosition(10, 80)
    self.nameLabel:SetForeColor(GoldColor)
    self.nameLabel:SetText("Dungeon Name")

    self.tierLabel = Turbine.UI.Label()
    self.tierLabel:SetParent(self)
    self.tierLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.tierLabel:SetSize(200, 15)
    self.tierLabel:SetPosition(220, 80)
    self.tierLabel:SetForeColor(GoldColor)
    self.tierLabel:SetText("Tier")

    self.timeLabel = Turbine.UI.Label()
    self.timeLabel:SetParent(self)
    self.timeLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.timeLabel:SetSize(200, 15)
    self.timeLabel:SetPosition(270, 80)
    self.timeLabel:SetForeColor(GoldColor)
    self.timeLabel:SetText("TEQ Score")

    self.scoreLabel = Turbine.UI.Label()
    self.scoreLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.scoreLabel:SetParent(self)
    self.scoreLabel:SetSize(200, 15)
    self.scoreLabel:SetPosition(370, 80)
    self.scoreLabel:SetForeColor(GoldColor)
    self.scoreLabel:SetText("Time")

    self.container = Turbine.UI.ListBox()
    self.container:SetParent(self)
    self.container:SetSize(480, 380)
    self.container:SetPosition(10, 100)
    --self.container:SetBackColor(GoldColor)
    self.container:SetVisible(true)
    self.container:SetMouseVisible(true)

    self.containerScrollbar = Turbine.UI.Lotro.ScrollBar();
    self.containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    self.containerScrollbar:SetParent( self );
    self.containerScrollbar:SetPosition( 980, 50 );
    self.containerScrollbar:SetSize( 10, 480 );
    self.containerScrollbar:SetVisible(false)

    self.container:SetVerticalScrollBar( self.containerScrollbar );

    self.dungeonNames = dungeonNames
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self:FillItems()
end

function MythicPlusViewer:ClearItems()
    self.container:ClearItems()
end

function MythicPlusViewer:FillItems()
    local items = AccountStats["TEQ"][self.player:GetName()]

    if items == nil then return end

    local maxScores = 0

    for key, value in pairs(items) do
        if self.dungeonData[key]["Season"] == self.currentSeason then
            self.container:AddItem(self:CreateScoreItem(key, value))
            maxScores = maxScores + value["Score"]
        end
    end
    self.TotalScoreLabel:SetText(Round(maxScores, 1))
end

function MythicPlusViewer:CreateScoreItem(id, item)
    local listItemBackground = Turbine.UI.Control();
    listItemBackground:SetBackColor(Turbine.UI.Color(1, 1, 1))
    listItemBackground:SetVisible(true)
    listItemBackground:SetSize( 480, 22 );
    listItemBackground:SetMouseVisible(true) 

    local listItem = Turbine.UI.Control();
    listItem:SetParent(listItemBackground)
    listItem:SetBackColor(Turbine.UI.Color(0, 0, 0))
    listItem:SetPosition(0, 1)
    listItem:SetVisible(true)
    listItem:SetSize( 480, 20 );
    listItem:SetMouseVisible(true) 

    local nameLabel = Turbine.UI.Label()
    nameLabel:SetParent(listItem)
    nameLabel:SetSize(200, 20)
    nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    nameLabel:SetMultiline(false)
    nameLabel:SetText(self.dungeonNames[id])

    local tierLabel = Turbine.UI.Label()
    tierLabel:SetParent(listItem)
    tierLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    tierLabel:SetSize(200, 15)
    tierLabel:SetPosition(210, 0)
    tierLabel:SetText(item["Tier"])

    local timeLabel = Turbine.UI.Label()
    timeLabel:SetParent(listItem)
    timeLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    timeLabel:SetSize(200, 15)
    timeLabel:SetPosition(260, 0)
    timeLabel:SetText(Round(item["Score"], 1))

    local scoreLabel = Turbine.UI.Label()
    scoreLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    scoreLabel:SetParent(listItem)
    scoreLabel:SetSize(200, 15)
    scoreLabel:SetPosition(360, 0)
    scoreLabel:SetText(FormatTimeString(item["Time"]))

    return listItemBackground
end

MplusOptions = class(Turbine.UI.Control)
function MplusOptions:Constructor(parent)
    local width = 750
    local height = 500
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10 - 2, 10 - 2)
    SingleBackground:SetSize(730 + 4, 450 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10, 10)
    SingleBackground:SetSize(730, 450)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local EffectBox = Turbine.UI.Lotro.CheckBox();
    EffectBox:SetParent(SingleBackground)
    EffectBox:SetPosition(10, 10);
    EffectBox:SetSize(200,20);
    EffectBox:SetChecked(Settings.MythicPlusVisible)
    EffectBox:SetText("Dungeon timer visible");
    EffectBox:SetVisible(true);

    EffectBox.CheckedChanged = function()
        Settings.MythicPlusVisible = EffectBox:IsChecked()
    end

end