options = Turbine.UI.Control()
options:SetSize(500, 400)

local MasterOptionsButton = Turbine.UI.Lotro.Button()
MasterOptionsButton:SetParent(options)
MasterOptionsButton:SetPosition(100, 100);
MasterOptionsButton:SetSize(200,15);
MasterOptionsButton:SetText("Open options panel");
MasterOptionsButton:SetVisible(true);

MasterOptionsButton.Click = function()
    if MasterOptions == nil then
        MasterOptions = OptionOptions()
        Windows["OptionsWindow"] = MasterOptions
    else
        MasterOptions:SetVisible(not(MasterOptions:IsVisible()))
    end
end

function GetWindowUI(parent, text, height, settingX, settingY)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(0, height)
    UIElement:SetSize(400, 35)

    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(20 , 0);
    UIElement.windowLabel:SetSize(200,15);
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    UIElement.windowLabel:SetVisible(true);
    UIElement.windowLabel:SetText(text);

    UIElement.windowX = Turbine.UI.TextBox()
    UIElement.windowX:SetParent(UIElement)
    UIElement.windowX:SetBackColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowX:SetForeColor(Turbine.UI.Color(0, 0, 0))
    UIElement.windowX:SetPosition(20 , 15);
    UIElement.windowX:SetSize(100,15);
    UIElement.windowX:SetText(settingX)
    UIElement.windowX:SetVisible(true);

    UIElement.windowY = Turbine.UI.TextBox()
    UIElement.windowY:SetParent(UIElement)
    UIElement.windowY:SetBackColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowY:SetForeColor(Turbine.UI.Color(0, 0, 0))
    UIElement.windowY:SetPosition(130 , 15);
    UIElement.windowY:SetSize(100,15);
    UIElement.windowY:SetText(settingY)
    UIElement.windowY:SetVisible(true);

    UIElement.button = Turbine.UI.Lotro.Button()
    UIElement.button:SetParent(UIElement)
    UIElement.button:SetPosition(240 , 10);
    UIElement.button:SetSize(100,15);
    UIElement.button:SetText("Apply change");
    UIElement.button:SetVisible(true);

    return(UIElement)
end

function GetLabelUI(parent, text, height)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(0, height)
    UIElement:SetSize(600, 30)
    -- NoteWindow
    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(20 , 0);
    UIElement.windowLabel:SetSize(600,30);
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana23);
    UIElement.windowLabel:SetVisible(true);
    UIElement.windowLabel:SetText(text);
    return(UIElement)
end

function GetCheckUI(parent, height, text, checked)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(20, height - 15)
    UIElement:SetSize(200, 40)

    UIElement.cBox = Turbine.UI.Lotro.CheckBox();
    UIElement.cBox:SetParent(UIElement)
    UIElement.cBox:SetPosition(15 , 0);
    UIElement.cBox:SetSize(300,40);
    UIElement.cBox:SetChecked(checked)
    UIElement.cBox:SetText(text);
    UIElement.cBox:SetVisible(true);
    return(UIElement)
end

function GetFontMenu(parent, height, text)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(20, height - 15)
    UIElement:SetSize(400, 50)

    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(0 , 10);
    UIElement.windowLabel:SetSize(200,15);
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    UIElement.windowLabel:SetVisible(true);
    UIElement.windowLabel:SetText("Change font");

    UIElement.menu = Turbine.UI.ContextMenu()
    UIElement.menuItems = UIElement.menu:GetItems()
    for i, fontName in pairs( Fonts ) do
        local menuItem = Turbine.UI.MenuItem( fontName )
        UIElement.menuItems:Add(menuItem)
        --ChatOutput(fontName)
     end

    UIElement.button = Turbine.UI.Lotro.Button()
    UIElement.button:SetParent(UIElement)
    UIElement.button:SetPosition(0, 30);
    UIElement.button:SetSize(200,15);
    UIElement.button:SetText(text);
    UIElement.button:SetVisible(true);

    UIElement.button.Click = function()
        UIElement.menu:ShowMenu()
    end

     return(UIElement)
end

Turbine.UI.Lotro.Font.TimesRoman12 = 0x42000021
Turbine.UI.Lotro.Font.TimesRoman20 = 0x4200000e
Turbine.UI.Lotro.Font.TimesRoman22 = 0x4200000f
Turbine.UI.Lotro.Font.TimesRoman24 = 0x42000010

Fonts = {}
FontsLUT = {}
FontsLUTR = {}
for key, item in pairs(Turbine.UI.Lotro.Font) do
    if ( item ~= "IsA" and item ~= "Undefined" ) then
        --ChatOutput("Key: " .. key .. " Value: " .. item)
        --Fonts[value] = key
       table.insert(Fonts, key)
       
       FontsLUT[key] = item
       FontsLUTR[item] = key

    end
end
table.sort(Fonts)

function GetOptionsBackground(Y, height, colour)
    local OptionsBackground = Turbine.UI.Control()
    OptionsBackground:SetParent(options)
    OptionsBackground:SetSize(500, height)
    OptionsBackground:SetPosition(0, Y)
    OptionsBackground:SetBackColor(colour)
end

function NoteWindowOptions(height) -- 70 height

    GetOptionsBackground(height, 70, Turbine.UI.Color(0, 0, 1))

    -- Note Window
    NoteWindowLabel = GetLabelUI(options, "Note Window Settings:", height) 

    NoteWindowOptions = GetWindowUI(options, "Width              Height", height + 30, Settings.NoteWidth, Settings.NoteHeight)
    NoteWindowOptions.button.Click = function()
        Settings.NoteWidth = NoteWindowOptions.windowX:GetText()
        Settings.NoteHeight = NoteWindowOptions.windowY:GetText()
        ReloadPlugin()
    end
end

Propaganda = class(Turbine.UI.Window)

function Propaganda:Constructor()
  Turbine.UI.Window.Constructor(self);
  local width = 800
  local height = 150
  local x = math.floor(Turbine.UI.Display.GetWidth() / 2 - (width /2))
  local y =  50
  local cooldownTimer = 0
  local maxFadeTimer = 5
  local fadeTimer = maxFadeTimer
  local maxTimer = 0
  local alertEffectName = ""

  self:SetSize(width,height);
  self:SetPosition(x,y);
  self:SetZOrder(1);

  self:SetWantsKeyEvents(false)
  self:SetMouseVisible(false)
  self:SetVisible(true)
  Updater:Subscribe(self)

  local messageTime = Turbine.Engine.GetGameTime() + math.random( 300)
  local showTime = 0

  --self:SetBackColor(GoldColor)

  local Label = Turbine.UI.Label()
  Label:SetParent(self)
  Label:SetSize(width, height)
  Label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  Label:SetMouseVisible(false)
  Label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
  Label:SetFontStyle(Turbine.UI.FontStyle.Outline)
  Label:SetMarkupEnabled(true)
  Label:SetOutlineColor(OutlineColor)
  Label:SetFontStyle( Turbine.UI.FontStyle.Outline )

  self.ExecuteUpdate = function(sender, delta)

    if showTime > 0 then
        showTime = showTime - delta
    else
        Label:SetVisible(false)
    end
    if Turbine.Engine.GetGameTime() > messageTime then
        Label:SetText(PropagandaMessages[math.random( Tablelength(PropagandaMessages) )])
        Label:SetVisible(true)
        showTime = 3
        messageTime = Turbine.Engine.GetGameTime() + math.random( 300, 600)
    end
  end
end

--P = Propaganda()


function EffectOptions(height)  -- 250 height

    GetOptionsBackground(height, 250, Turbine.UI.Color(0.5, 0, 1))
    
    -- Effect alerts
    EffectAlertLabel = GetLabelUI(options, "Effect Alert Settings:", height)

    EffectTestButton = Turbine.UI.Lotro.Button()
    EffectTestButton:SetParent(options)
    EffectTestButton:SetPosition(220, height);
    EffectTestButton:SetSize(100,15);
    EffectTestButton:SetText("Test alert");
    EffectTestButton:SetVisible(true);

    EffectTestButton.Click = function()
        if Settings.EEnabled then
            effectsWindow:Message(10, "<rgb="..GoldHex..">Test</rgb>", AlertIcon, true)
        end
    end

    EffectAlertCheckBox = GetCheckUI(options, height + 30, "Effect alerts enabled", Settings.EEnabled)
    EffectAlertCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.EEnabled = EffectAlertCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end

    EffectAlertOptions = GetWindowUI(options, "Window Width/Height", height + 50, Settings.EWidth, Settings.EHeight)
    EffectAlertOptions.button.Click = function()
        if tonumber(EffectAlertOptions.windowX:GetText()) then
            Settings.EWidth = tonumber(EffectAlertOptions.windowX:GetText())
        end
        if tonumber(EffectAlertOptions.windowY:GetText()) then
            Settings.EHeight = tonumber(EffectAlertOptions.windowY:GetText())
        end
        ReloadPlugin()
    end

    FontMenuEffect = GetFontMenu(options, height + 90, FontsLUTR[Settings.EFont]) 
    for i = 1, FontMenuEffect.menuItems:GetCount() do
        local menuItem = FontMenuEffect.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.EFont = FontsLUT[sender:GetText()]
            FontMenuEffect.button:SetText(Settings.EFont)
            ReloadPlugin()
        end
    end

    --EffectAlertLabel2 = GetLabelUI(options, "Icon size:", height + 130)
    --EffectWindowOptions2 = GetWindowUI(options, "Width              Height", height + 160, Settings.EIWidth, Settings.EIHeight)
    --EffectWindowOptions2.button.Click = function()
    --    Settings.EIWidth = EffectWindowOptions2.windowX:GetText()
    --    Settings.EIHeight = EffectWindowOptions2.windowY:GetText()
    --    ReloadPlugin()
    --end

    EffectAlertCheckBox2 = GetCheckUI(options, height + 200, "Left Icon Enabled", Settings.EL)
    EffectAlertCheckBox2.cBox.CheckedChanged = function(sender,args)
        Settings.EL = EffectAlertCheckBox2.cBox:IsChecked()
        ReloadPlugin()
    end
    EffectAlertCheckBox3 = GetCheckUI(options, height + 220, "Right Icon Enabled", Settings.ER)
    EffectAlertCheckBox3.cBox.CheckedChanged = function(sender,args)
        Settings.ER = EffectAlertCheckBox3.cBox:IsChecked()
        ReloadPlugin()
    end
end

function CountdownOptions(height) -- 110 height

    GetOptionsBackground(height, 110, Turbine.UI.Color(1, 0, 0))

    -- Countdown window
    CountDownLabel = GetLabelUI(options, "Count down Settings:", height)

    CountdownTestButton = Turbine.UI.Lotro.Button()
    CountdownTestButton:SetParent(options)
    CountdownTestButton:SetPosition(250, height);
    CountdownTestButton:SetSize(200,15);
    CountdownTestButton:SetText("Test countdown");
    CountdownTestButton:SetVisible(true);

    CountdownTestButton.Click = function()
        countdownWindow:Countdown(10)
    end

    CountdownWindowOptions = GetWindowUI(options, "CountdownWindow Width| Height", height + 30, Settings.CWidth, Settings.CHeight)
    CountdownWindowOptions.button.Click = function()
        Settings.CWidth = CountdownWindowOptions.windowX:GetText()
        Settings.CHeight = CountdownWindowOptions.windowY:GetText()
        ReloadPlugin()
    end

    FontMenuCountdown = GetFontMenu(options, height + 70, FontsLUTR[Settings.CFont]) 
    for i = 1, FontMenuCountdown.menuItems:GetCount() do
        local menuItem = FontMenuCountdown.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.CFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end
end

function MessageOptions(height) -- 290 height

    GetOptionsBackground(height, 290, Turbine.UI.Color(1, 0.4, 0.4))

    -- Message Window
    MessageWindowLabel = GetLabelUI(options, "Chat Alert Settings:", height)

    MessageTestButton = Turbine.UI.Lotro.Button()
    MessageTestButton:SetParent(options)
    MessageTestButton:SetPosition(220, height);
    MessageTestButton:SetSize(100,15);
    MessageTestButton:SetText("Test alert");
    MessageTestButton:SetVisible(true);
    
    MessageTestButton.Click = function()
        if Settings.MEnabled then
            messageWindow:Message(10, "Test", PuddleIconSmall, true)
        end
    end
    
    MessageWindowCheckBox = GetCheckUI(options, height + 40, "Chat alerts enabled", Settings.MEnabled)
    MessageWindowCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.MEnabled = MessageWindowCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end
    
    MessageWindowLabel2 = GetLabelUI(options, "Window size:", height + 60)
    MessageWindowOptions = GetWindowUI(options, "Width              Height", height + 80, Settings.MWidth, Settings.MHeight)
    MessageWindowOptions.button.Click = function()
        Settings.MWidth = MessageWindowOptions.windowX:GetText()
        Settings.MHeight = MessageWindowOptions.windowY:GetText()
        ReloadPlugin()
    end
    
    FontMenuMessage = GetFontMenu(options, height + 120, FontsLUTR[Settings.MFont]) 
    for i = 1, FontMenuMessage.menuItems:GetCount() do
        local menuItem = FontMenuMessage.menuItems:Get(i)
    
        menuItem.Click = function(sender, args)
            Settings.MFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end
    MessageWindowLabel3 = GetLabelUI(options, "Icon size:", height + 160)
    MessageWindowOptions2 = GetWindowUI(options, "Width              Height", height + 190, Settings.MIWidth, Settings.MIHeight)
    MessageWindowOptions2.button.Click = function()
        Settings.MIWidth = MessageWindowOptions2.windowX:GetText()
        Settings.MIHeight = MessageWindowOptions2.windowY:GetText()
        ReloadPlugin()
    end
    
    MessageWindowCheckBox2 = GetCheckUI(options, height + 230, "Left Icon Enabled", Settings.ML)
    MessageWindowCheckBox2.cBox.CheckedChanged = function(sender,args)
        Settings.ML = MessageWindowCheckBox2.cBox:IsChecked()
        ReloadPlugin()
    end
    MessageWindowCheckBox3 = GetCheckUI(options, height + 250, "Right Icon Enabled", Settings.MR)
    MessageWindowCheckBox3.cBox.CheckedChanged = function(sender,args)
        Settings.MR = MessageWindowCheckBox3.cBox:IsChecked()
        ReloadPlugin()
    end
    
end

function MessageOptions2(height) -- 290 height

    GetOptionsBackground(height, 290, Turbine.UI.Color(1, 0.4, 0.4))

    -- Message Window
    local MessageWindowLabel = GetLabelUI(options, "Chat / Other effects Alert Settings:", height)

    local MessageTestButton = Turbine.UI.Lotro.Button()
    MessageTestButton:SetParent(options)
    MessageTestButton:SetPosition(370, height);
    MessageTestButton:SetSize(100,15);
    MessageTestButton:SetText("Test alert");
    MessageTestButton:SetVisible(true);
    
    MessageTestButton.Click = function()
        if Settings.AEnabled then
            messageWindow:Message(math.random(10, 20), "Test on: oooooooooooooooooo", WebIcon, true)
        end
    end
    
    local MessageWindowCheckBox = GetCheckUI(options, height + 40, "Chat alerts enabled", Settings.AEnabled)
    MessageWindowCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.AEnabled = MessageWindowCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end
    
    local MessageWindowLabel2 = GetLabelUI(options, "Window size:", height + 60)
    MessageWindowOptions = GetWindowUI(options, "Width              Height", height + 80, Settings.AWidth, Settings.AHeight)
    MessageWindowOptions.button.Click = function()
        Settings.AWidth = MessageWindowOptions.windowX:GetText()
        Settings.AHeight = MessageWindowOptions.windowY:GetText()
        ReloadPlugin()
    end

    local MessageWindowLabel2 = GetLabelUI(options, "Window Position:", height + 160)
    MessageWindowOptions = GetWindowUI(options, "X              Y", height + 180, Settings.AX, Settings.AY)
    MessageWindowOptions.button.Click = function()
        Settings.AX = MessageWindowOptions.windowX:GetText()
        Settings.AY = MessageWindowOptions.windowY:GetText()
        messageWindow:SetPosition(Settings.AX, Settings.AY)
        ReloadPlugin()
    end
    
    local FontMenuMessage = GetFontMenu(options, height + 120, FontsLUTR[Settings.AFont]) 
    for i = 1, FontMenuMessage.menuItems:GetCount() do
        local menuItem = FontMenuMessage.menuItems:Get(i)
    
        menuItem.Click = function(sender, args)
            Settings.AFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end
    --MessageWindowLabel3 = GetLabelUI(options, "Icon size:", height + 160)
    --MessageWindowOptions2 = GetWindowUI(options, "Width              Height", height + 190, Settings.AIWidth, Settings.AIHeight)
    --MessageWindowOptions2.button.Click = function()
    --    Settings.AIWidth = MessageWindowOptions2.windowX:GetText()
    --    Settings.AIHeight = MessageWindowOptions2.windowY:GetText()
    --    ReloadPlugin()
    --end
    
    local MessageWindowCheckBox2 = GetCheckUI(options, height + 230, "Left Icon Enabled", Settings.AL)
    MessageWindowCheckBox2.cBox.CheckedChanged = function(sender,args)
        Settings.AL = MessageWindowCheckBox2.cBox:IsChecked()
        ReloadPlugin()
    end
    local MessageWindowCheckBox3 = GetCheckUI(options, height + 250, "Right Icon Enabled", Settings.AR)
    MessageWindowCheckBox3.cBox.CheckedChanged = function(sender,args)
        Settings.AR = MessageWindowCheckBox3.cBox:IsChecked()
        ReloadPlugin()
    end
    
end

function SkillCounterOptions(height) -- 210 height

    GetOptionsBackground(height, 210, Turbine.UI.Color(0.1, 0.1, 0.1))

    -- SkillCounter (Enemies)
    SkillCounterLabel = GetLabelUI(options, "Skill Alert Settings:", height)

    SkillCounterTestButton = Turbine.UI.Lotro.Button()
    SkillCounterTestButton:SetParent(options)
    SkillCounterTestButton:SetPosition(220, height);
    SkillCounterTestButton:SetSize(100,15);
    SkillCounterTestButton:SetText("Test timer");
    SkillCounterTestButton:SetVisible(true);

    SkillCounterTestButton.Click = function()
        if Settings.SEnabled then
            skillCounters:NewTimer(math.random(10, 50), "Test")
        end
    end

    SkillCounterCheckBox = GetCheckUI(options, height + 40, "Enemy skill timers enabled", Settings.SEnabled)
    SkillCounterCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.SEnabled = SkillCounterCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end

    SkillCountersOptions = GetWindowUI(options, "Width              Height", height + 80, Settings.SNewWidth, Settings.SNewHeight)
    SkillCountersOptions.button.Click = function()
        Settings.SNewWidth = SkillCountersOptions.windowX:GetText()
        Settings.SNewHeight = SkillCountersOptions.windowY:GetText()
        ReloadPlugin()
    end

    FontMenuSkillCounter = GetFontMenu(options, height + 130, FontsLUTR[Settings.SNewFont]) 
    for i = 1, FontMenuSkillCounter.menuItems:GetCount() do
        local menuItem = FontMenuSkillCounter.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.SNewFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end

    SkillCountersOptions2 = GetWindowUI(options, "Timer Width/Height", height + 170, Settings.SNewWidth, Settings.SNewTimer)
    SkillCountersOptions2.button.Click = function()
        Settings.SNewWidth = SkillCountersOptions2.windowX:GetText()
        Settings.SNewTimer = SkillCountersOptions2.windowY:GetText()
        ReloadPlugin()
    end
end

function SkillTimerOptions(height) -- 220 height

    GetOptionsBackground(height, 220, Turbine.UI.Color(0, 0.5, 0.5))

    -- Skill timers (Players)
    SkillTimerLabel = GetLabelUI(options, "Player Skill Alert Settings:", height)

    SkillTimerTestButton = Turbine.UI.Lotro.Button()
    SkillTimerTestButton:SetParent(options)
    SkillTimerTestButton:SetPosition(280, height);
    SkillTimerTestButton:SetSize(100,15);
    SkillTimerTestButton:SetText("Test timer");
    SkillTimerTestButton:SetVisible(true);

    SkillTimerTestButton.Click = function()
        if Settings.SPEnabled then
            skillTimers:NewTimer(math.random(10, 50), "Test", "Test", false, 5, false, TyrantIcon, "Test")
            activeTimers:NewTimer(math.random(10, 50), "Test", "Test", false, 5, true, TyrantIcon, "Test")
        end
    end

    SkillTimerCheckBox = GetCheckUI(options, height + 30, "Player timers enabled", Settings.SPEnabled)
    SkillTimerCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.SPEnabled = SkillTimerCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end

    SkillTimerOptions = GetWindowUI(options, "Width              Height", height + 70, Settings.SPWidth2, Settings.SPHeight2)
    SkillTimerOptions.button.Click = function()
        Settings.SPWidth2 = SkillTimerOptions.windowX:GetText()
        Settings.SPHeight2 = SkillTimerOptions.windowY:GetText()
        ReloadPlugin()
    end

    FontMenuSkillTimer = GetFontMenu(options, height + 120, FontsLUTR[Settings.SPNewFont]) 
    for i = 1, FontMenuSkillTimer.menuItems:GetCount() do
        local menuItem = FontMenuSkillTimer.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.SPNewFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end

    --SkillTimersOptions2 = GetWindowUI(options, "Timer Width/Height", height + 170, Settings.SPTimerWidth, Settings.SPTimerHeight)
    --SkillTimersOptions2.button.Click = function()
    --    Settings.SPTimerWidth = SkillTimersOptions2.windowX:GetText()
    --    Settings.SPTimerHeight = SkillTimersOptions2.windowY:GetText()
    --    ReloadPlugin()
    --end
    SkillTimerCheckBox2 = GetCheckUI(options, height + 170, "Player timers active enabled", Settings.SPAEnabled)
    SkillTimerCheckBox2.cBox.CheckedChanged = function(sender,args)
        Settings.SPAEnabled = SkillTimerCheckBox2.cBox:IsChecked()
        ReloadPlugin()
    end
end

function CombatTimerOptions(height) -- 150 height

    GetOptionsBackground(height, 150, Turbine.UI.Color(0.5, 0.5, 0.5))

    -- Combat timer window
    CombatTimerLabel = GetLabelUI(options, "Combat timer window Settings:", height)

    CombatTimerCheckBox = GetCheckUI(options, height + 40, "Combat timer enabled", Settings.CTEnabled)
    CombatTimerCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.CTEnabled = CombatTimerCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end

    CombatTimerWindowOptions = GetWindowUI(options, " Width| Height", height + 70, Settings.CTWidth, Settings.CTHeight)
    CombatTimerWindowOptions.button.Click = function()
        Settings.CTWidth = CombatTimerWindowOptions.windowX:GetText()
        Settings.CTHeight = CombatTimerWindowOptions.windowY:GetText()
        ReloadPlugin()
    end

    FontMenuCombatTimer = GetFontMenu(options, height + 110, FontsLUTR[Settings.CTFont]) 
    for i = 1, FontMenuCombatTimer.menuItems:GetCount() do
        local menuItem = FontMenuCombatTimer.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.CTFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end
end

function LeaderWindowOptions(height) -- 70 height

    GetOptionsBackground(height, 70, Turbine.UI.Color(0, 0, 0))

    -- Leader window
    LeaderWindowLabel = GetLabelUI(options, "Leader window Settings:", height)

    LeaderWindowCheckbox = GetCheckUI(options, height + 30, "Leader window enabled", Settings.LWEnabled)
    LeaderWindowCheckbox.cBox.CheckedChanged = function(sender,args)
        Settings.LWEnabled = LeaderWindowCheckbox.cBox:IsChecked()
        ReloadPlugin()
    end
end

function LogWindowOptions(height) -- 70 height

    GetOptionsBackground(height, 70, Turbine.UI.Color(0.5, 0.5, 0))

    -- Log window
    LogWindowLabel = GetLabelUI(options, "Log window Settings:", height)

    LogWindowCheckbox = GetCheckUI(options, height + 30, "Log window enabled", Settings.LEnabled)
    LogWindowCheckbox.cBox.CheckedChanged = function(sender,args)
        Settings.LEnabled = LogWindowCheckbox.cBox:IsChecked()
        ReloadPlugin()
    end
end

function RatTrackerOptions(height)
    GetOptionsBackground(height, 70, Turbine.UI.Color(0, 0, 1))

    -- Log window
    RatTrackerLabel = GetLabelUI(options, "Rat tracker Settings:", height)

    RatTrackerCheckbox = GetCheckUI(options, height + 30, "Rat tracker enabled", Settings.REnabled)
    RatTrackerCheckbox.cBox.CheckedChanged = function(sender,args)
        Settings.REnabled = RatTrackerCheckbox.cBox:IsChecked()
        ReloadPlugin()
    end
end

function ResetLabelOptions(height) -- 70 height

    GetOptionsBackground(height, 70, Turbine.UI.Color(0, 0, 0))

    -- Reset to default settings
    ResetLabel = GetLabelUI(options, "Reset to Default Settings:", height)

    ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(options)
    ResetButton:SetPosition(20, height + 30);
    ResetButton:SetSize(100,15);
    ResetButton:SetText("Reset");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        Settings.Reload = true
        ReloadPlugin()
    end
end

--NoteWindowOptions(0) -- 70 height
--EffectOptions(70) -- 250 height
--CountdownOptions(320) -- 110 height
--MessageOptions2(430) -- 290 height
--SkillCounterOptions(720) -- 210 height
--SkillTimerOptions(930) -- 220 height
--CombatTimerOptions(1150) -- 150 height
--LeaderWindowOptions(1300) -- 70 height
--LogWindowOptions(1370) -- 70 height
--RatTrackerOptions(1440) -- 70 height
--ResetLabelOptions(1440) -- 70 height

plugin.GetOptionsPanel = function( self )
    return options;
end

function SetCommands()
    Command = Turbine.ShellCommand()

    function Command:Execute( _, command )
        if command ~= nil or string.len( command ) ~= 0 then
            if command == "options" then
                if MasterOptions == nil then
                    MasterOptions = OptionOptions()
                    Windows["OptionsWindow"] = MasterOptions
                else
                    MasterOptions:SetVisible(not(MasterOptions:IsVisible()))
                end
            elseif command == "reload" then
                ReloadPlugin()
            elseif command == "move" then
                MoveWindow(true)
            elseif command == "lock" then
                MoveWindow(false)
            elseif command == "help" then
                ChatOutput(HelpString)
            elseif command == "loot" then
                if Settings.LOEnabled then lootWindow:SetVisible(not(lootWindow:IsVisible())) end 
            elseif command == "dungeon" then
                if DungeonWindow ~= nil then DungeonWindow:SetVisible(not(DungeonWindow:IsVisible())) end 
            elseif command == "features" then
                ChatOutput(Features)
            elseif command == "reset" then
                GetDefaultSettings()
                ReloadPlugin()
            elseif command == "clear" then
                ClearUI()
            elseif command == "time" then
                ChatOutput("Beginning of Prime time: " .. BeginningOfPrimeTime)
            elseif command == "soundtest" then
                Sounds:PlaySoundEffect(SoundEffects["Test"])
            elseif command == "ready" then
                if Party ~= nil then
                    if Party:GetLeader():GetName() == Player:GetName() then
                        RCButtonWindow:SetVisible(true)
                    end
                else
                    ChatOutput("You are not in a party!")
                end
            elseif command == "party" then
                if Party ~= nil then
                    if not(ReadyCheck:IsVisible()) then
                        ReadyCheck:SetVisible(true)
                        ReadyCheck:MakeNewReadyCheck()
                    end
                else
                    ChatOutput("You are not in a party!")
                end
            elseif command == "noteClear" then
                noteWindow.noteWindow:SetText("")
            else
                ChatOutput( "Non-existing command" )
            end
        end
    end
    
    Turbine.Shell.AddCommand( "prime", Command )
end

-- Reworked option panels

-- Effect alerts
EffectSettings = class(Turbine.UI.Control)
function EffectSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(10,30);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    --GetOptionsBackground(height, 250, Turbine.UI.Color(0.5, 0, 1))

    local height = 0
    
    -- Effect alerts
    local EffectAlertLabel = GetLabelUI(self, "Effect Alert Settings:", height)

    local EffectTestButton = Turbine.UI.Lotro.Button()
    EffectTestButton:SetParent(self)
    EffectTestButton:SetPosition(220, height);
    EffectTestButton:SetSize(100,15);
    EffectTestButton:SetText("Test alert");
    EffectTestButton:SetVisible(true);

    EffectTestButton.Click = function()
        if Settings.EEnabled then
            effectsWindow:Message(10, "<rgb="..GoldHex..">Test</rgb>", AlertIcon, true, "", true)
        end
    end

    local EffectAlertCheckBox = GetCheckUI(self, height + 30, "Effect alerts enabled", Settings.EEnabled)
    EffectAlertCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.EEnabled = EffectAlertCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end

    local EffectAlertOptions = GetWindowUI(self, "Window Width/Height", height + 50, Settings.EWidth, Settings.EHeight)
    EffectAlertOptions.button.Click = function()
        Settings.EWidth = EffectAlertOptions.windowX:GetText()
        Settings.EHeight = EffectAlertOptions.windowY:GetText()
        ReloadPlugin()
    end

    local FontMenuEffect = GetFontMenu(self, height + 90, FontsLUTR[Settings.EFont]) 
    for i = 1, FontMenuEffect.menuItems:GetCount() do
        local menuItem = FontMenuEffect.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.EFont = FontsLUT[sender:GetText()]
            FontMenuEffect.button:SetText(Settings.EFont)
            ReloadPlugin()
        end
    end

    --EffectAlertLabel2 = GetLabelUI(options, "Icon size:", height + 130)
    --EffectWindowOptions2 = GetWindowUI(options, "Width              Height", height + 160, Settings.EIWidth, Settings.EIHeight)
    --EffectWindowOptions2.button.Click = function()
    --    Settings.EIWidth = EffectWindowOptions2.windowX:GetText()
    --    Settings.EIHeight = EffectWindowOptions2.windowY:GetText()
    --    ReloadPlugin()
    --end

    local EffectAlertCheckBox2 = GetCheckUI(self, height + 200, "Left Icon Enabled", Settings.EL)
    EffectAlertCheckBox2.cBox.CheckedChanged = function(sender,args)
        Settings.EL = EffectAlertCheckBox2.cBox:IsChecked()
        ReloadPlugin()
    end
    
    local EffectAlertCheckBox3 = GetCheckUI(self, height + 220, "Right Icon Enabled", Settings.ER)
    EffectAlertCheckBox3.cBox.CheckedChanged = function(sender,args)
        Settings.ER = EffectAlertCheckBox3.cBox:IsChecked()
        ReloadPlugin()
    end
end

-- Countdown options
CountdownSettings = class(Turbine.UI.Control)
function CountdownSettings:Constructor(parent)

    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(10,30);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    local height = 0

    --GetOptionsBackground(self, 110, Turbine.UI.Color(1, 0, 0))

    -- Countdown window
    local CountDownLabel = GetLabelUI(self, "Count down Settings:", height)

    local CountdownTestButton = Turbine.UI.Lotro.Button()
    CountdownTestButton:SetParent(self)
    CountdownTestButton:SetPosition(250, height);
    CountdownTestButton:SetSize(200,15);
    CountdownTestButton:SetText("Test countdown");
    CountdownTestButton:SetVisible(true);

    CountdownTestButton.Click = function()
        countdownWindow:Countdown(10)
    end

    local CountdownWindowOptions = GetWindowUI(self, "CountdownWindow Width| Height", height + 30, Settings.CWidth, Settings.CHeight)
    CountdownWindowOptions.button.Click = function()
        Settings.CWidth = CountdownWindowOptions.windowX:GetText()
        Settings.CHeight = CountdownWindowOptions.windowY:GetText()
        ReloadPlugin()
    end

    local FontMenuCountdown = GetFontMenu(self, height + 70, FontsLUTR[Settings.CFont]) 
    for i = 1, FontMenuCountdown.menuItems:GetCount() do
        local menuItem = FontMenuCountdown.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.CFont = FontsLUT[sender:GetText()]
            ReloadPlugin()
        end
    end
end

-- Alert options
AlertSettings = class(Turbine.UI.Control)
function AlertSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(10,30);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    local height = 0

    --GetOptionsBackground(height, 290, Turbine.UI.Color(1, 0.4, 0.4))

    -- Message Window
    local MessageWindowLabel = GetLabelUI(self, "Chat / Other effects Alert Settings:", height)

    local MessageTestButton = Turbine.UI.Lotro.Button()
    MessageTestButton:SetParent(self)
    MessageTestButton:SetPosition(370, height);
    MessageTestButton:SetSize(100,15);
    MessageTestButton:SetText("Test alert");
    MessageTestButton:SetVisible(true);
    
    MessageTestButton.Click = function()
        if Settings.AEnabled then
            messageWindow:Message(math.random(10, 20), "Test on: oooooooooooooooooo", WebIcon, true)
        end
    end
    
    local MessageWindowCheckBox = GetCheckUI(self, height + 40, "Chat alerts enabled", Settings.AEnabled)
    MessageWindowCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.AEnabled = MessageWindowCheckBox.cBox:IsChecked()
        MasterOptions:ChangesMade()
    end
    
    local MessageWindowLabel2 = GetLabelUI(self, "Window size:", height + 60)
    MessageWindowOptions = GetWindowUI(self, "Width              Height", height + 80, Settings.AWidth, Settings.AHeight)
    MessageWindowOptions.button.Click = function()
        Settings.AWidth = MessageWindowOptions.windowX:GetText()
        Settings.AHeight = MessageWindowOptions.windowY:GetText()
        MasterOptions:ChangesMade()
    end

    local MessageWindowLabel2 = GetLabelUI(self, "Window Position:", height + 160)
    MessageWindowOptionsPos = GetWindowUI(self, "X              Y", height + 180, Settings.AX, Settings.AY)
    MessageWindowOptionsPos.button.Click = function()
        Settings.AX = MessageWindowOptionsPos.windowX:GetText()
        Settings.AY = MessageWindowOptionsPos.windowY:GetText()
        messageWindow:SetPosition(Settings.AX, Settings.AY)
        MasterOptions:ChangesMade()
    end
    
    local FontMenuMessage = GetFontMenu(self, height + 120, FontsLUTR[Settings.AFont]) 
    for i = 1, FontMenuMessage.menuItems:GetCount() do
        local menuItem = FontMenuMessage.menuItems:Get(i)
    
        menuItem.Click = function(sender, args)
            Settings.AFont = FontsLUT[sender:GetText()]
            MasterOptions:ChangesMade()
        end
    end
    
end

-- Boss cds
BossTimerSettings = class(Turbine.UI.Control)
function BossTimerSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(10,30);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    local height = 0

    -- SkillCounter (Enemies)
    local SkillCounterLabel = GetLabelUI(self, "Timer Settings:", height)

    local SkillCounterTestButton = Turbine.UI.Lotro.Button()
    SkillCounterTestButton:SetParent(self)
    SkillCounterTestButton:SetPosition(220, height);
    SkillCounterTestButton:SetSize(100,15);
    SkillCounterTestButton:SetText("Test timer");
    SkillCounterTestButton:SetVisible(true);

    SkillCounterTestButton.Click = function()
        if Settings.SEnabled then
            skillCounters:NewTimer(math.random(10, 50), "Test")
        end
    end

    local FontMenuSkillCounter = GetFontMenu(self, height + 130, FontsLUTR[Settings.SNewFont]) 
    for i = 1, FontMenuSkillCounter.menuItems:GetCount() do
        local menuItem = FontMenuSkillCounter.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.SNewFont = FontsLUT[sender:GetText()]
            MasterOptions:ChangesMade()
        end
    end

    local WidthBackground = Turbine.UI.Control()
    WidthBackground:SetParent(self)
    WidthBackground:SetPosition(20, 330)
    WidthBackground:SetSize(300, 200)
    WidthBackground:SetMouseVisible(false)
    WidthBackground:SetVisible(true)
    --WidthBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local timerBox = Turbine.UI.Lotro.TextBox()
    timerBox:SetParent(WidthBackground)
    timerBox:SetSize(50, 20)
    timerBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    timerBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    timerBox:SetPosition(15, 0)
    timerBox:SetText(Settings.SNewWidth)
    
    self.colourScheme = {Turbine.UI.Color(0.8,0,0,0), Turbine.UI.Color(0.8,0,0,0), TimerColourNormal5, Turbine.UI.Color(1,1,1), Turbine.UI.Color(0,0,0), Turbine.UI.Color(0.6,0.5,0,0), Settings.BossTimersFrontTexture, Settings.BossTimersBackTexture, Settings.BossTimersFrontOpacity, Settings.BossTimersBackOpacity}
    self.ExampleTimer = EffectTimer(WidthBackground, Settings.SPWidth2, 20, nil, "Test",  Settings.SPNewFont, self.colourScheme, true, nil, 20, 0x411172A2)
    self.ExampleTimer:SetPosition(130, 60)
    self.duration = 20

    self.ExecuteUpdate = function(delta)
        self.duration = self.duration - delta
    
        if self.duration < 2 then 
            self.duration = 20 
            self.ExampleTimer:ChangeDuration(self.duration)
        end
        self.ExampleTimer:UpdateText(delta)
    end

    self.callback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate)


    local sizeButton = Turbine.UI.Lotro.Button()
    sizeButton:SetParent(WidthBackground)
    sizeButton:SetSize(80, 20)
    sizeButton:SetPosition(5, 20)
    sizeButton:SetText("Set Width") 

    sizeButton.Click = function()
        Settings.SNewWidth = tonumber(timerBox:GetText())
        ChatOutput("Changed skill timer width to " .. tonumber(timerBox:GetText()))
    end

    local opacityBox = Turbine.UI.Lotro.TextBox()
    opacityBox:SetParent(WidthBackground)
    opacityBox:SetSize(50, 20)
    opacityBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    opacityBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    opacityBox:SetPosition(105, 0)
    opacityBox:SetText(Settings.BossTimersFrontOpacity)

    local opacityButton = Turbine.UI.Lotro.Button()
    opacityButton:SetParent(WidthBackground)
    opacityButton:SetSize(120, 20)
    opacityButton:SetPosition(90, 20)
    opacityButton:SetText("Set Front Opacity") 

    opacityButton.Click = function()
        Settings.BossTimersFrontOpacity = tonumber(opacityBox:GetText())
        ChatOutput("Changed skill timer bar opacity to " .. tonumber(opacityBox:GetText()))
        self.ExampleTimer:ChangeFrontOpacity(Settings.BossTimersFrontOpacity)
    end

    local opacityBackBox = Turbine.UI.Lotro.TextBox()
    opacityBackBox:SetParent(WidthBackground)
    opacityBackBox:SetSize(50, 20)
    opacityBackBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    opacityBackBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    opacityBackBox:SetPosition(15, 40)
    opacityBackBox:SetText(Settings.BossTimersBackOpacity)

    local opacityButtonBack = Turbine.UI.Lotro.Button()
    opacityButtonBack:SetParent(WidthBackground)
    opacityButtonBack:SetSize(120, 20)
    opacityButtonBack:SetPosition(0, 60)
    opacityButtonBack:SetText("Set Back Opacity") 

    opacityButtonBack.Click = function()
        Settings.BossTimersBackOpacity = tonumber(opacityBackBox:GetText())
        ChatOutput("Changed skill timer bar back opacity to " .. tonumber(opacityBackBox:GetText()))
        self.ExampleTimer:ChangeBackOpacity(Settings.BossTimersBackOpacity)
    end

    local frontbutton = Turbine.UI.Lotro.Button()
    frontbutton:SetParent(WidthBackground)
    frontbutton:SetPosition(0, 80);
    frontbutton:SetSize(150,15);
    frontbutton:SetText("Timer Texture");
    frontbutton:SetVisible(true);

    -- [[
    local sortedNames1 = {}
    for key, value in pairs(bars) do table.insert( sortedNames1, key ) end
    table.sort( sortedNames1 )
    
    self.frontmenu = Turbine.UI.ContextMenu()
    self.frontmenuItems = self.frontmenu:GetItems()

    self.frontBar = nil

    for key, value in pairs(sortedNames1) do
        local frontmenuItem = Turbine.UI.MenuItem( value )
        frontmenuItem.Click = function()
            self.frontBar = value
            Settings.BossTimersFrontTexture = self.frontBar 
            self.ExampleTimer:ChangeFrontTexture(Settings.BossTimersFrontTexture)
        end
        self.frontmenuItems:Add(frontmenuItem)
    end

    local frontmenuItemNil = Turbine.UI.MenuItem( "None" )
    frontmenuItemNil.Click = function()
        Settings.BossTimersFrontTexture = nil
        self.ExampleTimer:ChangeFrontTexture(Settings.BossTimersFrontTexture)
    end
    self.frontmenuItems:Add(frontmenuItemNil)
        --]]




    frontbutton.Click = function()
        self.frontmenu:ShowMenu()
    end

    local backbutton = Turbine.UI.Lotro.Button()
    backbutton:SetParent(WidthBackground)
    backbutton:SetPosition(0, 100);
    backbutton:SetSize(150,15);
    backbutton:SetText("Background Texture");
    backbutton:SetVisible(true);


    self.backbar = nil
    -- [[
    self.backmenu = Turbine.UI.ContextMenu()
    self.backmenuItems = self.backmenu:GetItems()

    local sortedNames2 = {}
    for key, value in pairs(bars) do table.insert( sortedNames2, key ) end
    table.sort( sortedNames2 )

    for key, value in pairs(sortedNames2) do
        local backmenuItem = Turbine.UI.MenuItem( value )
        backmenuItem.Click = function()
            self.backbar = value
            Settings.BossTimersBackTexture = self.backbar
            self.ExampleTimer:ChangeBackTexture(Settings.BossTimersBackTexture)
        end
        self.backmenuItems:Add(backmenuItem)
    end
    local backmenuItemNil = Turbine.UI.MenuItem( "None" )
    backmenuItemNil.Click = function()
        Settings.BossTimersBackTexture = nil
        self.ExampleTimer:ChangeBackTexture(Settings.BossTimersBackTexture)
    end
    self.backmenuItems:Add(backmenuItemNil)
        --]]

    backbutton.Click = function()
        self.backmenu:ShowMenu()
    end
end


-- Skill timers
SkillTimerOptions = class(Turbine.UI.Control)
function SkillTimerOptions:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(10,30);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    local height = 0

    -- Skill timers (Players)
    local SkillTimerLabel = GetLabelUI(self, "Player Skill Alert Settings:", height)

    local SkillTimerTestButton = Turbine.UI.Lotro.Button()
    SkillTimerTestButton:SetParent(self)
    SkillTimerTestButton:SetPosition(280, height);
    SkillTimerTestButton:SetSize(100,15);
    SkillTimerTestButton:SetText("Test timer");
    SkillTimerTestButton:SetVisible(true);

    SkillTimerTestButton.Click = function()
        if Settings.SPEnabled then
            skillTimers:NewTimer(math.random(10, 50), "Test", "Test", false, 5, false, TyrantIcon, "Test")
            activeTimers:NewTimer(math.random(10, 50), "Test", "Test", false, 5, true, TyrantIcon, "Test")
        end
    end

    local SkillTimerCheckBox = GetCheckUI(self, height + 30, "Player timers enabled", Settings.SPEnabled)
    SkillTimerCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.SPEnabled = SkillTimerCheckBox.cBox:IsChecked()
        MasterOptions:ChangesMade()
    end

    -- [[
    local SkillTimerOptions = GetWindowUI(self, "Width              Height", height + 70, Settings.SPWidth2, Settings.SPHeight2)
    SkillTimerOptions.button.Click = function()
        Settings.SPWidth2 = SkillTimerOptions.windowX:GetText()
        Settings.SPHeight2 = SkillTimerOptions.windowY:GetText()
        MasterOptions:ChangesMade()
    end
    --]]

    local FontMenuSkillTimer = GetFontMenu(self, height + 120, FontsLUTR[Settings.SPNewFont]) 
    for i = 1, FontMenuSkillTimer.menuItems:GetCount() do
        local menuItem = FontMenuSkillTimer.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.SPNewFont = FontsLUT[sender:GetText()]
            MasterOptions:ChangesMade()
        end
    end

    --SkillTimersOptions2 = GetWindowUI(options, "Timer Width/Height", height + 170, Settings.SPTimerWidth, Settings.SPTimerHeight)
    --SkillTimersOptions2.button.Click = function()
    --    Settings.SPTimerWidth = SkillTimersOptions2.windowX:GetText()
    --    Settings.SPTimerHeight = SkillTimersOptions2.windowY:GetText()
    --    ReloadPlugin()
    --end
    local CheckWindow = CheckWindowTemplate(self, Settings.SPEnabled, "Enable Skill Tracking", 50, 240)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.SPEnabled = CheckWindow:IsChecked()
    end

    local CheckWindow = CheckWindowTemplate(self, Settings.SPCDEnabled, "Enable Skill Cooldown Timers", 50, 260)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.SPCDEnabled = CheckWindow:IsChecked()
    end

    local CheckWindow = CheckWindowTemplate(self, Settings.SPActiveEnabled, "Enable Active Timers", 50, 280)
    CheckWindow.CheckedChanged = function(sender,args)
        Settings.SPActiveEnabled = CheckWindow:IsChecked()
    end

    local ScaleBox = Turbine.UI.Lotro.TextBox()
    ScaleBox:SetParent(self)
    ScaleBox:SetSize(50, 30)
    ScaleBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ScaleBox:SetPosition(550, 14)
    ScaleBox:SetText(Settings.SkillTimerScale)

    local ScaleButton = Turbine.UI.Lotro.Button()
    ScaleButton:SetParent(self)
    ScaleButton:SetSize(100, 30)
    ScaleButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ScaleButton:SetMouseVisible(false)
    ScaleButton:SetPosition(630, 20)
    ScaleButton:SetText("Set Scale")

    ScaleButton.Click = function()
        if ScaleBox:GetText() ~= "" and ScaleBox:GetText() ~= nil and ScaleBox:GetText() ~= Settings.SkillTimerScale then
            Settings.SkillTimerScale = tonumber(ScaleBox:GetText())
        end
    end

    local SortLabel = Turbine.UI.Label()
    SortLabel:SetParent(self)
    SortLabel:SetPosition(50, 330)
    SortLabel:SetSize(400, 20)
    SortLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold22)
    SortLabel:SetText("Sort type")

    -- Skill timer
    local EffectBox1 = Turbine.UI.Lotro.CheckBox();
    EffectBox1:SetParent(self)
    EffectBox1:SetPosition(50, 350);
    EffectBox1:SetSize(400,20);
    EffectBox1:SetChecked(Settings.SkilltimerSorting == 1)
    EffectBox1:SetText("Skills timer top to bottom");
    EffectBox1:SetVisible(true);

    local EffectBox2 = Turbine.UI.Lotro.CheckBox();
    EffectBox2:SetParent(self)
    EffectBox2:SetPosition(50, 370);
    EffectBox2:SetSize(400,20);
    EffectBox2:SetChecked(Settings.SkilltimerSorting == 2)
    EffectBox2:SetText("Skills timer bottom to top");
    EffectBox2:SetVisible(true);

    EffectBox1.CheckedChanged = function()
        if EffectBox1:IsChecked() then
            Settings.SkilltimerSorting = 1
            EffectBox2:SetChecked(false)
        end
        MasterOptions:ChangesMade()
    end

    EffectBox2.CheckedChanged = function()
        if EffectBox2:IsChecked() then
            Settings.SkilltimerSorting = 2
            EffectBox1:SetChecked(false)
        end
        MasterOptions:ChangesMade()
    end

    -- Active timers
    local EffectBox1 = Turbine.UI.Lotro.CheckBox();
    EffectBox1:SetParent(self)
    EffectBox1:SetPosition(50, 400);
    EffectBox1:SetSize(400,20);
    EffectBox1:SetChecked(Settings.ActivetimerSorting == 1)
    EffectBox1:SetText("Active timer top to bottom");
    EffectBox1:SetVisible(true);

    local EffectBox2 = Turbine.UI.Lotro.CheckBox();
    EffectBox2:SetParent(self)
    EffectBox2:SetPosition(50, 420);    
    EffectBox2:SetSize(400,20);
    EffectBox2:SetChecked(Settings.ActivetimerSorting == 2)
    EffectBox2:SetText("Active timer bottom to top");
    EffectBox2:SetVisible(true);

    EffectBox1.CheckedChanged = function()
        if EffectBox1:IsChecked() then
            Settings.EffectVersion = 1
            EffectBox2:SetChecked(false)
        end
        MasterOptions:ChangesMade()
    end

    EffectBox2.CheckedChanged = function()
        if EffectBox2:IsChecked() then
            Settings.EffectVersion = 2
            EffectBox1:SetChecked(false)
        end
        MasterOptions:ChangesMade()
    end

    local EffectBox6 = Turbine.UI.Lotro.CheckBox();
    EffectBox6:SetParent(self)
    EffectBox6:SetPosition(350, 370);
    EffectBox6:SetSize(400,20);
    EffectBox6:SetChecked(Settings.SPInstance)
    EffectBox6:SetText("Only show timers when in instances");
    EffectBox6:SetVisible(true);
    EffectBox6.CheckedChanged = function()
        Settings.SPInstance = EffectBox6:IsChecked()
    end
    
    local WidthBackground = Turbine.UI.Control()
    WidthBackground:SetParent(self)
    WidthBackground:SetPosition(400, 150)
    WidthBackground:SetSize(200, 200)
    WidthBackground:SetMouseVisible(false)
    WidthBackground:SetVisible(true)
    --WidthBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local timerBox = Turbine.UI.Lotro.TextBox()
    timerBox:SetParent(WidthBackground)
    timerBox:SetSize(50, 20)
    timerBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    timerBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    timerBox:SetPosition(15, 0)
    timerBox:SetText(Settings.SPWidth2)
    
    self.colourScheme = {Turbine.UI.Color(0.8,0,0,0), Turbine.UI.Color(0.8,0,0,0), TimerColourNormal5, Turbine.UI.Color(1,1,1), Turbine.UI.Color(0,0,0), Turbine.UI.Color(0.6,0.5,0,0), Settings.SkillTimersFrontTexture, Settings.SkillTimersBackTexture, Settings.SkillTimersFrontOpacity, Settings.SkillTimersBackOpacity}
    self.ExampleTimer = EffectTimer(WidthBackground, Settings.SPWidth2, 20, nil, "Test",  Settings.SPNewFont, self.colourScheme, true, nil, 20, 0x411172A2)
    self.ExampleTimer:SetPosition(130, 60)
    self.duration = 20

    self.ExecuteUpdate = function(delta)
        self.duration = self.duration - delta
    
        if self.duration < 2 then 
            self.duration = 20 
            self.ExampleTimer:ChangeDuration(self.duration)
        end
        self.ExampleTimer:UpdateText(delta)
    end

    self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate)


    local sizeButton = Turbine.UI.Lotro.Button()
    sizeButton:SetParent(WidthBackground)
    sizeButton:SetSize(80, 20)
    sizeButton:SetPosition(5, 20)
    sizeButton:SetText("Set Width") 

    sizeButton.Click = function()
        Settings.SPWidth2 = tonumber(timerBox:GetText())
        ChatOutput("Changed skill timer width to " .. tonumber(timerBox:GetText()))
    end

    local opacityBox = Turbine.UI.Lotro.TextBox()
    opacityBox:SetParent(WidthBackground)
    opacityBox:SetSize(50, 20)
    opacityBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    opacityBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    opacityBox:SetPosition(105, 0)
    opacityBox:SetText(Settings.SkillTimersFrontOpacity)

    local opacityButton = Turbine.UI.Lotro.Button()
    opacityButton:SetParent(WidthBackground)
    opacityButton:SetSize(120, 20)
    opacityButton:SetPosition(90, 20)
    opacityButton:SetText("Set Front Opacity") 

    opacityButton.Click = function()
        Settings.SkillTimersFrontOpacity = tonumber(opacityBox:GetText())
        ChatOutput("Changed skill timer bar opacity to " .. tonumber(opacityBox:GetText()))
        self.ExampleTimer:ChangeFrontOpacity(Settings.SkillTimersFrontOpacity)
    end

    local opacityBackBox = Turbine.UI.Lotro.TextBox()
    opacityBackBox:SetParent(WidthBackground)
    opacityBackBox:SetSize(50, 20)
    opacityBackBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    opacityBackBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    opacityBackBox:SetPosition(15, 40)
    opacityBackBox:SetText(Settings.SkillTimersBackOpacity)

    local opacityButtonBack = Turbine.UI.Lotro.Button()
    opacityButtonBack:SetParent(WidthBackground)
    opacityButtonBack:SetSize(120, 20)
    opacityButtonBack:SetPosition(0, 60)
    opacityButtonBack:SetText("Set Back Opacity") 

    opacityButtonBack.Click = function()
        Settings.SkillTimersBackOpacity = tonumber(opacityBackBox:GetText())
        ChatOutput("Changed skill timer bar back opacity to " .. tonumber(opacityBackBox:GetText()))
        self.ExampleTimer:ChangeBackOpacity(Settings.SkillTimersBackOpacity)
    end

    local frontbutton = Turbine.UI.Lotro.Button()
    frontbutton:SetParent(WidthBackground)
    frontbutton:SetPosition(0, 80);
    frontbutton:SetSize(150,15);
    frontbutton:SetText("Timer Texture");
    frontbutton:SetVisible(true);

    -- [[
    local sortedNames1 = {}
    for key, value in pairs(bars) do table.insert( sortedNames1, key ) end
    table.sort( sortedNames1 )
    
    self.frontmenu = Turbine.UI.ContextMenu()
    self.frontmenuItems = self.frontmenu:GetItems()

    self.frontBar = nil

    for key, value in pairs(sortedNames1) do
        local frontmenuItem = Turbine.UI.MenuItem( value )
        frontmenuItem.Click = function()
            self.frontBar = value
            Settings.SkillTimersFrontTexture = self.frontBar 
            self.ExampleTimer:ChangeFrontTexture(Settings.SkillTimersFrontTexture)
        end
        self.frontmenuItems:Add(frontmenuItem)
    end

    local frontmenuItemNil = Turbine.UI.MenuItem( "None" )
    frontmenuItemNil.Click = function()
        Settings.SkillTimersFrontTexture = nil
        self.ExampleTimer:ChangeFrontTexture(Settings.SkillTimersFrontTexture)
    end
    self.frontmenuItems:Add(frontmenuItemNil)
        --]]




    frontbutton.Click = function()
        self.frontmenu:ShowMenu()
    end

    local backbutton = Turbine.UI.Lotro.Button()
    backbutton:SetParent(WidthBackground)
    backbutton:SetPosition(0, 100);
    backbutton:SetSize(150,15);
    backbutton:SetText("Background Texture");
    backbutton:SetVisible(true);


    self.backbar = nil
    -- [[
    self.backmenu = Turbine.UI.ContextMenu()
    self.backmenuItems = self.backmenu:GetItems()

    local sortedNames2 = {}
    for key, value in pairs(bars) do table.insert( sortedNames2, key ) end
    table.sort( sortedNames2 )

    for key, value in pairs(sortedNames2) do
        local backmenuItem = Turbine.UI.MenuItem( value )
        backmenuItem.Click = function()
            self.backbar = value
            Settings.SkillTimersBackTexture = self.backbar
            self.ExampleTimer:ChangeBackTexture(Settings.SkillTimersBackTexture)
        end
        self.backmenuItems:Add(backmenuItem)
    end
    local backmenuItemNil = Turbine.UI.MenuItem( "None" )
    backmenuItemNil.Click = function()
        Settings.SkillTimersBackTexture = nil
        self.ExampleTimer:ChangeBackTexture(Settings.SkillTimersBackTexture)
    end
    self.backmenuItems:Add(backmenuItemNil)
        --]]

    backbutton.Click = function()
        self.backmenu:ShowMenu()
    end
end

-- Combat timer
CombatTimerSettings = class(Turbine.UI.Control)
function CombatTimerSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(10,30);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    local height = 0

    -- Combat timer window
    local CombatTimerLabel = GetLabelUI(self, "Combat timer window Settings:", height)

    local CombatTimerCheckBox = GetCheckUI(self, height + 40, "Combat timer enabled", Settings.CTEnabled)
    CombatTimerCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.CTEnabled = CombatTimerCheckBox.cBox:IsChecked()
        MasterOptions:ChangesMade()
    end

    local CombatTimerWindowOptions = GetWindowUI(self, " Width| Height", height + 70, Settings.CTWidth, Settings.CTHeight)
    CombatTimerWindowOptions.button.Click = function()
        Settings.CTWidth = CombatTimerWindowOptions.windowX:GetText()
        Settings.CTHeight = CombatTimerWindowOptions.windowY:GetText()
        MasterOptions:ChangesMade()
    end

    local FontMenuCombatTimer = GetFontMenu(self, height + 110, FontsLUTR[Settings.CTFont]) 
    for i = 1, FontMenuCombatTimer.menuItems:GetCount() do
        local menuItem = FontMenuCombatTimer.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.CTFont = FontsLUT[sender:GetText()]
            MasterOptions:ChangesMade()
        end
    end

    local EffectBox1 = Turbine.UI.Lotro.CheckBox();
    EffectBox1:SetParent(self)
    EffectBox1:SetPosition(50, 400);
    EffectBox1:SetSize(400,20);
    EffectBox1:SetChecked(Settings.CTInCombat)
    EffectBox1:SetText("Only show in combat");
    EffectBox1:SetVisible(true);


    EffectBox1.CheckedChanged = function()
        Settings.CTInCombat = EffectBox1:IsChecked()
        MasterOptions:ChangesMade()
    end
end

-- Reset button
SettingsSettings = class(Turbine.UI.Control)
function SettingsSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(10,30);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    local height = 0

    -- Reset to default settings
    local ResetLabel = GetLabelUI(self, "Reset to Default Settings:", height)

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(self)
    ResetButton:SetPosition(20, height + 30);
    ResetButton:SetSize(100,15);
    ResetButton:SetText("Reset");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        Settings.Reload = true
        MasterOptions:ChangesMade()
    end

    -- Setup
    local ResetLabel = GetLabelUI(self, "Redo setup:", height + 60)

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(self)
    ResetButton:SetPosition(20, height + 90);
    ResetButton:SetSize(100,15);
    ResetButton:SetText("Setup");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        if Setup == nil then
            Setup = FirstTimerOptions()
        else
            Setup:SetVisible()
        end
    end

    local PatchButton = Turbine.UI.Lotro.Button()
    PatchButton:SetParent(self)
    PatchButton:SetVisible(true)
    PatchButton:SetSize(150, 15)
    PatchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    PatchButton:SetMouseVisible(true)
    PatchButton:SetPosition(150, height + 90)
    PatchButton:SetText("Check Patch Notes")

    PatchButton.Click = function()
        WindowsHandlerController:CreatePatchWindow()
    end

    local collectionBox = Turbine.UI.Lotro.CheckBox();
    collectionBox:SetParent(self)
    collectionBox:SetPosition(220, height + 100);
    collectionBox:SetSize(200, 20);
    collectionBox:SetChecked(Settings.CollectIconData)
    collectionBox:SetText("Enable Data Collection");
    collectionBox:SetVisible(true);

    collectionBox.CheckedChanged = function(sender,args)
        Settings.CollectIconData = collectionBox:IsChecked()
    end
    
    -- Enable advanced settings
    local cBox = Turbine.UI.Lotro.CheckBox();
    cBox:SetParent(self)
    cBox:SetPosition(20, height + 120);
    cBox:SetSize(200, 20);
    cBox:SetChecked(Settings.Advanced)
    cBox:SetText("Enable Advanced Options");
    cBox:SetVisible(true);

    local SettingsMade = false

    cBox.CheckedChanged = function(sender,args)
        Settings.Advanced = cBox:IsChecked()
        if Settings.Advanced and not(SettingsMade) then
            GenerateAdvancedSettings(self)
            SettingsMade = true
        end
    end

    if Settings.Advanced then
        GenerateAdvancedSettings(self)
        SettingsMade = true
    end



    self.menu = Turbine.UI.ContextMenu()
    self.menuItems = self.menu:GetItems()



    for key, value in pairs(Profiles:GetPreferences()) do
        local menuItem = Turbine.UI.MenuItem(key)
        menuItem.Click = function()
            Profiles:ChangePreference(key)
        end
        self.menuItems:Add(menuItem)
    end

    self.button = Turbine.UI.Lotro.Button()
    self.button:SetParent(self)
    self.button:SetPosition(300, 30);
    self.button:SetSize(200,15);
    self.button:SetText("Change profile");
    self.button:SetVisible(true);

    self.button.Click = function()
        self.menu:ShowMenu()
    end

    local EffectBox = Turbine.UI.Lotro.CheckBox();
    EffectBox:SetParent(self)
    EffectBox:SetPosition(310, 10);
    EffectBox:SetSize(200,20);
    EffectBox:SetChecked(Settings.OptionsButton == 2)
    EffectBox:SetText("New Optionsbutton Enabled");
    EffectBox:SetVisible(true);

    EffectBox.CheckedChanged = function()
        if EffectBox:IsChecked() then
            Settings.OptionsButton = 2
        else
            Settings.OptionsButton = 1
        end
        MasterOptions:ChangesMade()
    end

end

function GenerateAdvancedSettings(parent)

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(parent)
    ResetButton:SetPosition(20, 150);
    ResetButton:SetSize(100,15);
    ResetButton:SetText("Print Settings");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        PrintSettings()
    end

    -- Enable advanced settings
    local cBox = Turbine.UI.Lotro.CheckBox();
    cBox:SetParent(parent)
    cBox:SetPosition(20, 180);
    cBox:SetSize(200, 20);
    cBox:SetChecked(Settings.CheckLag)
    cBox:SetText("Check for server lag");
    cBox:SetVisible(true);

    cBox.CheckedChanged = function(sender,args)
        Settings.CheckLag = cBox:IsChecked()
    end

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(parent)
    ResetButton:SetPosition(20, 200);
    ResetButton:SetSize(200,15);
    ResetButton:SetText("Get local time");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        ChatOutput(Turbine.Engine.GetLocalTime())
    end

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(parent)
    ResetButton:SetPosition(20, 220);
    ResetButton:SetSize(200,15);
    ResetButton:SetText("Get game time");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        ChatOutput(Turbine.Engine.GetGameTime())
    end

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(parent)
    ResetButton:SetPosition(20, 240);
    ResetButton:SetSize(200,15);
    ResetButton:SetText("Print Swap Data");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        SwappyWarner:PrintSwaps()
    end

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(parent)
    ResetButton:SetPosition(20, 260);
    ResetButton:SetSize(200,15);
    ResetButton:SetText("Get Instancecontroller state");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        if Settings.InstanceState then
            ChatOutput("Instance State: true")
        else
            ChatOutput("Instance State: false")
        end
        ChatOutput("Instance version: " .. Settings.InstanceVersion)
        ChatOutput("Instance tier: " .. Settings.InstanceTier)
    end

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(parent)
    ResetButton:SetPosition(20, 280);
    ResetButton:SetSize(200,15);
    ResetButton:SetText("Get memory used");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        ChatOutput(collectgarbage("count")*1024 .. " Bytes")
        ChatOutput(collectgarbage("count") .. " KB")
        ChatOutput(collectgarbage("count")/1024 .. " MB")
    end

    local ScaleBox = Turbine.UI.Lotro.TextBox()
    ScaleBox:SetParent(parent)
    ScaleBox:SetSize(50, 30)
    ScaleBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ScaleBox:SetPosition(20, 300)
    ScaleBox:SetText(Settings.UpdateDelay)

    local ScaleButton = Turbine.UI.Lotro.Button()
    ScaleButton:SetParent(parent)
    ScaleButton:SetSize(150, 30)
    ScaleButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ScaleButton:SetMouseVisible(false)
    ScaleButton:SetPosition(70, 305)
    ScaleButton:SetText("Set Update Delay")

    ScaleButton.Click = function()
        if ScaleBox:GetText() ~= "" and ScaleBox:GetText() ~= nil and ScaleBox:GetText() ~= Settings.UpdateDelay then
            Settings.UpdateDelay = tonumber(ScaleBox:GetText())
        end
    end

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(parent)
    ResetButton:SetPosition(20, 330);
    ResetButton:SetSize(200,15);
    ResetButton:SetText("Get effect info on player");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        local effectList = Player:GetEffects()

        for i = 1, effectList:GetCount(), 1 do
            ChatOutput(effectList:Get(i):GetName() .. " - Icon: " .. effectList:Get(i):GetIcon() .. " - Category: " .. effectList:Get(i):GetCategory() .. " - Duration: " .. effectList:Get(i):GetDuration() )
        end 
    end

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(parent)
    ResetButton:SetPosition(20, 350);
    ResetButton:SetSize(200,15);
    ResetButton:SetText("Get backpack info");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        local backPack = Player:GetBackpack()

        for i = 1, backPack:GetSize(), 1 do
            local item1 = backPack:GetItem(i)
            if item1 ~= nil then 
                local item = item1:GetItemInfo()
                ChatOutput(item:GetName() .. " - Icon: " .. item:GetIconImageID()) 
            end
        end
    end

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(parent)
    ResetButton:SetPosition(20, 370);
    ResetButton:SetSize(200,15);
    ResetButton:SetText("Get equipment info");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        local backPack = Player:GetEquipment()

        for i = 1, backPack:GetSize(), 1 do
            local item1 = backPack:GetItem(i)
            if item1 ~= nil then 
                local item = item1:GetItemInfo()
                ChatOutput(item:GetName() .. " - Icon: " .. item:GetIconImageID()) 
            end
        end
    end

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(parent)
    ResetButton:SetPosition(20, 390);
    ResetButton:SetSize(200,15);
    ResetButton:SetText("Get skill info + Icon");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        local tskills = Player:GetTrainedSkills()
        for i = 1, Player:GetTrainedSkills():GetCount(), 1 do
            local item = tskills:GetItem(i)--:GetSkillInfo()
            local name = item:GetSkillInfo():GetName() 
            local description = item:GetSkillInfo():GetIconImageID()

            ChatOutput(name .. " - Icon: " .. description)
        end
    end

    local ResetButton = Turbine.UI.Lotro.Button()
    ResetButton:SetParent(parent)
    ResetButton:SetPosition(20, 410);
    ResetButton:SetSize(200,15);
    ResetButton:SetText("Get skill info + description");
    ResetButton:SetVisible(true);

    ResetButton.Click = function()
        local tskills = Player:GetTrainedSkills()
        for i = 1, Player:GetTrainedSkills():GetCount(), 1 do
            local item = tskills:GetItem(i)--:GetSkillInfo()
            local name = item:GetSkillInfo():GetName() 
            local description = item:GetSkillInfo():GetDescription()

            ChatOutput(name .. " - Description: " .. description)
        end
    end
end

function PrintSettings()
    local SettingsWindow = LogWindow()
    SettingsWindow:SetVisible(true)
    for key, value in pairs(Settings) do
        local output = nil
        if value == true then
            output = "true"
        elseif value == false then
            output = "false"
        else
            output = value
        end
        SettingsWindow:Message(key .. ":" ..output, false)
    end
end

-- Note window settings
NoteSettings = class(Turbine.UI.Control)
function NoteSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(10,30);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    local height = 0

    -- Note Window
    local NoteWindowLabel = GetLabelUI(self, "Note Window Settings:", height) 

    local NoteWindowOptions = GetWindowUI(self, "Width              Height", height + 30, Settings.NoteWidth, Settings.NoteHeight)
    NoteWindowOptions.button.Click = function()
        Settings.NoteWidth = NoteWindowOptions.windowX:GetText()
        Settings.NoteHeight = NoteWindowOptions.windowY:GetText()
        MasterOptions:ChangesMade()
    end
end