TargetWindow = class(Turbine.UI.Window)
function TargetWindow:Constructor()
    Turbine.UI.Window.Constructor(self);
    self.width = Settings.TWidth
    local height = Settings.THeight2
    local x = Settings.TX
    local y = Settings.TY

    --local cooldownTimer = 0
    self.Timers = {}

    SetEffects()
    
    self.EffectDictionary = {}

    self.UpdateDelay = 0.05
    self.CheckDelay = 0.3
    self.TimeSinceLastCheck = 0
    self.UpdateToken = 1
    self.font = Settings.SPNewFont
    self.colourScheme = {Turbine.UI.Color(0,0,0), Turbine.UI.Color(0,0,0), TimerColourNormal5, Turbine.UI.Color(1,1,1), Turbine.UI.Color(0,0,0), TimerColourNormal2, Settings.TargetWindowFrontTexture, Settings.TargetWindowBackTexture, Settings.TargetWindowFrontOpacity, Settings.TargetWindowBackOpacity}
    --local EffectIndex = 1
    --local MaxEffectPerUpdate = 100

    self.PermDelay = 3

    self.TimerHeight = 20

    self.ResortTimers = false

    self.targetEffects = nil
    self.target = nil
    self.targetHealth = nil
    self.targetTime = Turbine.Engine.GetGameTime()
    self.targetEffectsID = {}
    --self.targetEffectsCount = 0

    self.ShowAll = Settings.TShowAll
    self.DoEffects = Settings.TEffects
    self.pvpEffects = Settings.SKTEnabled
    self.AlertsEnabled = Settings.AEnabled
    self.pvpAlerts = Settings.SKAEnabled

    --local EmptyString = ""

    self.oldGameTime = Turbine.Engine.GetGameTime()

    self.targetEffectsDictionary = TargetWindowEffects
    self.pvpDictionary = PvPTimerTriggers
    self.expiryEffects = ShowExpiryEffects

    self.itemCount = 0

    self.callback = {}

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    --self.TargetEffects.self = nil 

    self:SetSize(self.width,height);
    self:SetPosition(x,y);
    self:SetVisible(true)
    self:SetWantsUpdates(true)
    --Updater:Subscribe(self)
    self:SetMouseVisible(false)
    self:SetOpacity(1)
    --self:SetBackColor(GoldColor)

    self.opacityNameWindow = Turbine.UI.Window()
    self.opacityNameWindow:SetParent(self)
    self.opacityNameWindow:SetSize(self.width, 30)
    self.opacityNameWindow:SetBackColor(OutlineColor)
    self.opacityNameWindow:SetOpacity(0.3)
    self.opacityNameWindow:SetVisible(true)
    self.opacityNameWindow:SetMouseVisible(false)

    self.opacityNameWindow2 = Turbine.UI.Window()
    self.opacityNameWindow2:SetParent(self)
    self.opacityNameWindow2:SetSize(self.width, 30)
    --self.opacityNameWindow2:SetBackColor(OutlineColor)
    --self.opacityNameWindow2:SetOpacity(0.3)
    self.opacityNameWindow2:SetVisible(true)
    self.opacityNameWindow2:SetMouseVisible(false)

    self.NameLabel = Turbine.UI.Label()
    self.NameLabel:SetParent(self.opacityNameWindow2)
    self.NameLabel:SetSize(self.width, 15)
    self.NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.NameLabel:SetMouseVisible(false)
    self.NameLabel:SetMultiline(false)
    self.NameLabel:SetTop(2)

    self.DataLabel =  Turbine.UI.Label()
    self.DataLabel:SetParent(self.opacityNameWindow2)
    self.DataLabel:SetSize(self.width, 15)
    self.DataLabel:SetTop(15)
    self.DataLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.DataLabel:SetMouseVisible(false)
    self.DataLabel:SetMultiline(false)

    self.TimerContainer = Turbine.UI.Control()
    self.TimerContainer:SetParent(self)
    self.TimerContainer:SetVisible(true)
    self.TimerContainer:SetSize(100, height - 20)
    self.TimerContainer:SetPosition(0, 30)
    self.TimerContainer:SetMouseVisible(false)

    local moveBox = MoveBox(self, self.width, height, "Target Window")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.TimerCompare = function(t, a, b)
        if t[b][2] == t[a][2] then
            return t[b][4] > t[a][4]
        else
            return t[b][2] < t[a][2]
        end
    end

    -- Set callbacks
    self.callback["TargetChanged"] = AddCallback(self.player, "TargetChanged", function(sender, args) self:TargetEvents(sender) end)
    self.callback["InCombatChanged"] = AddCallback(self.player, "InCombatChanged", function(sender) self:CombatUpdate(sender) end)

    -- Handle initial situation
    self:CombatUpdate()
    self:TargetEvents()
    self:SetNameText()
end

-- Clean callbacks
function TargetWindow:RemoveCallbacks()
    RemoveCallback(self.player, "TargetChanged", self.callback["TargetChanged"])
    RemoveCallback(self.player, "InCombatChanged", self.callback["InCombatChanged"])
end

-- Looks at effects on targets and adds or removes timers based on conditions
function TargetWindow:UpdateEffects()
    if self.targetEffects == nil then return end

    for i = 1, self.targetEffects:GetCount() do

        -- Filter already handled IDs
        local currentEffect = self.targetEffects:Get(i)
        local id = currentEffect:GetID()
        if self.targetEffectsID[id] == nil then

            -- Only add id if not permanent effect
            if currentEffect:GetDuration() < 999999 then self.targetEffectsID[id] = true end

            -- Check if we should add timer
            if self.ShowAll or self.targetEffectsDictionary[currentEffect:GetName()] then
                self:NewTimer(currentEffect)
            end

            -- Check if we should handle pvp addition
            if self.pvpEffects then
                local pvpThing = self.pvpDictionary[currentEffect:GetName()]
                if pvpThing then
                    PVPCDTracker:NewTimer(pvpThing, self.target:GetName(), currentEffect, false)
                end
            end
        end
    end
end

-- Makes or updates timer based on effect
function TargetWindow:NewTimer(effect)
    local effectName = effect:GetName()
    local numberLessName = string.gsub(effectName, "%d", "")
    local item = self.Timers[numberLessName]

    -- Check if timer already exists
    if item and not(item[7]) then
        -- Timer already exists 
        if item[3] == effect:GetID() then 
            return
        else
            -- Update timer for new effect -- TODO track more effects
            local duration = effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime())
            item[2] = duration
            item[1]:ChangeDuration(duration)
            item[1]:ChangeText(effectName)
            self.Timers[numberLessName] = item
            self.ResortTimers = true
            return
        end
    end

    
    local maxDuration = effect:GetDuration()
    local duration = effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime())
    local permanent = false
    local showDuration = true
    -- If permanent change duration to managable amount
    if duration > 999999 then 
        duration, maxDuration = 9999999, 9999999
        permanent = true
        showDuration = false
        local alreadyExisting = self.Timers[numberLessName]

        -- Spotted again so handle changing permanent effect with potential namechange
        if alreadyExisting then
            if effectName ~= alreadyExisting[4] then
                self.Timers[numberLessName][1]:ChangeName(effectName)
            end
            self.Timers[numberLessName][5] = 0
            return
        end
    end

    -- Haven't seen this effect before so we make a timer
    self.Timers[numberLessName] = {EffectTimer(self.TimerContainer, self.width, self.TimerHeight, effect, effectName, self.font, self.colourScheme, showDuration), duration, effect:GetID(), effectName, 0, effect:GetIcon(), permanent}
    self.itemCount = self.itemCount + 1

    self.ResortTimers = true
end

-- Handles setting/resetting data of a target
function TargetWindow:TargetEvents()

    self:Clear()

    -- Reset all variables
    self.itemCount = 0

    -- Start regathering info
    self.target = self.player:GetTarget()

    if self.target then 

        -- Make sure we can see the window now that we have a target
        self:SetVisible(true)
        self:SetWantsUpdates(true)

        self.targetName = self.target:GetName()

        -- Check if target can have effects
        if self.target.GetEffects then

            -- Set current data
            self.targetTime = Turbine.Engine.GetGameTime()
            self.targetHealth = self.target:GetMorale()
            -- Only update if looking at effects
            if self.DoEffects then
                self.targetEffects =  self.target:GetEffects()
                self.EffectDictionary = {}
                self.targetEffectsID = {}
            end

            -- Force first update
            self:CombatUpdate(sender)
        end
    else
        -- No target -> Hide window
        self:SetWantsUpdates(false)
        self:SetVisible(false)
    end

    -- Handle label of window
    self:SetNameText()
end

-- Clear all timers
function TargetWindow:Clear()
    -- Destroy all timers in the table and remove them from table
    for key, value in pairs(self.Timers) do 
        value[1]:Destroy()
        self.Timers[key] = nil
    end

    -- Reset all variables
    self.targetEffects = nil
    self.target = nil
    self.targetTime = 0
    self.targetHealth = 0
    self.itemCount = 0
    self.EffectDictionary = nil
    self.targetEffectsID = nil
    self.Timers = nil
    self.targetName = nil

    collectgarbage()

    self.EffectDictionary = {}
    self.targetEffectsID = {}
    self.Timers = {}
end

-- Handle an update to combat state
function TargetWindow:CombatUpdate()
    if self.player:IsInCombat() then

        -- If we enter combat and have a target setup tracking
        if self.target then
            self:SetWantsUpdates(true)
            if self.target.GetMorale then
                self.targetHealth = self.target:GetMorale()
            end
        end

        -- Get time when we start tracking combat on target
        self.targetTime = Turbine.Engine.GetGameTime()
    end
end

-- Handle setting name text with or without correct data
function TargetWindow:SetNameText()

    -- Only update if we have a target
    if self.target then

        -- Check if we received data from the game
        if self.target.GetEffects and self.target:GetMaxMorale() ~= 0 then

            -- Get target morale
            local targetMorale = self.target:GetMorale()

            -- Get time between starting to track and now
            local delta = Turbine.Engine.GetGameTime() - self.targetTime

            -- Update if we have a health change and time since target is more than 1 second
            if self.targetHealth < targetMorale and delta < 1 then
                self.targetHealth = targetMorale
            end

            -- Start creating dps string
            local dpsString = nil
            if delta > 0 then
                local dps = nil
                -- Set edge case
                if self.targetHealth - targetMorale == 0 then
                    dps = "0.0"
                else
                    -- Set damage difference to normal number
                    dps = Round((self.targetHealth - targetMorale)/delta / 1000, 1)
                end
                dpsString = "DPS: " ..  dps .. "K"
            end

            -- Format dps string
            if dpsString and delta > 0 then
                self.DataLabel:SetText(FormatBigNumberVitals((targetMorale / self.target:GetMaxMorale() * 100)) .. "% ".. dpsString)
            else
                self.DataLabel:SetText(FormatBigNumberVitals((targetMorale / self.target:GetMaxMorale() * 100)) .. "% ")
            end

            -- Set name
            self.NameLabel:SetText(self.targetName)
        else
            -- Only set name in case we haven't received data yet or will never receive
            self.NameLabel:SetText(self.targetName)
            self.DataLabel:SetText("")
        end
    else
        -- Set basic state
        self.NameLabel:SetText("-")
        self.DataLabel:SetText("")
    end
end

-- Resort timers
function TargetWindow:ResortList()
    local counter = 0
    for _,v in spairs(self.Timers, self.TimerCompare ) do
        v[1]:SetPosition(0, counter * self.TimerHeight) 
        counter = counter + 1
    end

    self.ResortTimers = false
end

-- Update loop
function TargetWindow:Update()   

    -- What is the time?
    local currentGameTime = Turbine.Engine.GetGameTime()

    -- Get time passed since last handled update
    local delta = currentGameTime - self.oldGameTime

    --self.UpdateDelay = self.UpdateDelay - delta

    --local CheckUpdate = self.UpdateDelay < 0

    -- See if we want to update the window
    if delta < self.UpdateDelay then return end

    --ChatOutput(collectgarbage("count")*1024 .. " Bytes")

    -- Update effects
    if self.TimeSinceLastCheck > self.CheckDelay then
        if self.DoEffects then
            self:UpdateEffects()
        end
        
        self.TimeSinceLastCheck = 0

        --Update text
        self:SetNameText()
    else
        self.TimeSinceLastCheck = self.TimeSinceLastCheck + delta
    end

    for key, value in pairs(self.Timers) do 
        -- Check if normal timer or permanent timer
        if not(value[7]) then

            -- Update timer value and text
            value[2] = value[2] - delta
            value[1]:UpdateText(delta)

            -- Remove expired timer
            if value[2] < 0 then 
                if self.AlertsEnabled and self.pvpAlerts and self.expiryEffects[value[4]] then 
                    messageWindow:Message(4, "<rgb=#007700>" .. value[4] .. "</rgb> Expired On: <rgb=#FF0000>" .. self.target:GetName(), value[6], false)
                end 

                -- Delete timer for table and handle data
                value[1]:Destroy()
                self.Timers[key] = nil
                self.ResortTimers = true
                self.itemCount = self.itemCount - 1
            end

        -- Check if we want to get an update on permanent buffs
        else
            -- See how long we haven't seen the permanent effect
            value[5] = value[5] + delta
            if value[5] > self.PermDelay then
                value[1]:Destroy()
                self.Timers[key] = nil
                self.ResortTimers = true
                self.itemCount = self.itemCount - 1
            end
        end
    end

    -- Resort timers
    if self.ResortTimers then
        self:ResortList()
    end

    self.oldGameTime = currentGameTime
end