Stars = class(Turbine.UI.Window)

function Stars:Constructor()
    local star = nil
    if Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == 1 then
        star = "PrimePlugins/RaidTools/Images/Freep_Star-icon.tga"
    else
        star = "PrimePlugins/RaidTools/Images/Creep_Star-icon.tga"
    end

    local Settings = Turbine.PluginData.Load(Turbine.DataScope.Character, "StarSettings")
    if Settings == nil then
        Settings = {}
        Settings.Width = 20
        Settings.Height = 60
        Settings.X = 0
        Settings.Y = 50
    end

    local width = Settings.Width 
    local height = Settings.Height

    Turbine.UI.Window.Constructor(self);
    self:SetSize(width, height);
    self:SetPosition(Settings.X, Settings.Y);
    self:SetZOrder(1);

    self:SetWantsKeyEvents(false)
    self:SetMouseVisible(false)
    self:SetVisible(true)

    self.makeStarLabel = function(x, y)
        local starLabel = Turbine.UI.Label()
        starLabel:SetParent(self)
        starLabel:SetBackground(star)
        starLabel:SetSize(20, 20)
        --starLabel:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
        starLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
        starLabel:SetPosition(x, y)
    end 

    self.makeStarLabel(6, 0)
    self.makeStarLabel(3, 12)
    self.makeStarLabel(1, 24)
    self.makeStarLabel(4, 36)
    self.makeStarLabel(8, 48)

    self.MoveBox = Turbine.UI.Control()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(width, height)
    self.MoveBox:SetBackColor(Turbine.UI.Color(0, 1, 1))
    self.MoveBox:SetVisible(false)

    self.messageBox1 = Turbine.UI.Label()
    self.messageBox1:SetParent(self.MoveBox)
    self.messageBox1:SetSize(width, height)
    self.messageBox1:SetPosition(0,0)
    self.messageBox1:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter)
    self.messageBox1:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox1:SetMouseVisible(false)
    self.messageBox1:SetText("Stars")

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          if newLeft < 0 then newLeft = 0 end
          if newTop < 0 then newTop = 0 end
          if newLeft > (Turbine.UI.Display.GetWidth() - self:GetWidth()) then
            newLeft = Turbine.UI.Display.GetWidth() - self:GetWidth() end
          if newTop > (Turbine.UI.Display.GetHeight() - self:GetHeight()) then
            newTop = Turbine.UI.Display.GetHeight() - self:GetHeight() end
            self:SetPosition(newLeft,newTop)
        end
    end
    
    self.ToggleMove = function()
        self.MoveBox:SetVisible(not self.MoveBox:IsVisible())
    end

    self.SaveStars = function()
        Settings.X, Settings.Y = self:GetPosition()
        Turbine.PluginData.Save(Turbine.DataScope.Character, "StarSettings", Settings);
    end

end