import "PrimePlugins.Vitals"


Reloader = class(Turbine.UI.Control)
function Reloader:Constructor()
    Turbine.UI.Control.Constructor(self)
    self:SetWantsUpdates(true)
    self.reloaded = false
    self.Update = function()
        if self.reloaded then
            self:SetWantsUpdates(false)    
        elseif not(self.reloaded) then 
            Turbine.PluginManager.UnloadScriptState("~PrimeVitalsReloader")
            self.reloaded = true
            self:SetParent(nil)
        end
    end
end

function ReloadPlugin()
    Turbine.PluginManager.LoadPlugin("~PrimeVitalsReloader")
end

import "PrimePlugins.RaidTools.Utils"

local r = Reloader()

UpdateSettings()

Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, false );

if Settings.ClassicEnabled then
    Vital = ClassicWindow()
else
    Vital = VitalWindow()
end

if Settings.TargetEnabled then TargetVital = TargetWindow() end

Options = nil --OptionOptions()

ChatOutput("<rgb=#FF9900>"..plugin:GetName() .. " Version " .. plugin:GetVersion() .." loaded.</rgb>") 

plugin.Unload = function() 
    Vital:RemoveCallbacks()
    Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, true );
    Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Target, true );
    SaveData()
end