ResourceBar = class( Turbine.UI.Control );
function ResourceBar:Constructor(parent, width, height, boxes, text, y, borderColour)
    Turbine.UI.Control.Constructor( self )

    local mismatch = width % boxes

    local offset = 20 - height

    self:SetSize(width + 2, height + 30)
    self:SetZOrder(100)
    self:SetMouseVisible(false)
    --self:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125))
    self:SetParent(parent)
    self:SetPosition(0, y)

    self.border = Turbine.UI.Control()
    self.border:SetParent(parent)
    self.border:SetPosition(0, y)
    self.border:SetSize(width + 2, height)
    self.border:SetBackColor(borderColour)

    self.BarDictionary = {}

    self.boxes = boxes

    for i = 1,  self.boxes, 1 do
        self.BarDictionary[i] = ResourceBox(self, mismatch + (i - 1) * (width - mismatch) /  self.boxes, width - mismatch, height,  self.boxes)
    end  

    if text then
        self.textBox = Turbine.UI.Label()
        self.textBox:SetParent(self)
        self.textBox:SetSize(20, 20)
        self.textBox:SetPosition((width /2 ) - 10, -offset/3)
        self.textBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        self.textBox:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
        self.textBox:SetFontStyle( Turbine.UI.FontStyle.Outline )
        self.textBox:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        self.textBox:SetText("0")
        --self.textBox:SetBackColor(Turbine.UI.Color(0, 0, 0))
        self.textBox:SetMouseVisible(false)
    end
end

function ResourceBar:ChangeResource(NewNumber, Colour)
--Turbine.UI.Color(1,0.250,0.250)
    if self.textBox then self.textBox:SetText(NewNumber) end
    for i = 1, self.boxes, 1 do
        if i <= NewNumber then
            self.BarDictionary[i]:TurnOn(Colour)
        else
            self.BarDictionary[i]:TurnOff()
        end
    end  
end

ResourceBox = class( Turbine.UI.Control );
function ResourceBox:Constructor(parent, x, width, height, boxes)

    Turbine.UI.Control.Constructor( self )
    self:SetParent(parent)
    self:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125))
    self:SetPosition(x, 0)
    self:SetSize(width /  boxes, height)
    self:SetMouseVisible(false)

    self.InnerBarBackground = Turbine.UI.Control()
    self.InnerBarBackground:SetParent(self)
    self.InnerBarBackground:SetBackColor(Turbine.UI.Color(0.250,0.250,0.250))
    self.InnerBarBackground:SetPosition(1, 1)
    self.InnerBarBackground:SetSize(width /  boxes, height - 2)
    self.InnerBarBackground:SetMouseVisible(false)

    self.InnerBar = Turbine.UI.Control()
    self.InnerBar:SetParent(self)
    --self.InnerBar:SetBackColor(Turbine.UI.Color(1,0.250,0.250))
    self.InnerBar:SetPosition(1, 1)
    self.InnerBar:SetSize(width /  boxes - 2, height - 2)
    self.InnerBar:SetMouseVisible(false)

end

function ResourceBox:TurnOn(Colour)
    self.InnerBar:SetBackColor(Colour)
end

function ResourceBox:TurnOff()
    self.InnerBar:SetBackColor()
end