VitalBar = class( Turbine.UI.Control );
function VitalBar:Constructor(width, height, showText, textAlignment, parent, y, colourChange)
    Turbine.UI.Control.Constructor( self )
    
    self:SetSize(width, height)
    self:SetZOrder(100)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.8, 0, 0, 0))

    --self.MaxValue = 100
    --self.CurrentValue = 0
    self.TempValue = 0
    self.MaxTempValue = 0
    self.DreadValue = 0

    self.NumberMethod = Settings.NumberMethod
    self.PercentageShown = Settings.PercentageShown
    self.OnlyShowCurrent = Settings.OnlyShowCurrent
    self.showText = showText

    self.CurrentImmediate = 0
    self.CurrentValue = Turbine.Animation.LerpValue()
	self.MaxValue = 0--Turbine.Animation.LerpValue()
    self.baseMax = 0--Turbine.Animation.LerpValue()

    self.colourChange = colourChange
    self.backcolour = nil
    self.warningColour = Turbine.UI.Color(0.7, 0.1, 0.1)
    
    Background = "PrimePlugins/Vitals/Images/FittedSmooth.tga"

    --self:SetBackColor( Turbine.UI.Color( 1, 1, 0, 0 ) )
    --ChatOutput(width .. " " .. height)
    -- The background bar that contains all other bars
    self.TotalBar = Turbine.UI.Control()
    self.TotalBar:SetParent(self)
    --self.TotalBar:SetSize(256, 32)
    --self.TotalBar:SetStretchMode(1)
    self.TotalBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.TotalBar:SetPosition(2, 2)
    self.TotalBar:SetBackground(Background)
    self.TotalBar:SetSize(width - 4, height - 4)
    self.TotalBar:SetMouseVisible(false)

    -- The current value of the display
    self.CurrentBar = Turbine.UI.Control()
    self.CurrentBar:SetPosition(2, 2)
    self.CurrentBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.CurrentBar:SetParent(self)
    self.CurrentBar:SetBackground(Background)
    self.CurrentBar:SetSize(0, height - 4)
    self.CurrentBar:SetMouseVisible(false)

    -- Indicating morale loss/gain
    self.MoveBar = Turbine.UI.Control()
    --self.MoveBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.MoveBar:SetParent(self)
    self.MoveBar:SetSize(0, 0)
    self.MoveBar:SetMouseVisible(false)

    -- Bar to show temporary effects (bubbles)
    self.TemporaryBar = Turbine.UI.Control()
    self.TemporaryBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.TemporaryBar:SetParent(self)
    self.TemporaryBar:SetSize(0, height)
    self.TemporaryBar:SetMouseVisible(false)

    -- Bar to show temporary effects negative (dread)
    self.DreadBar = Turbine.UI.Control()
    --self.DreadBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.DreadBar:SetParent(self)
    self.DreadBar:SetSize(0, 0)
    self.DreadBar:SetMouseVisible(false)

	-- The animation classes for smoothly moving the bars.

    -- The display text for the vitals bar.
    -- [[
    if self.showText then
        self.text = Turbine.UI.Label()
        self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1, 1 ) )
        self.text:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
        self.text:SetFontStyle( Turbine.UI.FontStyle.Outline )
        self.text:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold19 )
        if parent == nil then
            if textAlignment == Turbine.UI.ContentAlignment.MiddleRight then
                self.text:SetPosition(-10, 0)
            elseif textAlignment == Turbine.UI.ContentAlignment.MiddleLeft then
                self.text:SetPosition(10, 0)
            elseif height == 54 then
                self.text:SetPosition(0, -5)
            end
            self.text:SetTextAlignment( textAlignment )
            self.text:SetParent( self )
        else
            if textAlignment == Turbine.UI.ContentAlignment.MiddleRight then
                self.text:SetPosition(-3, y)
            else
                self.text:SetPosition(3, y)
            end
            self.text:SetParent( parent )
            self.text:SetTextAlignment( textAlignment )
        end
        self.text:SetZOrder( 100 )
        self.text:SetSize(width, height)
        self.text:SetMouseVisible(false)
    end
    --]]

	--self.horizontalLayout = Turbine.UI.HorizontalLayout.LeftToRight;
	self.showPercentage = false;

	self.lastUpdate = 0;
end

function VitalBar:SetColours(BackColour, BarColour, TempColour, DreadColour)
    self.TotalBar:SetBackColor(BackColour)
    self.CurrentBar:SetBackColor(BarColour)
    self.backcolour = BarColour
    self.TemporaryBar:SetBackColor(TempColour)
    self.DreadBar:SetBackColor(DreadColour)
end

function VitalBar:SetMaxValue(value)
    self.MaxValue = value
    self.CurrentValue:SetRate( self.MaxValue / self:GetWidth() * 200 );
end

function VitalBar:SetCurrentValue(value)
    self.CurrentValue:SetValue(value)

    if ( self.CurrentValue:NeedsUpdate() ) then
		self:SetWantsUpdates( true );
	end
end

function VitalBar:SetCurrentValueImmediate(value)
    self.CurrentValue:SetValueImmediate(value)

    --if ( self.CurrentValue:NeedsUpdate() ) then
		self:SetWantsUpdates( true );
	--end
end

function VitalBar:SetTempValue(value)
    self.TempValue = value
    self:AdjustBars()
end

function VitalBar:SetMaxTempValue(value)
    self.MaxTempValue = value
    --self:AdjustBars()
end

function VitalBar:SetDreadValue(value)
    self.DreadValue = value
end

function VitalBar:Update( args )
	local delta = 0;
	local currentTime = Turbine.Engine.GetGameTime();

	if ( self.lastUpdate > 0 ) then
		delta = currentTime - self.lastUpdate;
	end

	self.lastUpdate = currentTime;

	self.CurrentValue:Update( delta );
	--self.MaxValue:Update( delta );
	--self.baseMax:Update( delta );

        --[[
	local current = math.floor( self.CurrentValue:GetValue() + 0.5 ) 
	local max = math.floor( self.MaxValue:GetValue() + 0.5 ) 
    local baseMax = math.floor( self.baseMax:GetValue() + 0.5 ) 
    
	if ( self.showPercentage ) then
		local percentage = math.floor( ( current / max * 100 ) + 0.5 );
		self.text:SetText( percentage .. "%" );
	else
		self.text:SetText( current .. "/" .. max );
    end
    

	self:PerformLayout();

    --]]
	if not(self.CurrentValue:NeedsUpdate()) then
		self:SetWantsUpdates( false );
		self.lastUpdate = 0;
    end
    
    self:AdjustBars()
end

function VitalBar:AdjustBars()

    local value = self.CurrentValue:GetValue()
    local totalWidth, currentHeight = self.TotalBar:GetSize()
    local totalHealthValue = self.MaxValue + self.TempValue
    local currentWidth = value / totalHealthValue * totalWidth

    self.CurrentBar:SetWidth(math.ceil(currentWidth))

    if self.colourChange then
        local colourValue = 1 - value / self.MaxValue
        self.CurrentBar:SetBackColor(Turbine.UI.Color(
            self.backcolour.R + (self.warningColour.R - self.backcolour.R) * colourValue, 
            self.backcolour.G + (self.warningColour.G - self.backcolour.G) * colourValue, 
            self.backcolour.B + (self.warningColour.B - self.backcolour.B) * colourValue))
    end

    --self.CurrentBar:SetBackColor(Turbine.UI.Color(0.4 + 0.6 - 0.6 * self.CurrentValue:GetValue() / (self.MaxValue:GetValue() + self.TempValue) , 0.5, 0.1))
    --self.TotalBar:SetBackColor(Turbine.UI.Color(0.4 + 0.6 - 0.6 * self.CurrentValue:GetValue() / (self.MaxValue:GetValue() + self.TempValue) , 0.7 - 0.3 * self.CurrentValue:GetValue() / (self.MaxValue:GetValue() + self.TempValue) , 0.1))

    --if self.TempValue > 0 then 
        self.TemporaryBar:SetWidth(math.ceil(self.TempValue / totalHealthValue * totalWidth))
        self.TemporaryBar:SetPosition(2 + currentWidth, 0)
    --end

    if self.showText then
        local tempString = ""

        if self.TempValue > 0 then
            tempString = " +" ..  self:FormatNumber(math.ceil(self.TempValue))
        end

        self.text:SetText(  self:GetHealthString(value) .. tempString .. self:FormatPercentage(value))
    end
    --[[
    local width, height = self:GetSize();

	-- Layout the text.
	--self.text:SetPosition( 0, -1 );
	--self.text:SetSize( width, height );

	local current = self.CurrentValue:GetValue();
	local max     = self.MaxValue:GetValue();
	local baseMax = self.baseMax:GetValue();

	local baseBarWidthPercent = 1;

	-- Calculate the percentage of the bar that is the base vital display
	-- versus the adjusted display portion for buffs and debuffs.
	if ( max < baseMax ) then
		baseBarWidthPercent = max / baseMax;
	elseif ( baseMax < max ) then
		baseBarWidthPercent = baseMax / max;
	end

	local baseBarFillPercent   = 0;
	local adjustBarFillPercent = 0;

	-- Calculate the amount of fill for the base bar and the buffed bar.
	if ( max < baseMax ) then
		-- Debuff case.
		baseBarFillPercent = current / max;
		adjustBarFillPercent = 1;
	elseif ( current <= baseMax ) then
		baseBarFillPercent = current / baseMax;
	else
		baseBarFillPercent = 1;
		adjustBarFillPercent = ( current - baseMax ) / ( max - baseMax );
	end

	-- Determine the actual layout of the bars now.
	local baseBarLeft      = 0;
	local baseBarMaxWidth  = math.floor( width * baseBarWidthPercent );
	local baseBarWidth     = math.floor( baseBarMaxWidth * baseBarFillPercent );
	local adjustedBarLeft  = 0;
	local adjustedBarWidth = math.floor( ( width - baseBarWidth ) * adjustBarFillPercent );

	if ( self.horizontalLayout == Turbine.UI.HorizontalLayout.LeftToRight ) then
		baseBarLeft     = 0;
		adjustedBarLeft = baseBarMaxWidth;
	else
		baseBarLeft     = width - baseBarWidth; 
		adjustedBarLeft = width - baseBarMaxWidth - adjustedBarWidth;
	end

	self.fillBar:SetPosition( baseBarLeft, 0 );
	self.fillBar:SetSize( baseBarWidth, height );

	self.debuffBar:SetVisible( false );
	self.buffBar:SetVisible( false );

	if ( max < baseMax ) then
		self.debuffBar:SetVisible( true );
		self.debuffBar:SetPosition( adjustedBarLeft, 0 );
		self.debuffBar:SetSize( adjustedBarWidth, height );
	elseif ( baseMax < max ) then
		self.buffBar:SetVisible( true );
		self.buffBar:SetPosition( adjustedBarLeft, 0 );
		self.buffBar:SetSize( adjustedBarWidth, height );
    end
    --]]
end

function VitalBar:SetTextVisible(value)
    if self.text then self.text:SetVisible(value) end
end

function VitalBar:FormatNumber(number) 
    if self.NumberMethod == 1 then
        return number
    elseif self.NumberMethod == 2 then
        return FormatBigNumber(number)
    end
end

function VitalBar:GetHealthString(value)
    if self.OnlyShowCurrent then
        return self:FormatNumber(math.floor( value+ 0.5 ))
    else
        return self:FormatNumber(math.floor( value + 0.5 ))  .. "/" .. self:FormatNumber(math.floor( self.MaxValue + 0.5 ))
    end
end




function VitalBar:FormatPercentage(value) 
    if self.PercentageShown then
        return " - " .. math.floor(value / self.MaxValue * 100) .. "%"
    else
        return ""
    end
end
