VitalWindow = class( Turbine.UI.Window)
function VitalWindow:Constructor()
    Turbine.UI.Window.Constructor( self );
	
    --self.layout = Turbine.UI.HorizontalLayout.LeftToRight;
    
    local width = 254
    local height = 160 + 160 + 86

    local vitalWidth = 250 + 4
    local vitalHeight = 80 + 4
	
	self:SetPosition( Settings.FrameX, Settings.FrameY );
    self:SetSize( width, height);
    self:SetVisible(true)
    self:SetMouseVisible(false)

    if Settings.Aura then
        self.aura = Aura()
    end

    self.BuffBoxes = {}
    self.DebuffBoxes = {}

    self.BuffResort = true
    self.DebuffResort = true

    self.UpdateCountdown = Settings.ShowCountdown

    self.Layout = Settings.Layout

    self.textSettings = Settings.Text

    self.BuffTracking = Settings.BuffTracking
    self.DebuffTracking = Settings.DebuffTracking

    self.IconScale = Settings.IconScale
    self.IconSize = 16 * self.IconScale

    self.debuffHeight = 160

    if self.Layout == 3 then self.debuffHeight = 150 end
    self.IconRow = 0
    self.IconRowHeight = self.debuffHeight - self.IconSize

    

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.ClassAttr = self.player:GetClassAttributes()
    self.ClassType = self.player:GetClass()

    self.playerCallbacks = {}
    self.attrCallbacks = {}
    self.effectCallbacks = {}

    self.ResourceText = Settings.ResourceText


    self.EffectPosition = Settings.EffectVersion

    self.oldGameTime = Turbine.Engine.GetGameTime()

    local offset = 0

    if self.ClassType == Turbine.Gameplay.Class.Champion or 
    self.ClassType == Turbine.Gameplay.Class.Hunter or 
    self.ClassType == Turbine.Gameplay.Class.RuneKeeper then
        if self.Layout == 1 then
            offset = 20
        elseif self.Layout == 2 then
            offset = 4
        end
    end

    
    --[[
	self.nameLabel = Turbine.UI.Label();
	self.nameLabel:SetParent( self );
	self.nameLabel:SetPosition( 60, 3 );
	self.nameLabel:SetSize( 160, 12 );
	self.nameLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
	self.nameLabel:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );
	self.nameLabel:SetMouseVisible( false );
    --]]
    
	self.vitalsFrame = Turbine.UI.Control();
	self.vitalsFrame:SetParent( self );
	--self.vitalsFrame:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
	self.vitalsFrame:SetPosition( 2, 2 );
    self.vitalsFrame:SetMouseVisible( true );	
    if self.Layout == 1 then
        self.vitalsFrame:SetSize( width, 86 );	
        self.vitalsFrame:SetPosition(0, offset + 160)
    elseif self.Layout == 2 then 
        self.vitalsFrame:SetSize( width, 61 );	
        self.vitalsFrame:SetPosition(0, offset + 160)
    elseif self.Layout == 3 then 
        self.vitalsFrame:SetSize( width, 61 );	
        self.vitalsFrame:SetPosition(0, offset + 160)
    end
    --self.vitalsFrame:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125))

    self.E = Turbine.UI.Lotro.EntityControl()
    self.E:SetParent (self.vitalsFrame)
    self.E:SetVisible (true)
    if self.Layout == 1 then
        self.E:SetSize(width, 86)
    elseif self.Layout == 2 then 
        self.E:SetSize(width, 66)
    elseif self.Layout == 3 then
        self.E:SetSize(width, 66)
    end
    self.E:SetEntity(self.player)
	
    -- Construct the morale bar.
    local alignment = nil
    if self.textSettings == 1 then
        alignment = Turbine.UI.ContentAlignment.BottomCenter
    elseif self.textSettings == 2 then
        alignment = Turbine.UI.ContentAlignment.MiddleRight        
    end

    if self.Layout == 1 then
        self.moraleBar = VitalBar(vitalWidth, vitalHeight - 20, true, alignment, nil, nil, Settings.ColourChanging);
    elseif self.Layout == 2 then 
        self.moraleBar = VitalBar(vitalWidth, vitalHeight - 30, true, alignment, nil, nil, Settings.ColourChanging);
    elseif self.Layout == 3 then
        self.moraleBar = VitalBar(vitalWidth, vitalHeight - 40, true, Turbine.UI.ContentAlignment.MiddleRight, self, 190, Settings.ColourChanging);
    end

    self.moraleBar:SetParent( self.vitalsFrame );
    --self.moraleBar:SetPosition(2, 2)
    local colour = nil
    local backgroundColor = nil
    if Settings.ColourMode == 1 then 
        colour = ClassColours[self.player:GetClass()]
        backgroundColor = ClassColoursBackground[self.player:GetClass()]
    elseif Settings.ColourMode == 2 then
        colour = Turbine.UI.Color(0, 50/255, 1/255)
        backgroundColor = Turbine.UI.Color(0.6, 0, 50/255, 1/255)
    elseif Settings.ColourMode == 3 then
        colour = Turbine.UI.Color(0.8, 0,  0, 0)
        self.moraleBar:SetBackColor(Turbine.UI.Color(0.08, 0.08, 0.08))
        backgroundColor = Turbine.UI.Color(0.3, 0.08, 0.08, 0.08)
    end
    self.moraleBar:SetColours(backgroundColor, colour, Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
	--self.moraleBar:SetColor( Turbine.UI.Color( 1, 0.1, 1, 0.1 ) );
	--self.moraleBar:SetBuffColor( Turbine.UI.Color( 1, 0.3, 0.7, 1 ) );
	--self.moraleBar:SetDebuffColor( Turbine.UI.Color( 1, 1.0, 0.4, 0 ) );
	--self.moraleBar:SetPosition( 60, 19 );
	self.moraleBar:SetMouseVisible( false );
	--self.moraleBar:SetShowPercentage( true );
    --self.moraleBar:SetHorizontalLayout( Turbine.UI.HorizontalLayout.RightToLeft );
	
    --self.SetText( self.moraleBar, "This is a really bad thing to be doing. I'm passing the wrong type of control..." );

	
    -- Construct the power bar.
    if self.Layout == 1 then
        self.powerBar = VitalBar(vitalWidth, vitalHeight - 60, Settings.ShowPowerNumbers, Turbine.UI.ContentAlignment.MiddleCenter);
        self.powerBar:SetPosition( 0, 64 - 2 );
    elseif self.Layout == 2 then 
        self.powerBar = VitalBar(vitalWidth, vitalHeight - 70, false, nil);
        self.powerBar:SetPosition( 0, 49 - 2 );
    elseif self.Layout == 3 then
        self.powerBar = VitalBar(vitalWidth - 130, vitalHeight - 73, false, nil);
        self.powerBar:SetPosition( 0, 49 - 2 );
    end
	self.powerBar:SetParent( self.vitalsFrame );
    self.powerBar:SetZOrder( 100 );
    if self.ClassType == Turbine.Gameplay.Class.Beorning then
        local powerBackground = Turbine.UI.Color(40/255, 0, 0)
        local powerColour = Turbine.UI.Color(100/255, 0, 0)

        if Settings.ColourMode == 3 then
            powerColour = Turbine.UI.Color(0.2, 0.2, 0.2)
            powerBackground = Turbine.UI.Color(0.25, 0.25, 0.25)
            self.powerBar:SetBackColor(Turbine.UI.Color(0.08, 0.08, 0.08))
        end
        self.powerBar:SetColours(powerBackground, powerColour, Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
    else
        local powerBackground = Turbine.UI.Color(0.1, 0.4, 0.4)
        local powerColour = Turbine.UI.Color(0.1, 0.1, 0.4)

        if Settings.ColourMode == 3 then
            powerColour = Turbine.UI.Color(0.2, 0.2, 0.2)
            powerBackground = Turbine.UI.Color(0.25, 0.25, 0.25)
            self.powerBar:SetBackColor(Turbine.UI.Color(0.08, 0.08, 0.08))
        end
        self.powerBar:SetColours(powerBackground, powerColour, Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
    end
	--self.powerBar:SetColor( Turbine.UI.Color( 1, 0.1, 0.5, 1 ) );
    self.powerBar:SetMouseVisible( false );
    --self.powerBar:SetVisible(false)

    if Settings.ShowName then
        self.text = Turbine.UI.Label()
        self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1, 1 ) )
        self.text:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
        self.text:SetFontStyle( Turbine.UI.FontStyle.Outline )
        self.text:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold19 )
        if self.Layout == 1 then
            self.text:SetSize(vitalWidth, vitalHeight - 20)
        elseif self.Layout == 2 then
            self.text:SetSize(vitalWidth, vitalHeight - 30)
        elseif self.Layout == 3 then
            self.text:SetSize(200, 30)
            self.text:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold22 )
        end

        self.text:SetZOrder( 100 )
        self.text:SetParent( self.moraleBar )

        if self.Layout == 3 then
            self.text:SetTextAlignment( Turbine.UI.ContentAlignment.TopLeft )
            self.text:SetPosition(3, 145)
            self.text:SetParent( self )
        elseif self.textSettings == 1 then
            self.text:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter )
        elseif self.textSettings == 2 then
            self.text:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft )
            self.text:SetPosition(10, 0)
        end

        self.text:SetMouseVisible(false)
        self.text:SetText(self.player:GetName())
    end

    if Settings.Aura then
        self.playerCallbacks["MoraleChanged"] = AddCallback(self.player, "MoraleChanged", function(sender, args) 
            self.moraleBar:SetCurrentValueImmediate(sender:GetMorale()) 
            self.aura:Adjust(sender:GetMorale() / sender:GetMaxMorale())
        end)
    else
        self.playerCallbacks["MoraleChanged"] = AddCallback(self.player, "MoraleChanged", function(sender, args) self.moraleBar:SetCurrentValueImmediate( sender:GetMorale() ) end)
    end
    self.playerCallbacks["MaxMoraleChanged"] = AddCallback(self.player, "MaxMoraleChanged", function(sender, args) self.moraleBar:SetMaxValue( sender:GetMaxMorale() ) end)
    self.playerCallbacks["BaseMaxMoraleChanged"] = AddCallback(self.player, "BaseMaxMoraleChanged", function(sender, args) self.moraleBar:SetMaxValue( sender:GetMaxMorale() ) end)
    self.playerCallbacks["TemporaryMoraleChanged"] = AddCallback(self.player, "TemporaryMoraleChanged", function(sender, args) self.moraleBar:SetTempValue( sender:GetTemporaryMorale()) end)
    --self.playerCallbacks["MaxTemporaryMoraleChanged"] = AddCallback(self.player, "MaxTemporaryMoraleChanged", function(sender, args) self.moraleBar:SetMaxTempValue(self.player:GetMaxTemporaryMorale()) end)
    
    if self.ClassType == Turbine.Gameplay.Class.Beorning then
        
        self.attrCallbacks["WrathChanged"] = AddCallback(self.ClassAttr, "WrathChanged", function(sender, args) self.powerBar:SetCurrentValue( sender:GetWrath() ) end)

        --[[
        self.ClassAttr.FormChanged = function()
            if self.ClassAttr:IsInBearForm() then
                self.vitalsFrame:SetBackColor(Turbine.UI.Color(0,0,1))
            else
                self.vitalsFrame:SetBackColor(Turbine.UI.Color(1, 0, 0))
            end
        end

        if self.ClassAttr:IsInBearForm() then
            self.vitalsFrame:SetBackColor(Turbine.UI.Color(0,0,1))
        else
            self.vitalsFrame:SetBackColor(Turbine.UI.Color(1, 0, 0))
        end
        --]]
    else
        self.playerCallbacks["PowerChanged"] = AddCallback(self.player, "PowerChanged", function(sender, args) self.powerBar:SetCurrentValue( sender:GetPower() ) end)
        self.playerCallbacks["MaxPowerChanged"] = AddCallback(self.player, "MaxPowerChanged", function(sender, args) self.powerBar:SetMaxValue( sender:GetMaxPower() ) end)
        self.playerCallbacks["BaseMaxPowerChanged"] = AddCallback(self.player, "BaseMaxPowerChanged", function(sender, args) self.powerBar:SetMaxValue( sender:GetMaxPower() ) end)
    end

    self.moraleBar:SetCurrentValue( self.player:GetMorale() )
    self.moraleBar:SetMaxValue( self.player:GetMaxMorale() )
    self.moraleBar:SetMaxValue( self.player:GetMaxMorale() )
    self.moraleBar:SetTempValue( self.player:GetTemporaryMorale())
    self.moraleBar:SetMaxTempValue( self.player:GetMaxTemporaryMorale())

    if self.ClassType == Turbine.Gameplay.Class.Beorning then
        self.powerBar:SetCurrentValue( self.ClassAttr:GetWrath() )
        self.powerBar:SetMaxValue( 100 )
        self.powerBar:SetMaxValue( 100 )
    else
        self.powerBar:SetCurrentValue( self.player:GetPower() )
        self.powerBar:SetMaxValue( self.player:GetMaxPower() )
        self.powerBar:SetMaxValue( self.player:GetMaxPower() )
    end

    self.Moving = false

    self.E.MouseDoubleClick = function(sender,args)
        if self.E.IsControlKeyDown() then
            self.MoveX = args.X
            self.MoveY = args.Y
            self.Moving = true
            self.vitalsFrame:SetBackColor(Turbine.UI.Color(0,1,0))
        end
    end
  
    self.E.MouseUp = function()
        self.Moving = false
        self.vitalsFrame:SetBackColor(nil)
    end
  
    self.E.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    if self.EffectPosition == 1 then

        self.buffBox = Turbine.UI.Control();
        self.buffBox:SetParent( self );
        --self.buffBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
        self.buffBox:SetPosition( 2, 2 );
        self.buffBox:SetSize( width, 160 );	
        self.buffBox:SetMouseVisible( false );	
        if self.Layout == 1 then
            self.buffBox:SetPosition(0, offset + 160 + 86)
        elseif self.Layout == 2 then
            self.buffBox:SetPosition(0, offset + 160 + 61)
        elseif self.Layout == 3 then
            self.buffBox:SetPosition(0, offset + 160 + 61)
        end
        --self.buffBox:SetBackColor(Turbine.UI.Color(0,0,0))

        self.IconRow = math.floor(width / self.IconSize)

    elseif self.EffectPosition == 2 then

        self.buffBox = Turbine.UI.Window()
        --self.buffBox:SetParent( self );
        self.buffBox:SetVisible(true)
        --self.buffBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
        self.buffBox:SetPosition( 1300, 2 );
        self.buffBox:SetSize( 400, 160 );	
        self.buffBox:SetMouseVisible( false );	

        self.IconRow = math.floor(400 / self.IconSize)
    end

    self.debuffBox = Turbine.UI.Control();
	self.debuffBox:SetParent( self );
	--self.debuffBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
    self.debuffBox:SetPosition( 2, 2 );
    self.debuffBox:SetSize( width, 160 );
    self.debuffBox:SetMouseVisible( false );	
    self.debuffBox:SetPosition(0, 0)
    --self.debuffBox:SetBackColor(Turbine.UI.Color(0,0,0))

    -- Effects
    self.effectList = self.player:GetEffects()

    for i = 1, self.effectList:GetCount(), 1 do
        local effect =  self.effectList:Get(i)

        if effect:IsDebuff() and self.DebuffTracking then
            self.DebuffBoxes[effect:GetID()] = EffectBox(self.debuffBox, effect, self.IconSize, self.UpdateCountdown)
        elseif not(effect:IsDebuff()) and self.BuffTracking then
            self.BuffBoxes[effect:GetID()] = EffectBox(self.buffBox, effect, self.IconSize, self.UpdateCountdown)
        end
    end 

    self.effectCallbacks["EffectRemoved"] = AddCallback(self.effectList, "EffectRemoved", function(sender, args)
        if args.Effect then 
            local ID = args.Effect:GetID()
            if self.BuffBoxes[ID] then 
                self.BuffBoxes[ID]:SetVisible(false) 
                self.BuffBoxes[ID]:SetParent(nil) 
                self.BuffBoxes[ID] = nil
                self.BuffResort = true
            end
            if self.DebuffBoxes[ID] then 
                self.DebuffBoxes[ID]:SetVisible(false)
                self.DebuffBoxes[ID]:SetParent(nil)  
                self.DebuffBoxes[ID] = nil
                self.DebuffResort = true
            end
        end
    end)

    self.effectCallbacks["EffectAdded"] = AddCallback(self.effectList, "EffectAdded", function(sender, args)
        local effect = sender:Get(args.Index)
        if effect:IsDebuff() and self.DebuffTracking then
            self.DebuffBoxes[effect:GetID()] = EffectBox(self.debuffBox, effect, self.IconSize, self.UpdateCountdown)
            self.DebuffResort = true
        elseif not(effect:IsDebuff()) and self.BuffTracking then
            self.BuffBoxes[effect:GetID()] = EffectBox(self.buffBox, effect, self.IconSize, self.UpdateCountdown)
            self.BuffResort = true
        end
    end)

    self.Update = function()
        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == self.oldGameTime then
            return(true)
        end
        local delta = currentGameTime - self.oldGameTime

        for key, value in pairs(self.DebuffBoxes) do
            value:UpdateText(delta)
            --[[
            if value:GetValue() < 0 then
                value:SetVisible(false) 
                value:SetParent(nil) 
                self.DebuffBoxes[key] = nil
                self.DebuffResort = true
            end
            --]]
        end

        for key, value in pairs(self.BuffBoxes) do
            value:UpdateText(delta)
            --[[
            if value:GetValue() < 0 then
                value:SetVisible(false) 
                value:SetParent(nil) 
                self.BuffBoxes[key] = nil
                self.BuffResort = true
            end
            --]]
        end

        if self.BuffResort or self.DebuffResort then self.ResortList() end

        self.oldGameTime = currentGameTime
    end

    self.ResortList = function()
        if self.BuffResort then
            if self.EffectPosition == 1 then
                local counter = 0
                for _,v in spairs(self.BuffBoxes, function(t,a,b) return t[b]:GetValue() < t[a]:GetValue() end) do
                    v:SetPosition((counter % self.IconRow) * self.IconSize, math.floor(counter / self.IconRow) * self.IconSize)
                    counter = counter + 1
                end
            elseif self.EffectPosition == 2 then
                local counter = 0
                for _,v in spairs(self.BuffBoxes, function(t,a,b) return t[b]:GetValue() < t[a]:GetValue() end) do
                    v:SetPosition(400 - self.IconSize - (counter % self.IconRow) * self.IconSize, math.floor(counter / self.IconRow) * self.IconSize) 
                    counter = counter + 1	
                end
            end
            self.BuffResort = false
        end

        if self.DebuffResort then
            local counter = 0
            for _,v in spairs(self.DebuffBoxes, function(t,a,b) return t[b]:GetValue() > t[a]:GetValue() end) do
                v:SetPosition((counter % self.IconRow) * self.IconSize, self.IconRowHeight - math.floor(counter / self.IconRow) * self.IconSize) 
                counter = counter + 1
            end
            self.DebuffResort = false
        end
    end

    self:ResortList()
    self:SetWantsUpdates(true)

    -- Resources
    self.RBar = nil

    local borderColour = Turbine.UI.Color(0, 0, 0) -- Turbine.UI.Color(0.125, 0.125, 0.125)

    if Settings.ColourMode == 3 then 
        borderColour = Turbine.UI.Color(0.08, 0.08, 0.08)
    end


    if self.ClassType == Turbine.Gameplay.Class.Champion then
        if self.Layout == 1 then
            self.RBar = ResourceBar(self, 252, 20, 5, self.ResourceText, 160, borderColour)
        elseif self.Layout == 2 then
            self.RBar = ResourceBar(self, 252, 8, 5, self.ResourceText, 160, borderColour)
        elseif self.Layout == 3 then
            self.RBar = ResourceBar(self, 252, 8, 5, self.ResourceText, 195, borderColour)
        end

        self.attrCallbacks["FervorChanged"] = AddCallback(self.ClassAttr, "FervorChanged", function(sender, args) self.RBar:ChangeResource(sender:GetFervor(), Turbine.UI.Color(153/255,0,0)) end)
        
        self.RBar:ChangeResource(self.ClassAttr:GetFervor(), Turbine.UI.Color(153/255,0,0))

    elseif self.ClassType == Turbine.Gameplay.Class.Hunter then
        if self.Layout == 1 then
            self.RBar = ResourceBar(self, 252, 20, 9, self.ResourceText, 160, borderColour)
        elseif self.Layout == 2 then
            self.RBar = ResourceBar(self, 252, 8, 9, self.ResourceText, 160, borderColour)
        elseif self.Layout == 3 then
            self.RBar = ResourceBar(self, 252, 8, 9, self.ResourceText, 195, borderColour)
        end

        self.attrCallbacks["FocusChanged"] = AddCallback(self.ClassAttr, "FocusChanged", function(sender, args) self.RBar:ChangeResource(sender:GetFocus(), Turbine.UI.Color(153/255,0,0)) end)

        self.RBar:ChangeResource(self.ClassAttr:GetFocus(), Turbine.UI.Color(153/255,0,0))

    elseif self.ClassType == Turbine.Gameplay.Class.RuneKeeper then
        if self.Layout == 1 then
            self.RBar = ResourceBar(self, 252, 20, 9, self.ResourceText, 160, borderColour)
        elseif self.Layout == 2 then
            self.RBar = ResourceBar(self, 252, 8, 9, self.ResourceText, 160, borderColour)
        elseif self.Layout == 3 then
            self.RBar = ResourceBar(self, 252, 8, 9, self.ResourceText, 195, borderColour)
        end

        self.attrCallbacks["AttunementChanged"] = AddCallback(self.ClassAttr, "AttunementChanged", function(sender, args) 
            local Attunement = sender:GetAttunement()
            if Attunement > 10 then
                self.RBar:ChangeResource(math.abs( Attunement - 10), Turbine.UI.Color(0,102/255,0))
            else
                self.RBar:ChangeResource(math.abs( Attunement - 10), Turbine.UI.Color(153/255,0,0))
            end
        end)
        
        local Attunement = self.ClassAttr:GetAttunement()
        if Attunement > 10 then
            self.RBar:ChangeResource(math.abs( Attunement - 10), Turbine.UI.Color(0,102/255,0))
        else
            self.RBar:ChangeResource(math.abs( Attunement - 10), Turbine.UI.Color(153/255,0,0))
        end
    end
end

function VitalWindow:RemoveCallbacks()
    for key, value in pairs(self.playerCallbacks) do
        RemoveCallback(self.player, key, value)
    end

    for key, value in pairs(self.effectCallbacks) do
        RemoveCallback(self.effectList, key, value)
    end

    for key, value in pairs(self.attrCallbacks) do
        RemoveCallback(self.ClassAttr, key, value)
    end
end